Attribute VB_Name = "ESRead"
Option Explicit

'***************************************************************************
'*                                                                         *
'*                            Read Functions                               *
'*                                                                         *
'***************************************************************************

Public Function ReadUnknown(ByVal FileHandle As Integer, ByRef NextRecordType As String, Optional ByVal SkipData As Boolean) As ES_Unknown

Dim temp As String * 4

With ReadUnknown
    .Name = NextRecordType
    Get FileHandle, , .Size
    Get FileHandle, , .UnknownHeader1
    Get FileHandle, , .Flag
    If SkipData = 0 Then
        .Data = Space$(.Size)
        Get FileHandle, , .Data
    Else
        Seek FileHandle, Seek(FileHandle) + .Size
    End If
    Get FileHandle, , NextRecordType
End With

End Function

Public Function ReadTES3(ByVal FileHandle As Integer, ByRef NextRecordType As String) As ES_TES3

Dim i As Long

With ReadTES3
    Get FileHandle, , .Size
    Get FileHandle, , .UnknownHeader1
    Get FileHandle, , .Flag
    Get FileHandle, , NextRecordType
    Do
        Select Case NextRecordType
        Case "HEDR"
            Get FileHandle, , .HEDRSize
            Get FileHandle, , .HEDRVersion
            Get FileHandle, , .HEDRFormatFlag
            Get FileHandle, , .HEDRAuthor
            Get FileHandle, , .HEDRDescript
            Get FileHandle, , .HEDRRecNum
            Get FileHandle, , NextRecordType
        Case "MAST"
            While NextRecordType = "MAST"
                ReDim Preserve .MASTArray(i)
                 Get FileHandle, , .MASTArray(i).MASTSize
                .MASTArray(i).MASTValue = Space$(.MASTArray(i).MASTSize - 1)
                Get FileHandle, , .MASTArray(i).MASTValue
                Seek FileHandle, Seek(FileHandle) + 1
                Seek FileHandle, Seek(FileHandle) + 4
                Get FileHandle, , .MASTArray(i).DATASize
                Get FileHandle, , .MASTArray(i).DATAValue
                .MASTArray(i).DATAValue = .MASTArray(i).DATAValue
                Get FileHandle, , NextRecordType
                i = i + 1
            Wend
        Case "GMDT"
            Get FileHandle, , .GMDTSize
            Get FileHandle, , .GMDTCurHealth
            Get FileHandle, , .GMDTMaxHealth
            Get FileHandle, , .GMDTUnknown1
            Get FileHandle, , .GMDTDay
            Get FileHandle, , .GMDTMonth
            Get FileHandle, , .GMDTYear
            Get FileHandle, , .GMDTCellName
            Get FileHandle, , .GMDTUnknown2
            Get FileHandle, , .GMDTCharacterName
            Get FileHandle, , NextRecordType
        Case "SCRD"
            Get FileHandle, , .SCRDSize
            For i = 0 To 19
                Get FileHandle, , .SCRDValue(i)
            Next
            Get FileHandle, , NextRecordType
        Case "SCRS"
            Get FileHandle, , .SCRSSize
            .SCRSValue = Space$(65536)
            Get FileHandle, , .SCRSValue
            Get FileHandle, , NextRecordType
        Case "DELE"
            'Record Deleted. Skip the data.
            Seek FileHandle, Seek(FileHandle) + 8
            Get FileHandle, , NextRecordType
        Case Else
            Exit Do
        End Select
    Loop
End With

End Function

Public Function ReadGLOB(ByVal FileHandle As Integer, ByRef NextRecordType As String) As ES_GLOB

With ReadGLOB
    Get FileHandle, , .Size
    Get FileHandle, , .UnknownHeader1
    Get FileHandle, , .Flag
    Get FileHandle, , NextRecordType
    Do
        Select Case NextRecordType
        Case "NAME"
            Get FileHandle, , .NAMESize
            .NAMEValue = Space$(.NAMESize - 1)
            Get FileHandle, , .NAMEValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "FNAM"
            Get FileHandle, , .FNAMSize
            Get FileHandle, , .FNAMValue
            Get FileHandle, , NextRecordType
        Case "FLTV"
            Get FileHandle, , .FLTVSize
            Get FileHandle, , .FLTVValue
            If .NAMEValue = "ratskilled" Then 'This one's weird...
                .FLTVValue = 0
            End If
            If .FNAMValue = "s" Then
                On Error Resume Next
                If .FLTVValue > 32767 Or .FLTVValue < -32767 Then
                    .FLTVValue = 0
                Else
                    .FLTVValue = Round(.FLTVValue, 0)
                End If
            ElseIf .FNAMValue = "l" Then
                .FLTVValue = Round(.FLTVValue, 0)
            End If
            Get FileHandle, , NextRecordType
        Case "DELE"
            'Record Deleted. Skip the data.
            Seek FileHandle, Seek(FileHandle) + 8
            Get FileHandle, , NextRecordType
        Case Else
            Exit Do
        End Select
    Loop
End With

End Function

Public Function ReadGMST(ByVal FileHandle As Integer, ByRef NextRecordType As String) As ES_GMST

With ReadGMST
    Get FileHandle, , .Size
    Get FileHandle, , .UnknownHeader1
    Get FileHandle, , .Flag
    Get FileHandle, , NextRecordType
    Do
        Select Case NextRecordType
        Case "STRV"
            Get FileHandle, , .STRVSize
            .STRVValue = Space$(.STRVSize)
            Get FileHandle, , .STRVValue
            Get FileHandle, , NextRecordType
        Case "INTV"
            Get FileHandle, , .INTVSize
            Get FileHandle, , .INTVValue
            Get FileHandle, , NextRecordType
        Case "FLTV"
            Get FileHandle, , .FLTVSize
            Get FileHandle, , .FLTVValue
            .FLTVValue = Round(.FLTVValue, 4)
            Get FileHandle, , NextRecordType
        Case "NAME"
            Get FileHandle, , .NAMESize
            .NAMEValue = Space$(.NAMESize)
            Get FileHandle, , .NAMEValue
            Get FileHandle, , NextRecordType
        Case "DELE"
            'Record Deleted. Skip the data.
            Seek FileHandle, Seek(FileHandle) + 8
            Get FileHandle, , NextRecordType
        Case Else
            Exit Do
        End Select
    Loop
End With


End Function

Public Function ReadCLAS(ByVal FileHandle As Integer, ByRef NextRecordType As String) As ES_CLAS

With ReadCLAS
    Get FileHandle, , .Size
    Get FileHandle, , .UnknownHeader1
    Get FileHandle, , .Flag
    Get FileHandle, , NextRecordType
    Do
        Select Case NextRecordType
        Case "NAME"
            Get FileHandle, , .NAMESize
            .NAMEValue = Space$(.NAMESize - 1)
            Get FileHandle, , .NAMEValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "FNAM"
            Get FileHandle, , .FNAMSize
            .FNAMValue = Space$(.FNAMSize - 1)
            Get FileHandle, , .FNAMValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "CLDT"
            Get FileHandle, , .CLDTSize
            Get FileHandle, , .CLDTAttributeID1
            Get FileHandle, , .CLDTAttributeID2
            Get FileHandle, , .CLDTSpecialization
            Get FileHandle, , .CLDTMinorID1
            Get FileHandle, , .CLDTMajorID1
            Get FileHandle, , .CLDTMinorID2
            Get FileHandle, , .CLDTMajorID2
            Get FileHandle, , .CLDTMinorID3
            Get FileHandle, , .CLDTMajorID3
            Get FileHandle, , .CLDTMinorID4
            Get FileHandle, , .CLDTMajorID4
            Get FileHandle, , .CLDTMinorID5
            Get FileHandle, , .CLDTMajorID5
            Get FileHandle, , .CLDTPlayable
            Seek FileHandle, Seek(FileHandle) + 1
            Seek FileHandle, Seek(FileHandle) + 1
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , .CLDTAutoCalcFlags
            Get FileHandle, , NextRecordType
        Case "DESC"
            Get FileHandle, , .DESCSize
            .DESCValue = Space$(.DESCSize)
            Get FileHandle, , .DESCValue
            Get FileHandle, , NextRecordType
        Case "DELE"
            'Record Deleted. Skip the data.
            Seek FileHandle, Seek(FileHandle) + 8
            Get FileHandle, , NextRecordType
        Case Else
            Exit Do
        End Select
    Loop
End With

End Function

Public Function ReadFACT(ByVal FileHandle As Integer, ByRef NextRecordType As String) As ES_FACT

Dim i As Long

With ReadFACT
    Get FileHandle, , .Size
    Get FileHandle, , .UnknownHeader1
    Get FileHandle, , .Flag
    Get FileHandle, , NextRecordType
    Do
        Select Case NextRecordType
        Case "NAME"
            Get FileHandle, , .NAMESize
            .NAMEValue = Space$(.NAMESize - 1)
            Get FileHandle, , .NAMEValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "FNAM"
            Get FileHandle, , .FNAMSize
            .FNAMValue = Space$(.FNAMSize - 1)
            Get FileHandle, , .FNAMValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "RNAM"
            i = 0
            While NextRecordType = "RNAM"
                Get FileHandle, , .RankArray(i).RNAMSize
                Get FileHandle, , .RankArray(i).RNAMValue
                Get FileHandle, , NextRecordType
                i = i + 1
            Wend
        Case "FADT"
            i = 0
            Get FileHandle, , .FADTSize
            Get FileHandle, , .FADTAttributeID1
            Get FileHandle, , .FADTAttributeID2
            For i = 0 To 9
                Get FileHandle, , .FADTRankData(i).Attribute1
                Get FileHandle, , .FADTRankData(i).Attribute2
                Get FileHandle, , .FADTRankData(i).FirstSkill
                Get FileHandle, , .FADTRankData(i).SecondSkill
                Get FileHandle, , .FADTRankData(i).FactionReputation
            Next
            Get FileHandle, , .FADTSkillID1
            Get FileHandle, , .FADTSkillID2
            Get FileHandle, , .FADTSkillID3
            Get FileHandle, , .FADTSkillID4
            Get FileHandle, , .FADTSkillID5
            Get FileHandle, , .FADTSkillID6
            Get FileHandle, , .FADTUnknown1
            Get FileHandle, , .FADTHiddenFlag
            Get FileHandle, , NextRecordType
        Case "ANAM"
            i = 0
            While NextRecordType = "ANAM"
                ReDim Preserve .ReactionsArray(i)
                Get FileHandle, , .ReactionsArray(i).ANAMSize
                .ReactionsArray(i).ANAMValue = Space$(.ReactionsArray(i).ANAMSize)
                Get FileHandle, , .ReactionsArray(i).ANAMValue
                Seek FileHandle, Seek(FileHandle) + 4
                Get FileHandle, , .ReactionsArray(i).INTVSize
                Get FileHandle, , .ReactionsArray(i).INTVValue
                Get FileHandle, , NextRecordType
                i = i + 1
            Wend
        Case "DELE"
            'Record Deleted. Skip the data.
            Seek FileHandle, Seek(FileHandle) + 8
            Get FileHandle, , NextRecordType
        Case Else
            Exit Do
        End Select
    Loop
End With

End Function

Public Function ReadRACE(ByVal FileHandle As Integer, ByRef NextRecordType As String) As ES_RACE

Dim i As Long

With ReadRACE
    Get FileHandle, , .Size
    Get FileHandle, , .UnknownHeader1
    Get FileHandle, , .Flag
    Get FileHandle, , NextRecordType
    Do
        Select Case NextRecordType
        Case "NAME"
            Get FileHandle, , .NAMESize
            .NAMEValue = Space$(.NAMESize - 1)
            Get FileHandle, , .NAMEValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "FNAM"
            Get FileHandle, , .FNAMSize
            .FNAMValue = Space$(.FNAMSize - 1)
            Get FileHandle, , .FNAMValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "RADT"
            i = 0
            Get FileHandle, , .RADTSize
            Get FileHandle, , .RADTSkillID1
            Get FileHandle, , .RADTSkillBonus1
            Get FileHandle, , .RADTSkillID2
            Get FileHandle, , .RADTSkillBonus2
            Get FileHandle, , .RADTSkillID3
            Get FileHandle, , .RADTSkillBonus3
            Get FileHandle, , .RADTSkillID4
            Get FileHandle, , .RADTSkillBonus4
            Get FileHandle, , .RADTSkillID5
            Get FileHandle, , .RADTSkillBonus5
            Get FileHandle, , .RADTSkillID6
            Get FileHandle, , .RADTSkillBonus6
            Get FileHandle, , .RADTSkillID7
            Get FileHandle, , .RADTSkillBonus7
            Get FileHandle, , .RADTStrengthMale
            Get FileHandle, , .RADTStrengthFemale
            Get FileHandle, , .RADTIntelligenceMale
            Get FileHandle, , .RADTIntelligenceFemale
            Get FileHandle, , .RADTWillpowerMale
            Get FileHandle, , .RADTWillpowerFemale
            Get FileHandle, , .RADTAgilityMale
            Get FileHandle, , .RADTAgilityFemale
            Get FileHandle, , .RADTSpeedMale
            Get FileHandle, , .RADTSpeedFemale
            Get FileHandle, , .RADTEnduranceMale
            Get FileHandle, , .RADTEnduranceFemale
            Get FileHandle, , .RADTPersonalityMale
            Get FileHandle, , .RADTPersonalityFemale
            Get FileHandle, , .RADTLuckMale
            Get FileHandle, , .RADTLuckFemale
            Get FileHandle, , .RADTHeightMale
            Get FileHandle, , .RADTHeightFemale
            Get FileHandle, , .RADTWeightMale
            Get FileHandle, , .RADTWeightFemale
            Get FileHandle, , .RADTFlags
            Get FileHandle, , NextRecordType
        Case "DESC"
            Get FileHandle, , .DESCSize
            .DESCValue = Space$(.DESCSize)
            Get FileHandle, , .DESCValue
            Get FileHandle, , NextRecordType
        Case "NPCS"
            While NextRecordType = "NPCS"
                ReDim Preserve .NPCS(i)
                Get FileHandle, , .NPCS(i).NPCSSize
                Get FileHandle, , .NPCS(i).NPCSValue
                Get FileHandle, , NextRecordType
                i = i + 1
            Wend
        Case "DELE"
            'Record Deleted. Skip the data.
            Seek FileHandle, Seek(FileHandle) + 8
            Get FileHandle, , NextRecordType
        Case Else
            Exit Do
        End Select
    Loop
End With

End Function

Public Function ReadSOUN(ByVal FileHandle As Integer, ByRef NextRecordType As String) As ES_SOUN

With ReadSOUN
    Get FileHandle, , .Size
    Get FileHandle, , .UnknownHeader1
    Get FileHandle, , .Flag
    Get FileHandle, , NextRecordType
    Do
        Select Case NextRecordType
        Case "NAME"
            Get FileHandle, , .NAMESize
            .NAMEValue = Space$(.NAMESize - 1)
            Get FileHandle, , .NAMEValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "FNAM"
            Get FileHandle, , .FNAMSize
            .FNAMValue = Space$(.FNAMSize - 1)
            Get FileHandle, , .FNAMValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "DATA"
            Get FileHandle, , .DATASize
            Get FileHandle, , .DATAVolume
            Get FileHandle, , .DATAMinRange
            Get FileHandle, , .DATAMaxRange
            Get FileHandle, , NextRecordType
        Case "DELE"
            'Record Deleted. Skip the data.
            Seek FileHandle, Seek(FileHandle) + 8
            Get FileHandle, , NextRecordType
        Case Else
            Exit Do
        End Select
    Loop
End With

End Function

Public Function ReadSKIL(ByVal FileHandle As Integer, ByRef NextRecordType As String) As ES_SKIL

With ReadSKIL
    Get FileHandle, , .Size
    Get FileHandle, , .UnknownHeader1
    Get FileHandle, , .Flag
    Get FileHandle, , NextRecordType
    Do
        Select Case NextRecordType
        Case "INDX"
            Get FileHandle, , .INDXSize
            Get FileHandle, , .INDXValue
            Get FileHandle, , NextRecordType
        Case "SKDT"
            Get FileHandle, , .SKDTSize
            Get FileHandle, , .SKDTAttibute
            Get FileHandle, , .SKDTSpecialization
            Get FileHandle, , .SKDTUseValue1
            Get FileHandle, , .SKDTUseValue2
            Get FileHandle, , .SKDTUseValue3
            Get FileHandle, , .SKDTUseValue4
            Get FileHandle, , NextRecordType
        Case "DESC"
            Get FileHandle, , .DESCSize
            .DESCValue = Space$(.DESCSize)
            Get FileHandle, , .DESCValue
            Get FileHandle, , NextRecordType
        Case "DELE"
            'Record Deleted. Skip the data.
            Seek FileHandle, Seek(FileHandle) + 8
            Get FileHandle, , NextRecordType
        Case Else
            Exit Do
        End Select
    Loop
End With

End Function

Public Function ReadMGEF(ByVal FileHandle As Integer, ByRef NextRecordType As String) As ES_MGEF

With ReadMGEF
    Get FileHandle, , .Size
    Get FileHandle, , .UnknownHeader1
    Get FileHandle, , .Flag
    Get FileHandle, , NextRecordType
    Do
        Select Case NextRecordType
        Case "INDX"
            Get FileHandle, , .INDXSize
            Get FileHandle, , .INDXValue
            Get FileHandle, , NextRecordType
        Case "MEDT"
            Get FileHandle, , .MEDTSize
            Get FileHandle, , .MEDTSchool
            Get FileHandle, , .MEDTBaseCost
            Get FileHandle, , .MEDTFlags
            Get FileHandle, , .MEDTRed
            Get FileHandle, , .MEDTGreen
            Get FileHandle, , .MEDTBlue
            Get FileHandle, , .MEDTSpeedX
            Get FileHandle, , .MEDTSizeX
            Get FileHandle, , .MEDTSizeCap
            Get FileHandle, , NextRecordType
        Case "DESC"
            Get FileHandle, , .DESCSize
            .DESCValue = Space$(.DESCSize)
            Get FileHandle, , .DESCValue
            Get FileHandle, , NextRecordType
        Case "ITEX"
            Get FileHandle, , .ITEXSize
            .ITEXValue = Space$(.ITEXSize - 1)
            Get FileHandle, , .ITEXValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "PTEX"
            Get FileHandle, , .PTEXSize
            .PTEXValue = Space$(.PTEXSize - 1)
            Get FileHandle, , .PTEXValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "BSND"
            Get FileHandle, , .BSNDSize
            .BSNDValue = Space$(.BSNDSize - 1)
            Get FileHandle, , .BSNDValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "CSND"
            Get FileHandle, , .CSNDSize
            .CSNDValue = Space$(.CSNDSize - 1)
            Get FileHandle, , .CSNDValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
         Case "HSND"
            Get FileHandle, , .HSNDSize
            .HSNDValue = Space$(.HSNDSize - 1)
            Get FileHandle, , .HSNDValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "ASND"
            Get FileHandle, , .ASNDSize
            .ASNDValue = Space$(.ASNDSize - 1)
            Get FileHandle, , .ASNDValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "BVFX"
            Get FileHandle, , .BVFXSize
            .BVFXValue = Space$(.BVFXSize - 1)
            Get FileHandle, , .BVFXValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "CVFX"
            Get FileHandle, , .CVFXSize
            .CVFXValue = Space$(.CVFXSize - 1)
            Get FileHandle, , .CVFXValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "HVFX"
            Get FileHandle, , .HVFXSize
            .HVFXValue = Space$(.HVFXSize - 1)
            Get FileHandle, , .HVFXValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "AVFX"
            Get FileHandle, , .AVFXSize
            .AVFXValue = Space$(.AVFXSize - 1)
            Get FileHandle, , .AVFXValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "DELE"
            'Record Deleted. Skip the data.
            Seek FileHandle, Seek(FileHandle) + 8
            Get FileHandle, , NextRecordType
        Case Else
            Exit Do
        End Select
    Loop
End With

End Function

Public Function ReadSCPT(ByVal FileHandle As Integer, ByRef NextRecordType As String) As ES_SCPT

Dim SCVR_buffer() As String
Dim i As Long

With ReadSCPT
    Get FileHandle, , .Size
    Get FileHandle, , .UnknownHeader1
    Get FileHandle, , .Flag
    Get FileHandle, , NextRecordType
    Do
        Select Case NextRecordType
        Case "SCHD"
            Get FileHandle, , .SCHDSize
            Get FileHandle, , .SCHDScriptName
            Get FileHandle, , .SCHDNumShorts
            Get FileHandle, , .SCHDNumLongs
            Get FileHandle, , .SCHDNumFloats
            Get FileHandle, , .SCHDCodeSize
            Get FileHandle, , .SCHDLocalSize
            Get FileHandle, , NextRecordType
        Case "SCVR"
            i = 0
            Get FileHandle, , .SCVRSize
            ReDim SCVR_buffer(.SCHDNumShorts + .SCHDNumLongs + .SCHDNumFloats)
            SCVR_buffer(0) = Space$(.SCVRSize - 1)
            Get FileHandle, , SCVR_buffer(0)
            SCVR_buffer = Split(SCVR_buffer(0), Chr$(0))
            While i < .SCHDNumShorts
                ReDim Preserve .SCVRShorts(i)
                .SCVRShorts(i) = SCVR_buffer(i)
                i = i + 1
            Wend
            While i < .SCHDNumLongs + .SCHDNumShorts
                ReDim Preserve .SCVRLongs(i - .SCHDNumShorts)
                .SCVRLongs(i - .SCHDNumShorts) = SCVR_buffer(i)
                i = i + 1
            Wend
            While i < .SCHDNumFloats + .SCHDNumLongs + .SCHDNumShorts
                ReDim Preserve .SCVRFloats(i - (.SCHDNumShorts + .SCHDNumLongs))
                .SCVRFloats(i - (.SCHDNumShorts + .SCHDNumLongs)) = SCVR_buffer(i)
                i = i + 1
            Wend
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "SCDT"
            Get FileHandle, , .SCDTSize
            .SCDTValue = Space$(.SCDTSize)
            Get FileHandle, , .SCDTValue
            Get FileHandle, , NextRecordType
        Case "SCTX"
            Get FileHandle, , .SCTXSize
            .SCTXValue = Space$(.SCTXSize)
            Get FileHandle, , .SCTXValue
            Get FileHandle, , NextRecordType
        'savagame specific data
        Case "RNAM"
            Get FileHandle, , .RNAMSize
            .RNAMValue = Space$(.RNAMSize)
            Get FileHandle, , .RNAMValue
            Get FileHandle, , NextRecordType
        Case "SLSD"
            Get FileHandle, , .SLSDSize
            ReDim .SLSDValue((.SLSDSize / 2) - 1)
            For i = LBound(.SLSDValue) To UBound(.SLSDValue)
                Get FileHandle, , .SLSDValue(i)
            Next
            Get FileHandle, , NextRecordType
        Case "SLCS"
            Get FileHandle, , .SLCSSize
            .SLCSValue = Space$(.SLCSSize)
            Get FileHandle, , .SLCSValue
            Get FileHandle, , NextRecordType
        Case "SLFD"
            Get FileHandle, , .SLFDSize
            ReDim .SLFDValue((.SLFDSize / 4) - 1)
            For i = LBound(.SLFDValue) To UBound(.SLFDValue)
                Get FileHandle, , .SLFDValue(i)
            Next
            Get FileHandle, , NextRecordType
        Case Else
            Exit Do
        End Select
    Loop
End With

End Function

Public Function ReadREGN(ByVal FileHandle As Integer, ByRef NextRecordType As String) As ES_REGN

Dim i As Long

With ReadREGN
    Get FileHandle, , .Size
    Get FileHandle, , .UnknownHeader1
    Get FileHandle, , .Flag
    Get FileHandle, , NextRecordType
    Do
        Select Case NextRecordType
        Case "NAME"
            Get FileHandle, , .NAMESize
            .NAMEValue = Space$(.NAMESize - 1)
            Get FileHandle, , .NAMEValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "FNAM"
            Get FileHandle, , .FNAMSize
            .FNAMValue = Space$(.FNAMSize - 1)
            Get FileHandle, , .FNAMValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "WEAT"
            i = 0
            Get FileHandle, , .WEATSize
            ReDim .WEATChances(.WEATSize - 1)
            For i = LBound(.WEATChances) To UBound(.WEATChances)
                Get FileHandle, , .WEATChances(i)
            Next
            Get FileHandle, , NextRecordType
        Case "BNAM"
            Get FileHandle, , .BNAMSize
            .BNAMValue = Space$(.BNAMSize - 1)
            Get FileHandle, , .BNAMValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "CNAM"
            Get FileHandle, , .CNAMSize
            Get FileHandle, , .CNAMRed
            Get FileHandle, , .CNAMGreen
            Get FileHandle, , .CNAMBlue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "SNAM"
            i = 0
            While NextRecordType = "SNAM"
                ReDim Preserve .SNAM(i)
                With .SNAM(i)
                    Get FileHandle, , .SNAMSize
                    Get FileHandle, , .SNAMSound
                    Get FileHandle, , .SNAMChance
                    Get FileHandle, , NextRecordType
                End With
                i = i + 1
            Wend
        Case "WNAM"
            Get FileHandle, , .WNAMSize
            Get FileHandle, , .WNAMValue
            Get FileHandle, , NextRecordType
        Case "DELE"
            'Record Deleted. Skip the data.
            Seek FileHandle, Seek(FileHandle) + 8
            Get FileHandle, , NextRecordType
        Case Else
            Exit Do
        End Select
    Loop
End With

End Function

Public Function ReadBSGN(ByVal FileHandle As Integer, ByRef NextRecordType As String) As ES_BSGN

Dim i As Long

With ReadBSGN
    Get FileHandle, , .Size
    Get FileHandle, , .UnknownHeader1
    Get FileHandle, , .Flag
    Get FileHandle, , NextRecordType
    Do
        Select Case NextRecordType
        Case "NAME"
             Get FileHandle, , .NAMESize
            .NAMEValue = Space$(.NAMESize - 1)
            Get FileHandle, , .NAMEValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "FNAM"
            Get FileHandle, , .FNAMSize
            .FNAMValue = Space$(.FNAMSize - 1)
            Get FileHandle, , .FNAMValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "TNAM"
            Get FileHandle, , .TNAMSize
            .TNAMValue = Space$(.TNAMSize - 1)
            Get FileHandle, , .TNAMValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "DESC"
            Get FileHandle, , .DESCSize
            .DESCValue = Space$(.DESCSize)
            Get FileHandle, , .DESCValue
            Get FileHandle, , NextRecordType
        Case "NPCS"
            While NextRecordType = "NPCS"
                ReDim Preserve .NPCS(i)
                Get FileHandle, , .NPCS(i).NPCSSize
                Get FileHandle, , .NPCS(i).NPCSValue
                Get FileHandle, , NextRecordType
                i = i + 1
            Wend
        Case "DELE"
            'Record Deleted. Skip the data.
            Seek FileHandle, Seek(FileHandle) + 8
            Get FileHandle, , NextRecordType
        Case Else
            Exit Do
        End Select
    Loop
End With

End Function

Public Function ReadLTEX(ByVal FileHandle As Integer, ByRef NextRecordType As String) As ES_LTEX

With ReadLTEX
    Get FileHandle, , .Size
    Get FileHandle, , .UnknownHeader1
    Get FileHandle, , .Flag
    Get FileHandle, , NextRecordType
    Do
        Select Case NextRecordType
        Case "NAME"
            Get FileHandle, , .NAMESize
            .NAMEValue = Space$(.NAMESize - 1)
            Get FileHandle, , .NAMEValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "INTV"
            Get FileHandle, , .INTVSize
            Get FileHandle, , .INTVValue
            Get FileHandle, , NextRecordType
        Case "DATA"
            Get FileHandle, , .DATASize
            .DATAValue = Space$(.DATASize - 1)
            Get FileHandle, , .DATAValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "DELE"
            'Record Deleted. Skip the data.
            Seek FileHandle, Seek(FileHandle) + 8
            Get FileHandle, , NextRecordType
        Case Else
            Exit Do
        End Select
    Loop
End With

End Function

Public Function ReadSTAT(ByVal FileHandle As Integer, ByRef NextRecordType As String) As ES_STAT

Dim buffer As Byte
Dim i As Long

With ReadSTAT
    Get FileHandle, , .Size
    Get FileHandle, , .UnknownHeader1
    Get FileHandle, , .Flag
    Get FileHandle, , NextRecordType
    Do
        Select Case NextRecordType
        Case "NAME"
            Get FileHandle, , .NAMESize
            .NAMEValue = Space$(.NAMESize - 1)
            Get FileHandle, , .NAMEValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "MODL"
            Get FileHandle, , .MODLSize
            .MODLValue = Space$(.MODLSize - 1)
            Get FileHandle, , .MODLValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "DELE"
            'Record Deleted. Skip the data.
            Seek FileHandle, Seek(FileHandle) + 8
            Get FileHandle, , NextRecordType
        Case Else
            Exit Do
        End Select
    Loop
End With

End Function

Public Function ReadDOOR(ByVal FileHandle As Integer, ByRef NextRecordType As String) As ES_DOOR

With ReadDOOR
    Get FileHandle, , .Size
    Get FileHandle, , .UnknownHeader1
    Get FileHandle, , .Flag
    Get FileHandle, , NextRecordType
    Do
        Select Case NextRecordType
        Case "NAME"
            Get FileHandle, , .NAMESize
            .NAMEValue = Space$(.NAMESize - 1)
            Get FileHandle, , .NAMEValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "MODL"
            Get FileHandle, , .MODLSize
            .MODLValue = Space$(.MODLSize - 1)
            Get FileHandle, , .MODLValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "FNAM"
            Get FileHandle, , .FNAMSize
            .FNAMValue = Space$(.FNAMSize - 1)
            Get FileHandle, , .FNAMValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "SCRI"
            Get FileHandle, , .SCRISize
            .SCRIValue = Space$(.SCRISize - 1)
            Get FileHandle, , .SCRIValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "SNAM"
            Get FileHandle, , .SNAMSize
            .SNAMValue = Space$(.SNAMSize - 1)
            Get FileHandle, , .SNAMValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "ANAM"
            Get FileHandle, , .ANAMSize
            .ANAMValue = Space$(.ANAMSize - 1)
            Get FileHandle, , .ANAMValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "DELE"
            'Record Deleted. Skip the data.
            Seek FileHandle, Seek(FileHandle) + 8
            Get FileHandle, , NextRecordType
        Case Else
            Exit Do
        End Select
    Loop
End With

End Function

Public Function ReadMISC(ByVal FileHandle As Integer, ByRef NextRecordType As String) As ES_MISC

With ReadMISC
    Get FileHandle, , .Size
    Get FileHandle, , .UnknownHeader1
    Get FileHandle, , .Flag
    Get FileHandle, , NextRecordType
    Do
        Select Case NextRecordType
        Case "NAME"
            Get FileHandle, , .NAMESize
            .NAMEValue = Space$(.NAMESize - 1)
            Get FileHandle, , .NAMEValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "MODL"
            Get FileHandle, , .MODLSize
            .MODLValue = Space$(.MODLSize - 1)
            Get FileHandle, , .MODLValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "FNAM"
            Get FileHandle, , .FNAMSize
            .FNAMValue = Space$(.FNAMSize - 1)
            Get FileHandle, , .FNAMValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "SCRI"
            Get FileHandle, , .SCRISize
            .SCRIValue = Space$(.SCRISize - 1)
            Get FileHandle, , .SCRIValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "ITEX"
            Get FileHandle, , .ITEXSize
            .ITEXValue = Space$(.ITEXSize - 1)
            Get FileHandle, , .ITEXValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "MCDT"
            Get FileHandle, , .MCDTSize
            Get FileHandle, , .MCDTWeight
            Get FileHandle, , .MCDTValue
            Get FileHandle, , .MCDTUnknown1
            Get FileHandle, , NextRecordType
        Case "DELE"
            'Record Deleted. Skip the data.
            Seek FileHandle, Seek(FileHandle) + 8
            Get FileHandle, , NextRecordType
        Case Else
            Exit Do
        End Select
    Loop
End With

End Function

Public Function ReadWEAP(ByVal FileHandle As Integer, ByRef NextRecordType As String) As ES_WEAP

Dim buffer As Byte
Dim i As Long

With ReadWEAP
    Get FileHandle, , .Size
    Get FileHandle, , .UnknownHeader1
    Get FileHandle, , .Flag
    Get FileHandle, , NextRecordType
    Do
        Select Case NextRecordType
        Case "NAME"
            Get FileHandle, , .NAMESize
            .NAMEValue = Space$(.NAMESize - 1)
            Get FileHandle, , .NAMEValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "MODL"
            Get FileHandle, , .MODLSize
            .MODLValue = Space$(.MODLSize - 1)
            Get FileHandle, , .MODLValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "FNAM"
            Get FileHandle, , .FNAMSize
            .FNAMValue = Space$(.FNAMSize - 1)
            Get FileHandle, , .FNAMValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "SCRI"
            Get FileHandle, , .SCRISize
            .SCRIValue = Space$(.SCRISize - 1)
            Get FileHandle, , .SCRIValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "ITEX"
            Get FileHandle, , .ITEXSize
            .ITEXValue = Space$(.ITEXSize - 1)
            Get FileHandle, , .ITEXValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "ENAM"
            Get FileHandle, , .ENAMSize
            .ENAMValue = Space$(.ENAMSize - 1)
            Get FileHandle, , .ENAMValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "WPDT"
            Get FileHandle, , .WPDTSize
            Get FileHandle, , .WPDTWeight
            Get FileHandle, , .WPDTValue
            Get FileHandle, , .WPDTType
            Get FileHandle, , .WPDTHealth
            Get FileHandle, , .WPDTSpeed
            Get FileHandle, , .WPDTReach
            Get FileHandle, , .WPDTEnchPoints
            Get FileHandle, , .WPDTChopMin
            Get FileHandle, , .WPDTChopMax
            Get FileHandle, , .WPDTSlashMin
            Get FileHandle, , .WPDTSlashMax
            Get FileHandle, , .WPDTThrustMin
            Get FileHandle, , .WPDTThrustMax
            Get FileHandle, , .WPDTFlags
            Seek FileHandle, Seek(FileHandle) + 1
            Seek FileHandle, Seek(FileHandle) + 1
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "DELE"
            'Record Deleted. Skip the data.
            Seek FileHandle, Seek(FileHandle) + 8
            Get FileHandle, , NextRecordType
        Case Else
            Exit Do
        End Select
    Loop
End With

End Function

Public Function ReadCONT(ByVal FileHandle As Integer, ByRef NextRecordType As String) As ES_CONT

Dim i As Long

With ReadCONT
    Get FileHandle, , .Size
    Get FileHandle, , .UnknownHeader1
    Get FileHandle, , .Flag
    Get FileHandle, , NextRecordType
    Do
        Select Case NextRecordType
        Case "NAME"
            Get FileHandle, , .NAMESize
            .NAMEValue = Space$(.NAMESize - 1)
            Get FileHandle, , .NAMEValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "MODL"
            Get FileHandle, , .MODLSize
            .MODLValue = Space$(.MODLSize - 1)
            Get FileHandle, , .MODLValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "INDX"
            Get FileHandle, , .INDXSize
            Get FileHandle, , .INDXValue
            Get FileHandle, , NextRecordType
        Case "FNAM"
            Get FileHandle, , .FNAMSize
            .FNAMValue = Space$(.FNAMSize - 1)
            Get FileHandle, , .FNAMValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "SCRI"
            Get FileHandle, , .SCRISize
            .SCRIValue = Space$(.SCRISize - 1)
            Get FileHandle, , .SCRIValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "CNDT"
            Get FileHandle, , .CNDTSize
            Get FileHandle, , .CNDTWeight
            Get FileHandle, , NextRecordType
        Case "FLAG"
            Get FileHandle, , .FLAGSize
            Get FileHandle, , .FLAGFlag
            Seek FileHandle, Seek(FileHandle) + 1
            Seek FileHandle, Seek(FileHandle) + 1
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "NPCO"
            While NextRecordType = "NPCO"
                ReDim Preserve .NPCO(i)
                With .NPCO(i)
                    Get FileHandle, , .NPCOSize
                    Get FileHandle, , .NPCOCount
                    Get FileHandle, , .NPCOItem
                    Get FileHandle, , NextRecordType
                End With
                i = i + 1
            Wend
        Case "DELE"
            'Record Deleted. Skip the data.
            Seek FileHandle, Seek(FileHandle) + 8
            Get FileHandle, , NextRecordType
        Case Else
            Exit Do
        End Select
    Loop
End With

End Function

Public Function ReadSPEL(ByVal FileHandle As Integer, ByRef NextRecordType As String) As ES_SPEL

Dim i As Long

With ReadSPEL
    Get FileHandle, , .Size
    Get FileHandle, , .UnknownHeader1
    Get FileHandle, , .Flag
    Get FileHandle, , NextRecordType
    Do
        Select Case NextRecordType
        Case "NAME"
            Get FileHandle, , .NAMESize
            .NAMEValue = Space$(.NAMESize - 1)
            Get FileHandle, , .NAMEValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "FNAM"
            Get FileHandle, , .FNAMSize
            .FNAMValue = Space$(.FNAMSize - 1)
            Get FileHandle, , .FNAMValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "SPDT"
            Get FileHandle, , .SPDTSize
            Get FileHandle, , .SPDTType
            Get FileHandle, , .SPDTCost
            Get FileHandle, , .SPDTFlags
            Seek FileHandle, Seek(FileHandle) + 1
            Seek FileHandle, Seek(FileHandle) + 1
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "ENAM"
            While NextRecordType = "ENAM"
                With .ENAM(i)
                    Get FileHandle, , .ENAMSize
                    Get FileHandle, , .ENAMEffectID
                    Get FileHandle, , .ENAMSkillID
                    Get FileHandle, , .ENAMAttributeID
                    Get FileHandle, , .ENAMRange
                    Seek FileHandle, Seek(FileHandle) + 1
                    Seek FileHandle, Seek(FileHandle) + 1
                    Seek FileHandle, Seek(FileHandle) + 1
                    Get FileHandle, , .ENAMArea
                    Get FileHandle, , .ENAMDuration
                    Get FileHandle, , .ENAMMagnitudeMin
                    Get FileHandle, , .ENAMMagnitudeMax
                    Get FileHandle, , NextRecordType
                End With
                i = i + 1
            Wend
        Case "DELE"
            'Record Deleted. Skip the data.
            Seek FileHandle, Seek(FileHandle) + 8
            Get FileHandle, , NextRecordType
        Case Else
            Exit Do
        End Select
    Loop
End With

End Function

Public Function ReadENCH(ByVal FileHandle As Integer, ByRef NextRecordType As String) As ES_ENCH

Dim i As Long

With ReadENCH
    Get FileHandle, , .Size
    Get FileHandle, , .UnknownHeader1
    Get FileHandle, , .Flag
    Get FileHandle, , NextRecordType
    Do
        Select Case NextRecordType
        Case "NAME"
            Get FileHandle, , .NAMESize
            .NAMEValue = Space$(.NAMESize - 1)
            Get FileHandle, , .NAMEValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "ENDT"
            Get FileHandle, , .ENDTSize
            Get FileHandle, , .ENDTType
            Get FileHandle, , .ENDTCost
            Get FileHandle, , .ENDTCharge
            Get FileHandle, , .ENDTAutoCalc
            Seek FileHandle, Seek(FileHandle) + 1
            Seek FileHandle, Seek(FileHandle) + 1
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "ENAM"
            While NextRecordType = "ENAM"
                With .ENAM(i)
                     Get FileHandle, , .ENAMSize
                    Get FileHandle, , .ENAMEffectID
                    Get FileHandle, , .ENAMSkillID
                    Get FileHandle, , .ENAMAttributeID
                    Get FileHandle, , .ENAMRange
                    Seek FileHandle, Seek(FileHandle) + 1
                    Seek FileHandle, Seek(FileHandle) + 1
                    Seek FileHandle, Seek(FileHandle) + 1
                    Get FileHandle, , .ENAMArea
                    Get FileHandle, , .ENAMDuration
                    Get FileHandle, , .ENAMMagnitudeMin
                    Get FileHandle, , .ENAMMagnitudeMax
                    Get FileHandle, , NextRecordType
                End With
                i = i + 1
            Wend
        Case "DELE"
            'Record Deleted. Skip the data.
            Seek FileHandle, Seek(FileHandle) + 8
            Get FileHandle, , NextRecordType
        Case Else
            Exit Do
        End Select
    Loop
End With

End Function

Public Function ReadBODY(ByVal FileHandle As Integer, ByRef NextRecordType As String) As ES_BODY

With ReadBODY
    Get FileHandle, , .Size
    Get FileHandle, , .UnknownHeader1
    Get FileHandle, , .Flag
    Get FileHandle, , NextRecordType
    Do
        Select Case NextRecordType
        Case "NAME"
            Get FileHandle, , .NAMESize
            .NAMEValue = Space$(.NAMESize - 1)
            Get FileHandle, , .NAMEValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "MODL"
             Get FileHandle, , .MODLSize
            .MODLValue = Space$(.MODLSize - 1)
            Get FileHandle, , .MODLValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "FNAM"
            Get FileHandle, , .FNAMSize
            .FNAMValue = Space$(.FNAMSize - 1)
            Get FileHandle, , .FNAMValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "BYDT"
            Get FileHandle, , .BYDTSize
            Get FileHandle, , .BYDTPart
            Get FileHandle, , .BYDTVampire
            Get FileHandle, , .BYDTFlags
            Get FileHandle, , .BYDTType
            Get FileHandle, , NextRecordType
        Case "DELE"
            'Record Deleted. Skip the data.
            Seek FileHandle, Seek(FileHandle) + 8
            Get FileHandle, , NextRecordType
        Case Else
            Exit Do
        End Select
    Loop
End With

End Function

Public Function ReadLIGH(ByVal FileHandle As Integer, ByRef NextRecordType As String) As ES_LIGH

With ReadLIGH
    Get FileHandle, , .Size
    Get FileHandle, , .UnknownHeader1
    Get FileHandle, , .Flag
    Get FileHandle, , NextRecordType
    Do
        Select Case NextRecordType
        Case "NAME"
            Get FileHandle, , .NAMESize
            .NAMEValue = Space$(.NAMESize - 1)
            Get FileHandle, , .NAMEValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "MODL"
            Get FileHandle, , .MODLSize
            .MODLValue = Space$(.MODLSize - 1)
            Get FileHandle, , .MODLValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "FNAM"
            Get FileHandle, , .FNAMSize
            .FNAMValue = Space$(.FNAMSize - 1)
            Get FileHandle, , .FNAMValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "ITEX"
            Get FileHandle, , .ITEXSize
            .ITEXValue = Space$(.ITEXSize - 1)
            Get FileHandle, , .ITEXValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "SCRI"
            Get FileHandle, , .SCRISize
            .SCRIValue = Space$(.SCRISize - 1)
            Get FileHandle, , .SCRIValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "SNAM"
            Get FileHandle, , .SNAMSize
            .SNAMValue = Space$(.SNAMSize - 1)
            Get FileHandle, , .SNAMValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "LHDT"
            Get FileHandle, , .LHDTSize
            Get FileHandle, , .LHDTWeight
            Get FileHandle, , .LHDTValue
            Get FileHandle, , .LHDTTime
            Get FileHandle, , .LHDTRadius
            Get FileHandle, , .LHDTRed
            Get FileHandle, , .LHDTGreen
            Get FileHandle, , .LHDTBlue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , .LHDTFlags
            Get FileHandle, , NextRecordType
        Case "DELE"
            'Record Deleted. Skip the data.
            Seek FileHandle, Seek(FileHandle) + 8
            Get FileHandle, , NextRecordType
        Case Else
            Exit Do
        End Select
    Loop
End With

End Function

Public Function ReadARMO(ByVal FileHandle As Integer, ByRef NextRecordType As String) As ES_ARMO

Dim i As Long

With ReadARMO
    Get FileHandle, , .Size
    Get FileHandle, , .UnknownHeader1
    Get FileHandle, , .Flag
    Get FileHandle, , NextRecordType
    Do
        Select Case NextRecordType
        Case "NAME"
            Get FileHandle, , .NAMESize
            .NAMEValue = Space$(.NAMESize - 1)
            Get FileHandle, , .NAMEValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "MODL"
            Get FileHandle, , .MODLSize
            .MODLValue = Space$(.MODLSize - 1)
            Get FileHandle, , .MODLValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "FNAM"
            Get FileHandle, , .FNAMSize
            .FNAMValue = Space$(.FNAMSize - 1)
            Get FileHandle, , .FNAMValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "SCRI"
            Get FileHandle, , .SCRISize
            .SCRIValue = Space$(.SCRISize - 1)
            Get FileHandle, , .SCRIValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "ITEX"
            Get FileHandle, , .ITEXSize
            .ITEXValue = Space$(.ITEXSize - 1)
            Get FileHandle, , .ITEXValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "ENAM"
            Get FileHandle, , .ENAMSize
            .ENAMValue = Space$(.ENAMSize - 1)
            Get FileHandle, , .ENAMValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "AODT"
            Get FileHandle, , .AODTSize
            Get FileHandle, , .AODTType
            Get FileHandle, , .AODTWeight
            Get FileHandle, , .AODTValue
            Get FileHandle, , .AODTHealth
            Get FileHandle, , .AODTEnchPoints
            Get FileHandle, , .AODTArmorRating
            Get FileHandle, , NextRecordType
        Case "INDX"
            While NextRecordType = "INDX"
                With .BipedParts(i)
                    Get FileHandle, , .INDXSize
                    Get FileHandle, , .INDXValue
                    Get FileHandle, , NextRecordType
                    'Note: these 2 CNAM checks are intended, as BNAM may
                    'come either before, or after CNAM, and there's no
                    'need to make another complex structure.
                    If NextRecordType = "CNAM" Then
                        Get FileHandle, , .CNAMSize
                        .CNAMValue = Space$(.CNAMSize)
                        Get FileHandle, , .CNAMValue
                        Get FileHandle, , NextRecordType
                    End If
                    If NextRecordType = "BNAM" Then
                        Get FileHandle, , .BNAMSize
                        .BNAMValue = Space$(.BNAMSize)
                        Get FileHandle, , .BNAMValue
                        Get FileHandle, , NextRecordType
                    End If
                    If NextRecordType = "CNAM" Then
                        Get FileHandle, , .CNAMSize
                        .CNAMValue = Space$(.CNAMSize)
                        Get FileHandle, , .CNAMValue
                        Get FileHandle, , NextRecordType
                    End If
                End With
                i = i + 1
            Wend
        Case "DELE"
            'Record Deleted. Skip the data.
            Seek FileHandle, Seek(FileHandle) + 8
            Get FileHandle, , NextRecordType
        Case Else
            Exit Do
        End Select
    Loop
End With

End Function

Public Function ReadCLOT(ByVal FileHandle As Integer, ByRef NextRecordType As String) As ES_CLOT

Dim i As Long

With ReadCLOT
    Get FileHandle, , .Size
    Get FileHandle, , .UnknownHeader1
    Get FileHandle, , .Flag
    Get FileHandle, , NextRecordType
    Do
        Select Case NextRecordType
        Case "NAME"
            Get FileHandle, , .NAMESize
            .NAMEValue = Space$(.NAMESize - 1)
            Get FileHandle, , .NAMEValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "MODL"
            Get FileHandle, , .MODLSize
            .MODLValue = Space$(.MODLSize - 1)
            Get FileHandle, , .MODLValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "FNAM"
            Get FileHandle, , .FNAMSize
            .FNAMValue = Space$(.FNAMSize - 1)
            Get FileHandle, , .FNAMValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "SCRI"
            Get FileHandle, , .SCRISize
            .SCRIValue = Space$(.SCRISize - 1)
            Get FileHandle, , .SCRIValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "ITEX"
            Get FileHandle, , .ITEXSize
            .ITEXValue = Space$(.ITEXSize - 1)
            Get FileHandle, , .ITEXValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "ENAM"
            Get FileHandle, , .ENAMSize
            .ENAMValue = Space$(.ENAMSize - 1)
            Get FileHandle, , .ENAMValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "CTDT"
            Get FileHandle, , .CTDTSize
            Get FileHandle, , .CTDTType
            Get FileHandle, , .CTDTWeight
            Get FileHandle, , .CTDTValue
            Get FileHandle, , .CTDTEnchPoints
            Get FileHandle, , NextRecordType
        Case "INDX"
            While NextRecordType = "INDX"
                With .BipedParts(i)
                    Get FileHandle, , .INDXSize
                    Get FileHandle, , .INDXValue
                    Get FileHandle, , NextRecordType
                    'Note: these 2 CNAM checks are intended, as BNAM may
                    'come either before, or after CNAM, and there's no
                    'need to make another complex structure.
                    If NextRecordType = "CNAM" Then
                        Get FileHandle, , .CNAMSize
                        .CNAMValue = Space$(.CNAMSize)
                        Get FileHandle, , .CNAMValue
                        Get FileHandle, , NextRecordType
                    End If
                    If NextRecordType = "BNAM" Then
                        Get FileHandle, , .BNAMSize
                        .BNAMValue = Space$(.BNAMSize)
                        Get FileHandle, , .BNAMValue
                        Get FileHandle, , NextRecordType
                    End If
                    If NextRecordType = "CNAM" Then
                        Get FileHandle, , .CNAMSize
                        .CNAMValue = Space$(.CNAMSize)
                        Get FileHandle, , .CNAMValue
                        Get FileHandle, , NextRecordType
                    End If
                End With
                i = i + 1
            Wend
        Case "DELE"
            'Record Deleted. Skip the data.
            Seek FileHandle, Seek(FileHandle) + 8
            Get FileHandle, , NextRecordType
        Case Else
            Exit Do
        End Select
    Loop
End With

End Function

Public Function ReadREPA(ByVal FileHandle As Integer, ByRef NextRecordType As String) As ES_REPA

With ReadREPA
    Get FileHandle, , .Size
    Get FileHandle, , .UnknownHeader1
    Get FileHandle, , .Flag
    Get FileHandle, , NextRecordType
    Do
        Select Case NextRecordType
        Case "NAME"
            Get FileHandle, , .NAMESize
            .NAMEValue = Space$(.NAMESize - 1)
            Get FileHandle, , .NAMEValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "MODL"
            Get FileHandle, , .MODLSize
            .MODLValue = Space$(.MODLSize - 1)
            Get FileHandle, , .MODLValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "FNAM"
            Get FileHandle, , .FNAMSize
            .FNAMValue = Space$(.FNAMSize - 1)
            Get FileHandle, , .FNAMValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "SCRI"
            Get FileHandle, , .SCRISize
            .SCRIValue = Space$(.SCRISize - 1)
            Get FileHandle, , .SCRIValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "ITEX"
            Get FileHandle, , .ITEXSize
            .ITEXValue = Space$(.ITEXSize - 1)
            Get FileHandle, , .ITEXValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "RIDT"
            Get FileHandle, , .RIDTSize
            Get FileHandle, , .RIDTWeight
            Get FileHandle, , .RIDTValue
            Get FileHandle, , .RIDTUses
            Get FileHandle, , .RIDTQuality
            Get FileHandle, , NextRecordType
        Case "DELE"
            'Record Deleted. Skip the data.
            Seek FileHandle, Seek(FileHandle) + 8
            Get FileHandle, , NextRecordType
        Case Else
            Exit Do
        End Select
    Loop
End With

End Function

Public Function ReadACTI(ByVal FileHandle As Integer, ByRef NextRecordType As String) As ES_ACTI

With ReadACTI
    Get FileHandle, , .Size
    Get FileHandle, , .UnknownHeader1
    Get FileHandle, , .Flag
    Get FileHandle, , NextRecordType
    Do
        Select Case NextRecordType
        Case "NAME"
            Get FileHandle, , .NAMESize
            .NAMEValue = Space$(.NAMESize - 1)
            Get FileHandle, , .NAMEValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "MODL"
            Get FileHandle, , .MODLSize
            .MODLValue = Space$(.MODLSize - 1)
            Get FileHandle, , .MODLValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "FNAM"
            Get FileHandle, , .FNAMSize
            .FNAMValue = Space$(.FNAMSize - 1)
            Get FileHandle, , .FNAMValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "SCRI"
            Get FileHandle, , .SCRISize
            .SCRIValue = Space$(.SCRISize - 1)
            Get FileHandle, , .SCRIValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "DELE"
            'Record Deleted. Skip the data.
            Seek FileHandle, Seek(FileHandle) + 8
            Get FileHandle, , NextRecordType
        Case Else
            Exit Do
        End Select
    Loop
End With

End Function

Public Function ReadAPPA(ByVal FileHandle As Integer, ByRef NextRecordType As String) As ES_APPA

With ReadAPPA
    Get FileHandle, , .Size
    Get FileHandle, , .UnknownHeader1
    Get FileHandle, , .Flag
    Get FileHandle, , NextRecordType
    Do
        Select Case NextRecordType
        Case "NAME"
            Get FileHandle, , .NAMESize
            .NAMEValue = Space$(.NAMESize - 1)
            Get FileHandle, , .NAMEValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "MODL"
            Get FileHandle, , .MODLSize
            .MODLValue = Space$(.MODLSize - 1)
            Get FileHandle, , .MODLValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "FNAM"
            Get FileHandle, , .FNAMSize
            .FNAMValue = Space$(.FNAMSize - 1)
            Get FileHandle, , .FNAMValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "SCRI"
            Get FileHandle, , .SCRISize
            .SCRIValue = Space$(.SCRISize - 1)
            Get FileHandle, , .SCRIValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "ITEX"
            Get FileHandle, , .ITEXSize
            .ITEXValue = Space$(.ITEXSize - 1)
            Get FileHandle, , .ITEXValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "AADT"
            Get FileHandle, , .AADTSize
            Get FileHandle, , .AADTType
            Get FileHandle, , .AADTQuality
            Get FileHandle, , .AADTWeight
            Get FileHandle, , .AADTValue
            Get FileHandle, , NextRecordType
        Case "DELE"
            'Record Deleted. Skip the data.
            Seek FileHandle, Seek(FileHandle) + 8
            Get FileHandle, , NextRecordType
        Case Else
            Exit Do
        End Select
    Loop
End With

End Function

Public Function ReadLOCK(ByVal FileHandle As Integer, ByRef NextRecordType As String) As ES_LOCK

With ReadLOCK
    Get FileHandle, , .Size
    Get FileHandle, , .UnknownHeader1
    Get FileHandle, , .Flag
    Get FileHandle, , NextRecordType
    Do
        Select Case NextRecordType
        Case "NAME"
            Get FileHandle, , .NAMESize
            .NAMEValue = Space$(.NAMESize - 1)
            Get FileHandle, , .NAMEValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "MODL"
            Get FileHandle, , .MODLSize
            .MODLValue = Space$(.MODLSize - 1)
            Get FileHandle, , .MODLValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "FNAM"
            Get FileHandle, , .FNAMSize
            .FNAMValue = Space$(.FNAMSize - 1)
            Get FileHandle, , .FNAMValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "SCRI"
            Get FileHandle, , .SCRISize
            .SCRIValue = Space$(.SCRISize - 1)
            Get FileHandle, , .SCRIValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "ITEX"
            Get FileHandle, , .ITEXSize
            .ITEXValue = Space$(.ITEXSize - 1)
            Get FileHandle, , .ITEXValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "LKDT"
            Get FileHandle, , .LKDTSize
            Get FileHandle, , .LKDTWeight
            Get FileHandle, , .LKDTValue
            Get FileHandle, , .LKDTQuality
            Get FileHandle, , .LKDTUses
            Get FileHandle, , NextRecordType
        Case "DELE"
            'Record Deleted. Skip the data.
            Seek FileHandle, Seek(FileHandle) + 8
            Get FileHandle, , NextRecordType
        Case Else
            Exit Do
        End Select
    Loop
End With

End Function

Public Function ReadPROB(ByVal FileHandle As Integer, ByRef NextRecordType As String) As ES_PROB

With ReadPROB
    Get FileHandle, , .Size
    Get FileHandle, , .UnknownHeader1
    Get FileHandle, , .Flag
    Get FileHandle, , NextRecordType
    Do
        Select Case NextRecordType
        Case "NAME"
            Get FileHandle, , .NAMESize
            .NAMEValue = Space$(.NAMESize - 1)
            Get FileHandle, , .NAMEValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "MODL"
            Get FileHandle, , .MODLSize
            .MODLValue = Space$(.MODLSize - 1)
            Get FileHandle, , .MODLValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "FNAM"
            Get FileHandle, , .FNAMSize
            .FNAMValue = Space$(.FNAMSize - 1)
            Get FileHandle, , .FNAMValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "SCRI"
            Get FileHandle, , .SCRISize
            .SCRIValue = Space$(.SCRISize - 1)
            Get FileHandle, , .SCRIValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "ITEX"
            Get FileHandle, , .ITEXSize
            .ITEXValue = Space$(.ITEXSize - 1)
            Get FileHandle, , .ITEXValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "PBDT"
            Get FileHandle, , .PBDTSize
            Get FileHandle, , .PBDTWeight
            Get FileHandle, , .PBDTValue
            Get FileHandle, , .PBDTQuality
            Get FileHandle, , .PBDTUses
            Get FileHandle, , NextRecordType
        Case "DELE"
            'Record Deleted. Skip the data.
            Seek FileHandle, Seek(FileHandle) + 8
            Get FileHandle, , NextRecordType
        Case Else
            Exit Do
        End Select
    Loop
End With

End Function

Public Function ReadINGR(ByVal FileHandle As Integer, ByRef NextRecordType As String) As ES_INGR

With ReadINGR
    Get FileHandle, , .Size
    Get FileHandle, , .UnknownHeader1
    Get FileHandle, , .Flag
    Get FileHandle, , NextRecordType
    Do
        Select Case NextRecordType
        Case "NAME"
            Get FileHandle, , .NAMESize
            .NAMEValue = Space$(.NAMESize - 1)
            Get FileHandle, , .NAMEValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "MODL"
            Get FileHandle, , .MODLSize
            .MODLValue = Space$(.MODLSize - 1)
            Get FileHandle, , .MODLValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "FNAM"
            Get FileHandle, , .FNAMSize
            .FNAMValue = Space$(.FNAMSize - 1)
            Get FileHandle, , .FNAMValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "SCRI"
            Get FileHandle, , .SCRISize
            .SCRIValue = Space$(.SCRISize - 1)
            Get FileHandle, , .SCRIValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "ITEX"
            Get FileHandle, , .ITEXSize
            .ITEXValue = Space$(.ITEXSize - 1)
            Get FileHandle, , .ITEXValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "IRDT"
            Get FileHandle, , .IRDTSize
            Get FileHandle, , .IRDTWeight
            Get FileHandle, , .IRDTValue
            Get FileHandle, , .IRDTEffectID(0)
            Get FileHandle, , .IRDTEffectID(1)
            Get FileHandle, , .IRDTEffectID(2)
            Get FileHandle, , .IRDTEffectID(3)
            Get FileHandle, , .IRDTSkillID(0)
            Get FileHandle, , .IRDTSkillID(1)
            Get FileHandle, , .IRDTSkillID(2)
            Get FileHandle, , .IRDTSkillID(3)
            Get FileHandle, , .IRDTAttributeID(0)
            Get FileHandle, , .IRDTAttributeID(1)
            Get FileHandle, , .IRDTAttributeID(2)
            Get FileHandle, , .IRDTAttributeID(3)
            Get FileHandle, , NextRecordType
        Case "DELE"
            'Record Deleted. Skip the data.
            Seek FileHandle, Seek(FileHandle) + 8
            Get FileHandle, , NextRecordType
        Case Else
            Exit Do
        End Select
    Loop
End With

End Function

Public Function ReadBOOK(ByVal FileHandle As Integer, ByRef NextRecordType As String) As ES_BOOK

With ReadBOOK
    Get FileHandle, , .Size
    Get FileHandle, , .UnknownHeader1
    Get FileHandle, , .Flag
    Get FileHandle, , NextRecordType
    Do
        Select Case NextRecordType
        Case "NAME"
            Get FileHandle, , .NAMESize
            .NAMEValue = Space$(.NAMESize - 1)
            Get FileHandle, , .NAMEValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "MODL"
            Get FileHandle, , .MODLSize
            .MODLValue = Space$(.MODLSize - 1)
            Get FileHandle, , .MODLValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "FNAM"
            Get FileHandle, , .FNAMSize
            .FNAMValue = Space$(.FNAMSize - 1)
            Get FileHandle, , .FNAMValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "SCRI"
            Get FileHandle, , .SCRISize
            .SCRIValue = Space$(.SCRISize - 1)
            Get FileHandle, , .SCRIValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "ITEX"
            Get FileHandle, , .ITEXSize
            .ITEXValue = Space$(.ITEXSize - 1)
            Get FileHandle, , .ITEXValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "ENAM"
            Get FileHandle, , .ENAMSize
            .ENAMValue = Space$(.ENAMSize - 1)
            Get FileHandle, , .ENAMValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "TEXT"
            Get FileHandle, , .TEXTSize
            .TEXTValue = Space$(.TEXTSize)
            Get FileHandle, , .TEXTValue
            Get FileHandle, , NextRecordType
        Case "BKDT"
            Get FileHandle, , .BKDTSize
            Get FileHandle, , .BKDTWeight
            Get FileHandle, , .BKDTValue
            Get FileHandle, , .BKDTScroll
            Get FileHandle, , .BKDTSkillID
            Get FileHandle, , .BKDTEnchantVal
            Get FileHandle, , NextRecordType
        Case "DELE"
            'Record Deleted. Skip the data.
            Seek FileHandle, Seek(FileHandle) + 8
            Get FileHandle, , NextRecordType
        Case Else
            Exit Do
        End Select
    Loop
End With

End Function

Public Function ReadALCH(ByVal FileHandle As Integer, ByRef NextRecordType As String) As ES_ALCH

Dim i As Long

With ReadALCH
    Get FileHandle, , .Size
    Get FileHandle, , .UnknownHeader1
    Get FileHandle, , .Flag
    Get FileHandle, , NextRecordType
    Do
        Select Case NextRecordType
        Case "NAME"
            Get FileHandle, , .NAMESize
            .NAMEValue = Space$(.NAMESize - 1)
            Get FileHandle, , .NAMEValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "MODL"
            Get FileHandle, , .MODLSize
            .MODLValue = Space$(.MODLSize - 1)
            Get FileHandle, , .MODLValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "FNAM"
            Get FileHandle, , .FNAMSize
            .FNAMValue = Space$(.FNAMSize - 1)
            Get FileHandle, , .FNAMValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "SCRI"
            Get FileHandle, , .SCRISize
            .SCRIValue = Space$(.SCRISize - 1)
            Get FileHandle, , .SCRIValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "TEXT"
            Get FileHandle, , .TEXTSize
            .TEXTValue = Space$(.TEXTSize - 1)
            Get FileHandle, , .TEXTValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "ALDT"
            Get FileHandle, , .ALDTSize
            Get FileHandle, , .ALDTWeight
            Get FileHandle, , .ALDTValue
            Get FileHandle, , .ALDTAutoCalc
            Get FileHandle, , NextRecordType
        Case "ENAM"
            While NextRecordType = "ENAM"
                With .ENAM(i)
                    Get FileHandle, , .ENAMSize
                    Get FileHandle, , .ENAMEffectID
                    Get FileHandle, , .ENAMSkillID
                    Get FileHandle, , .ENAMAttributeID
                    Get FileHandle, , .ENAMRange
                    Seek FileHandle, Seek(FileHandle) + 3
                    Get FileHandle, , .ENAMArea
                    Get FileHandle, , .ENAMDuration
                    Get FileHandle, , .ENAMMagnitudeMin
                    Get FileHandle, , .ENAMMagnitudeMax
                    Get FileHandle, , NextRecordType
                End With
                i = i + 1
            Wend
        Case "DELE"
            'Record Deleted. Skip the data.
            Seek FileHandle, Seek(FileHandle) + 8
            Get FileHandle, , NextRecordType
        Case Else
            Exit Do
        End Select
    Loop
End With

End Function

Public Function ReadLEVI(ByVal FileHandle As Integer, ByRef NextRecordType As String) As ES_LEVI

Dim i As Long

With ReadLEVI
    Get FileHandle, , .Size
    Get FileHandle, , .UnknownHeader1
    Get FileHandle, , .Flag
    Get FileHandle, , NextRecordType
    Do
        Select Case NextRecordType
        Case "NAME"
            Get FileHandle, , .NAMESize
            .NAMEValue = Space$(.NAMESize - 1)
            Get FileHandle, , .NAMEValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "DATA"
            Get FileHandle, , .DATASize
            Get FileHandle, , .DATAValue
            Seek FileHandle, Seek(FileHandle) + 3
            Get FileHandle, , NextRecordType
        Case "NNAM"
            Get FileHandle, , .NNAMSize
            Get FileHandle, , .NNAMValue
            Get FileHandle, , NextRecordType
        Case "INDX"
            Get FileHandle, , .INDXSize
            Get FileHandle, , .INDXValue
            Get FileHandle, , NextRecordType
        Case "INAM"
            While NextRecordType = "INAM"
                ReDim Preserve .Items(i)
                With .Items(i)
                    Get FileHandle, , .INAMSize
                    .INAMValue = Space$(.INAMSize - 1)
                    Get FileHandle, , .INAMValue
                    Seek FileHandle, Seek(FileHandle) + 5
                     Get FileHandle, , .INTVSize
                    Get FileHandle, , .INTVValue
                    Get FileHandle, , NextRecordType
                End With
                i = i + 1
            Wend
        Case "DELE"
            'Record Deleted. Skip the data.
            Seek FileHandle, Seek(FileHandle) + 8
            Get FileHandle, , NextRecordType
        Case Else
            Exit Do
        End Select
    Loop
End With

End Function

Public Function ReadLEVC(ByVal FileHandle As Integer, ByRef NextRecordType As String) As ES_LEVC

Dim i As Long

With ReadLEVC
    Get FileHandle, , .Size
    Get FileHandle, , .UnknownHeader1
    Get FileHandle, , .Flag
    Get FileHandle, , NextRecordType
    Do
        Select Case NextRecordType
        Case "NAME"
            Get FileHandle, , .NAMESize
            .NAMEValue = Space$(.NAMESize - 1)
            Get FileHandle, , .NAMEValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "DATA"
            Get FileHandle, , .DATASize
            Get FileHandle, , .DATAValue
            Seek FileHandle, Seek(FileHandle) + 3
            Get FileHandle, , NextRecordType
        Case "NNAM"
            Get FileHandle, , .NNAMSize
            Get FileHandle, , .NNAMValue
            Get FileHandle, , NextRecordType
        Case "INDX"
            Get FileHandle, , .INDXSize
            Get FileHandle, , .INDXValue
            Get FileHandle, , NextRecordType
        Case "CNAM"
            While NextRecordType = "CNAM"
                ReDim Preserve .Creatures(i)
                With .Creatures(i)
                    Get FileHandle, , .CNAMSize
                    .CNAMValue = Space$(.CNAMSize - 1)
                    Get FileHandle, , .CNAMValue
                    Seek FileHandle, Seek(FileHandle) + 5
                    Get FileHandle, , .INTVSize
                    Get FileHandle, , .INTVValue
                    Get FileHandle, , NextRecordType
                End With
                i = i + 1
            Wend
        Case "DELE"
            'Record Deleted. Skip the data.
            Seek FileHandle, Seek(FileHandle) + 8
            Get FileHandle, , NextRecordType
        Case Else
            Exit Do
        End Select
    Loop
End With

End Function

Public Function ReadSNDG(ByVal FileHandle As Integer, ByRef NextRecordType As String) As ES_SNDG

With ReadSNDG
    Get FileHandle, , .Size
    Get FileHandle, , .UnknownHeader1
    Get FileHandle, , .Flag
    Get FileHandle, , NextRecordType
    Do
        Select Case NextRecordType
        Case "NAME"
            Get FileHandle, , .NAMESize
            .NAMEValue = Space$(.NAMESize - 1)
            Get FileHandle, , .NAMEValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "DATA"
            Get FileHandle, , .DATASize
            Get FileHandle, , .DATAValue
            Seek FileHandle, Seek(FileHandle) + 3
            Get FileHandle, , NextRecordType
        Case "CNAM"
            Get FileHandle, , .CNAMSize
            .CNAMValue = Space$(.CNAMSize - 1)
            Get FileHandle, , .CNAMValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "SNAM"
            Get FileHandle, , .SNAMSize
            .SNAMValue = Space$(.SNAMSize - 1)
            Get FileHandle, , .SNAMValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "DELE"
            'Record Deleted. Skip the data.
            Seek FileHandle, Seek(FileHandle) + 8
            Get FileHandle, , NextRecordType
        Case Else
            Exit Do
        End Select
    Loop
End With

End Function

Public Function ReadSSCR(ByVal FileHandle As Integer, ByRef NextRecordType As String) As ES_SSCR

With ReadSSCR
    Get FileHandle, , .Size
    Get FileHandle, , .UnknownHeader1
    Get FileHandle, , .Flag
    Get FileHandle, , NextRecordType
    Do
        Select Case NextRecordType
        Case "NAME"
            Get FileHandle, , .NAMESize
            .NAMEValue = Space$(.NAMESize)
            Get FileHandle, , .NAMEValue
            Get FileHandle, , NextRecordType
        Case "DATA"
            Get FileHandle, , .DATASize
            .DATAValue = Space$(.DATASize)
            Get FileHandle, , .DATAValue
            Get FileHandle, , NextRecordType
        Case "DELE"
            'Record Deleted. Skip the data.
            Seek FileHandle, Seek(FileHandle) + 8
            Get FileHandle, , NextRecordType
        Case Else
            Exit Do
        End Select
    Loop
End With

End Function

Public Function ReadPGRD(ByVal FileHandle As Integer, ByRef NextRecordType As String) As ES_PGRD

Dim i As Long
Dim l As Long

With ReadPGRD
    Get FileHandle, , .Size
    Get FileHandle, , .UnknownHeader1
    Get FileHandle, , .Flag
    Get FileHandle, , NextRecordType
    Do
        Select Case NextRecordType
        Case "NAME"
            Get FileHandle, , .NAMESize
            .NAMEValue = Space$(.NAMESize - 1)
            Get FileHandle, , .NAMEValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "DATA"
            Get FileHandle, , .DATASize
            Get FileHandle, , .DATAGridX
            Get FileHandle, , .DATAGridY
            Get FileHandle, , .DATAGranularity
            Get FileHandle, , .DATAPointsCount
            Get FileHandle, , NextRecordType
        Case "PGRP"
            i = 0
            Get FileHandle, , .PGRPSize
            ReDim .PGRPPoints(.DATAPointsCount - 1)
            For i = LBound(.PGRPPoints) To UBound(.PGRPPoints)
                With .PGRPPoints(i)
                    Get FileHandle, , .PGRPCoordX
                    Get FileHandle, , .PGRPCoordY
                    Get FileHandle, , .PGRPCoordZ
                    Get FileHandle, , .PGRPUnknown1
                    Get FileHandle, , .PGRPConnectCount
                    Get FileHandle, , .PGRPUnknown2
                    Get FileHandle, , .PGRPUnknown3
                End With
            Next
            Get FileHandle, , NextRecordType
        Case "PGRC"
            i = 0
            Get FileHandle, , .PGRCSize
            ReDim .PGRCData((.PGRCSize / 4) - 1)
            For i = LBound(.PGRCData) To UBound(.PGRCData)
                Get FileHandle, , .PGRCData(i)
            Next
            'Calculation of the "Connections" Helper
                'Calculate start points
                ReDim .Connections(0)
                For l = LBound(.PGRPPoints) To UBound(.PGRPPoints)
                    For i = 1 To (.PGRPPoints(l).PGRPConnectCount)
                        .Connections(UBound(.Connections)).StartPoint = l
                        ReDim Preserve .Connections(UBound(.Connections) + 1)
                    Next
                Next
                ReDim Preserve .Connections(UBound(.Connections) - 1)
                'Calculate end points
                For i = LBound(.PGRCData) To UBound(.PGRCData)
                    .Connections(i).EndPoint = .PGRCData(i)
                Next
            'End calculation of the helper
            Get FileHandle, , NextRecordType
        Case Else
            Exit Do
        End Select
    Loop
End With

End Function

Public Function ReadNPC_(ByVal FileHandle As Integer, ByRef NextRecordType As String) As ES_NPC_

Dim i As Long
Dim w_counter As Long
Dim t_counter As Long
Dim f_counter As Long
Dim a_counter As Long
Dim e_counter As Long

With ReadNPC_
    Get FileHandle, , .Size
    Get FileHandle, , .UnknownHeader1
    Get FileHandle, , .Flag
    Get FileHandle, , NextRecordType
    Do
        Select Case NextRecordType
        Case "NAME"
            Get FileHandle, , .NAMESize
            .NAMEValue = Space$(.NAMESize - 1)
            Get FileHandle, , .NAMEValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "MODL"
            Get FileHandle, , .MODLSize
            .MODLValue = Space$(.MODLSize - 1)
            Get FileHandle, , .MODLValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "FNAM"
            Get FileHandle, , .FNAMSize
            .FNAMValue = Space$(.FNAMSize - 1)
            Get FileHandle, , .FNAMValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "RNAM"
            Get FileHandle, , .RNAMSize
            .RNAMValue = Space$(.RNAMSize - 1)
            Get FileHandle, , .RNAMValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "CNAM"
            Get FileHandle, , .CNAMSize
            .CNAMValue = Space$(.CNAMSize - 1)
            Get FileHandle, , .CNAMValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "ANAM"
            Get FileHandle, , .ANAMSize
            .ANAMValue = Space$(.ANAMSize - 1)
            Get FileHandle, , .ANAMValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "BNAM"
            Get FileHandle, , .BNAMSize
            .BNAMValue = Space$(.BNAMSize - 1)
            Get FileHandle, , .BNAMValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "KNAM"
            Get FileHandle, , .KNAMSize
            .KNAMValue = Space$(.KNAMSize - 1)
            Get FileHandle, , .KNAMValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "SCRI"
            Get FileHandle, , .SCRISize
            .SCRIValue = Space$(.SCRISize - 1)
            Get FileHandle, , .SCRIValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "NPDT"
            Get FileHandle, , .NPDTSize
            If .NPDTSize = 12 Then
                Get FileHandle, , .NPDTDataS
            Else
                Get FileHandle, , .NPDTDataL
            End If
            Get FileHandle, , NextRecordType
        Case "FLAG"
            Get FileHandle, , .FLAGSize
            Get FileHandle, , .FLAGGeneral
            Get FileHandle, , .FLAGBlood
            Seek FileHandle, Seek(FileHandle) + 2
            Get FileHandle, , NextRecordType
        Case "INDX"
            Get FileHandle, , .INDXSize
            Get FileHandle, , .INDXValue
            Get FileHandle, , NextRecordType
        Case "NPCO"
            i = 0
            While NextRecordType = "NPCO"
                ReDim Preserve .NPCO(i)
                With .NPCO(i)
                    Get FileHandle, , .NPCOSize
                    Get FileHandle, , .NPCOCount
                    Get FileHandle, , .NPCOItem
                    Get FileHandle, , NextRecordType
                End With
                i = i + 1
            Wend
        Case "NPCS"
            i = 0
            While NextRecordType = "NPCS"
                ReDim Preserve .NPCS(i)
                With .NPCS(i)
                    Get FileHandle, , .NPCSSize
                    Get FileHandle, , .NPCSItem
                    Get FileHandle, , NextRecordType
                End With
                i = i + 1
            Wend
        Case "AIDT"
            Get FileHandle, , .AIDTSize
            Get FileHandle, , .AIDTHello
            Get FileHandle, , .AIDTUnknown1
            Get FileHandle, , .AIDTFight
            Get FileHandle, , .AIDTFlee
            Get FileHandle, , .AIDTAlarm
            Get FileHandle, , .AIDTUnknown2
            Get FileHandle, , .AIDTUnknown3
            Get FileHandle, , .AIDTUnknown4
            Get FileHandle, , .AIDTFlag
            Get FileHandle, , NextRecordType
        Case "AI_W"
            While NextRecordType = "AI_W"
                ReDim Preserve .AI_W(w_counter)
                With .AI_W(w_counter)
                    Get FileHandle, , .AI_WSize
                    Get FileHandle, , .AI_WDistance
                    Get FileHandle, , .AI_WDuration
                    Get FileHandle, , .AI_WTime
                    For i = 0 To 7
                        Get FileHandle, , .AI_WIdles(i)
                    Next
                    Get FileHandle, , .AI_WUnknown
                End With
                Get FileHandle, , NextRecordType
                w_counter = w_counter + 1
            Wend
        Case "AI_T"
            While NextRecordType = "AI_T"
                ReDim Preserve .AI_T(t_counter)
                With .AI_T(t_counter)
                    Get FileHandle, , .AI_TSize
                    Get FileHandle, , .AI_TCoordX
                    Get FileHandle, , .AI_TCoordY
                    Get FileHandle, , .AI_TCoordZ
                    Get FileHandle, , .AI_TUnknown
                End With
                Get FileHandle, , NextRecordType
                t_counter = t_counter + 1
            Wend
        Case "AI_A"
            While NextRecordType = "AI_A"
                ReDim Preserve .AI_A(a_counter)
                With .AI_A(a_counter)
                    Get FileHandle, , .AI_ASize
                    Get FileHandle, , .AI_ATarget
                    Get FileHandle, , .AI_AUnknown
                End With
                Get FileHandle, , NextRecordType
                a_counter = a_counter + 1
            Wend
        Case "AI_F"
            While NextRecordType = "AI_F"
                ReDim Preserve .AI_F(f_counter)
                With .AI_F(f_counter)
                    Get FileHandle, , .AI_FSize
                    Get FileHandle, , .AI_FCoordX
                    Get FileHandle, , .AI_FCoordY
                    Get FileHandle, , .AI_FCoordZ
                    Get FileHandle, , .AI_FDuration
                    Get FileHandle, , .AI_FCharacter
                    Get FileHandle, , .AI_FUnknown
                    Get FileHandle, , NextRecordType
                    If NextRecordType = "CNDT" Then
                        Get FileHandle, , .CNDTSizeF
                        .CNDTValueF = Space$(.CNDTSizeF - 1)
                        Get FileHandle, , .CNDTValueF
                        Seek FileHandle, Seek(FileHandle) + 1
                        Get FileHandle, , NextRecordType
                    End If
                End With
                f_counter = f_counter + 1
            Wend
        Case "AI_E"
            While NextRecordType = "AI_E"
                ReDim Preserve .AI_E(e_counter)
                With .AI_E(e_counter)
                    Get FileHandle, , .AI_ESize
                    Get FileHandle, , .AI_ECoordX
                    Get FileHandle, , .AI_ECoordY
                    Get FileHandle, , .AI_ECoordZ
                    Get FileHandle, , .AI_EDuration
                    Get FileHandle, , .AI_ECharacter
                    Get FileHandle, , .AI_EUnknown
                    Get FileHandle, , NextRecordType
                    If NextRecordType = "CNDT" Then
                        Get FileHandle, , .CNDTSizeE
                        .CNDTValueE = Space$(.CNDTSizeE - 1)
                        Get FileHandle, , .CNDTValueE
                        Seek FileHandle, Seek(FileHandle) + 1
                        Get FileHandle, , NextRecordType
                    End If
                End With
                e_counter = e_counter + 1
            Wend
        Case "DODT"
            i = 0
            While NextRecordType = "DODT"
                With .DODT(i)
                    Get FileHandle, , .DODTSize
                    Get FileHandle, , .DODTPosX
                    Get FileHandle, , .DODTPosY
                    Get FileHandle, , .DODTPosZ
                    Get FileHandle, , .DODTRotX
                    Get FileHandle, , .DODTRotY
                    Get FileHandle, , .DODTRotZ
                    Get FileHandle, , NextRecordType
                    If NextRecordType = "DNAM" Then
                        Get FileHandle, , .DNAMSize
                        .DNAMValue = Space$(.DNAMSize - 1)
                        Get FileHandle, , .DNAMValue
                        Seek FileHandle, Seek(FileHandle) + 1
                        Get FileHandle, , NextRecordType
                    End If
                End With
                i = i + 1
            Wend
        Case "DELE"
            'Record Deleted. Skip the data.
            Seek FileHandle, Seek(FileHandle) + 8
            Get FileHandle, , NextRecordType
        Case Else
            Exit Do
        End Select
    Loop
End With

End Function

Public Function ReadCREA(ByVal FileHandle As Integer, ByRef NextRecordType As String) As ES_CREA

Dim i As Long
Dim w_counter As Long
Dim t_counter As Long
Dim f_counter As Long
Dim a_counter As Long
Dim e_counter As Long

With ReadCREA
    Get FileHandle, , .Size
    Get FileHandle, , .UnknownHeader1
    Get FileHandle, , .Flag
    Get FileHandle, , NextRecordType
    Do
        Select Case NextRecordType
        Case "NAME"
            Get FileHandle, , .NAMESize
            .NAMEValue = Space$(.NAMESize - 1)
            Get FileHandle, , .NAMEValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "MODL"
            Get FileHandle, , .MODLSize
            .MODLValue = Space$(.MODLSize - 1)
            Get FileHandle, , .MODLValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "FNAM"
            Get FileHandle, , .FNAMSize
            .FNAMValue = Space$(.FNAMSize - 1)
            Get FileHandle, , .FNAMValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "CNAM"
            Get FileHandle, , .CNAMSize
            .CNAMValue = Space$(.CNAMSize - 1)
            Get FileHandle, , .CNAMValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "SCRI"
            Get FileHandle, , .SCRISize
            .SCRIValue = Space$(.SCRISize - 1)
            Get FileHandle, , .SCRIValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "NPDT"
            Get FileHandle, , .NPDTData
            Get FileHandle, , NextRecordType
        Case "FLAG"
            Get FileHandle, , .FLAGSize
            Get FileHandle, , .FLAGGeneral
            Get FileHandle, , .FLAGBlood
            Seek FileHandle, Seek(FileHandle) + 2
            Get FileHandle, , NextRecordType
        Case "INDX"
            Get FileHandle, , .INDXSize
            Get FileHandle, , .INDXValue
            Get FileHandle, , NextRecordType
        Case "NPCO"
            i = 0
            While NextRecordType = "NPCO"
                ReDim Preserve .NPCO(i)
                With .NPCO(i)
                    Get FileHandle, , .NPCOSize
                    Get FileHandle, , .NPCOCount
                    Get FileHandle, , .NPCOItem
                    Get FileHandle, , NextRecordType
                End With
                i = i + 1
            Wend
        Case "NPCS"
            i = 0
            While NextRecordType = "NPCS"
                ReDim Preserve .NPCS(i)
                With .NPCS(i)
                    Get FileHandle, , .NPCSSize
                    Get FileHandle, , .NPCSItem
                    Get FileHandle, , NextRecordType
                End With
                i = i + 1
            Wend
        Case "AIDT"
            Get FileHandle, , .AIDTSize
            Get FileHandle, , .AIDTHello
            Get FileHandle, , .AIDTUnknown1
            Get FileHandle, , .AIDTFight
            Get FileHandle, , .AIDTFlee
            Get FileHandle, , .AIDTAlarm
            Get FileHandle, , .AIDTUnknown2
            Get FileHandle, , .AIDTUnknown3
            Get FileHandle, , .AIDTUnknown4
            Get FileHandle, , .AIDTFlag
            Get FileHandle, , NextRecordType
        Case "AI_W"
            While NextRecordType = "AI_W"
                ReDim Preserve .AI_W(w_counter)
                With .AI_W(w_counter)
                    Get FileHandle, , .AI_WSize
                    Get FileHandle, , .AI_WDistance
                    Get FileHandle, , .AI_WDuration
                    Get FileHandle, , .AI_WTime
                    For i = 0 To 7
                        Get FileHandle, , .AI_WIdles(i)
                    Next
                    Get FileHandle, , .AI_WUnknown
                End With
                Get FileHandle, , NextRecordType
                w_counter = w_counter + 1
            Wend
        Case "AI_T"
            While NextRecordType = "AI_T"
                ReDim Preserve .AI_T(t_counter)
                With .AI_T(t_counter)
                    Get FileHandle, , .AI_TSize
                    Get FileHandle, , .AI_TCoordX
                    Get FileHandle, , .AI_TCoordY
                    Get FileHandle, , .AI_TCoordZ
                    Get FileHandle, , .AI_TUnknown
                End With
                Get FileHandle, , NextRecordType
                t_counter = t_counter + 1
            Wend
        Case "AI_A"
            While NextRecordType = "AI_A"
                ReDim Preserve .AI_A(a_counter)
                With .AI_A(a_counter)
                    Get FileHandle, , .AI_ASize
                    Get FileHandle, , .AI_ATarget
                    Get FileHandle, , .AI_AUnknown
                End With
                Get FileHandle, , NextRecordType
                a_counter = a_counter + 1
            Wend
        Case "AI_F"
            While NextRecordType = "AI_F"
                ReDim Preserve .AI_F(f_counter)
                With .AI_F(f_counter)
                    Get FileHandle, , .AI_FSize
                    Get FileHandle, , .AI_FCoordX
                    Get FileHandle, , .AI_FCoordY
                    Get FileHandle, , .AI_FCoordZ
                    Get FileHandle, , .AI_FDuration
                    Get FileHandle, , .AI_FCharacter
                    Get FileHandle, , .AI_FUnknown
                    Get FileHandle, , NextRecordType
                    If NextRecordType = "CNDT" Then
                        Get FileHandle, , .CNDTSizeF
                        .CNDTValueF = Space$(.CNDTSizeF - 1)
                        Get FileHandle, , .CNDTValueF
                        Seek FileHandle, Seek(FileHandle) + 1
                        Get FileHandle, , NextRecordType
                    End If
                End With
                f_counter = f_counter + 1
            Wend
        Case "AI_E"
            While NextRecordType = "AI_E"
                ReDim Preserve .AI_E(e_counter)
                With .AI_E(e_counter)
                    Get FileHandle, , .AI_ESize
                    Get FileHandle, , .AI_ECoordX
                    Get FileHandle, , .AI_ECoordY
                    Get FileHandle, , .AI_ECoordZ
                    Get FileHandle, , .AI_EDuration
                    Get FileHandle, , .AI_ECharacter
                    Get FileHandle, , .AI_EUnknown
                    Get FileHandle, , NextRecordType
                    If NextRecordType = "CNDT" Then
                        Get FileHandle, , .CNDTSizeE
                        .CNDTValueE = Space$(.CNDTSizeE - 1)
                        Get FileHandle, , .CNDTValueE
                        Seek FileHandle, Seek(FileHandle) + 1
                        Get FileHandle, , NextRecordType
                    End If
                End With
                e_counter = e_counter + 1
            Wend
        Case "XSCL"
            Get FileHandle, , .XSCLSize
            Get FileHandle, , .XSCLValue
            Get FileHandle, , NextRecordType
        Case "DODT"
            i = 0
            While NextRecordType = "DODT"
                With .DODT(i)
                    Get FileHandle, , .DODTSize
                    Get FileHandle, , .DODTPosX
                    Get FileHandle, , .DODTPosY
                    Get FileHandle, , .DODTPosZ
                    Get FileHandle, , .DODTRotX
                    Get FileHandle, , .DODTRotY
                    Get FileHandle, , .DODTRotZ
                    Get FileHandle, , NextRecordType
                    If NextRecordType = "DNAM" Then
                        Get FileHandle, , .DNAMSize
                        .DNAMValue = Space$(.DNAMSize - 1)
                        Get FileHandle, , .DNAMValue
                        Seek FileHandle, Seek(FileHandle) + 1
                        Get FileHandle, , NextRecordType
                    End If
                End With
                i = i + 1
            Wend
        Case "DELE"
            'Record Deleted. Skip the data.
            Seek FileHandle, Seek(FileHandle) + 8
            Get FileHandle, , NextRecordType
        Case Else
            Exit Do
        End Select
    Loop
End With

End Function

Public Function ReadCELL(ByVal FileHandle As Integer, ByRef NextRecordType As String) As ES_CELL

Dim Pers As Boolean
Dim i As Long, temp As Long

With ReadCELL
    Get FileHandle, , .Size
    Get FileHandle, , .UnknownHeader1
    Get FileHandle, , .Flag
    Get FileHandle, , NextRecordType
    Do
        Select Case NextRecordType
        Case "NAME"
            Get FileHandle, , .NAMESize
            .NAMEValue = Space$(.NAMESize - 1)
            Get FileHandle, , .NAMEValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "NAM8"
            Get FileHandle, , .NAM8Size
            .NAM8Value = Space$(.NAM8Size)
            Get FileHandle, , .NAM8Value
            Get FileHandle, , NextRecordType
        Case "MPCD"
            Get FileHandle, , .MPCDSize
            Get FileHandle, , .MPCDValueX
            Get FileHandle, , .MPCDValueY
            Get FileHandle, , .MPCDValueZ
            Get FileHandle, , NextRecordType
        Case "MPNT"
            Get FileHandle, , temp
            Seek FileHandle, Seek(FileHandle) + temp
            Get FileHandle, , NextRecordType
        Case "RGNN"
            Get FileHandle, , .RGNNSize
            .RGNNValue = Space$(.RGNNSize - 1)
            Get FileHandle, , .RGNNValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "DATA"
            Get FileHandle, , .DATASize
            Get FileHandle, , .DATAFlag
            Get FileHandle, , .DATAGridX
            Get FileHandle, , .DATAGridY
            Get FileHandle, , NextRecordType
        Case "INTV"
            Get FileHandle, , .INTVSize
            Get FileHandle, , .INTVValue
            Get FileHandle, , NextRecordType
        Case "NAM5"
            Get FileHandle, , .NAM5Size
            Get FileHandle, , .NAM5Red
            Get FileHandle, , .NAM5Green
            Get FileHandle, , .NAM5Blue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "WHGT"
            Get FileHandle, , .WHGTSize
            Get FileHandle, , .WHGTValue
            Get FileHandle, , NextRecordType
        Case "AMBI"
            Get FileHandle, , .AMBISize
            Get FileHandle, , .AMBIRed
            Get FileHandle, , .AMBIGreen
            Get FileHandle, , .AMBIBlue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , .AMBISunRed
            Get FileHandle, , .AMBISunGreen
            Get FileHandle, , .AMBISunBlue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , .AMBIFogRed
            Get FileHandle, , .AMBIFogGreen
            Get FileHandle, , .AMBIFogBlue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , .AMBIFogDensity
            Get FileHandle, , NextRecordType
        Case "NAM0" 'Number of Persistant References
            Get FileHandle, , .NAM0Size
            Get FileHandle, , .NAM0Value
            Get FileHandle, , NextRecordType
            Pers = True
        Case "FRMR"
            While NextRecordType = "FRMR"
                ReDim Preserve .References(i)
                With .References(i)
                    If Pers = True Then
                        .Persistant = 0
                    Else
                        .Persistant = 1
                    End If
                    ReDim .RefUnknown(0)
                    Get FileHandle, , .FRMRSize
                    Get FileHandle, , .FRMRObjIndex
                    Get FileHandle, , .FRMRModIndex
                    Get FileHandle, , NextRecordType
                    Do
                        Select Case NextRecordType
                        Case "NAME"
                            Get FileHandle, , .NAMESize
                            .NAMEValue = Space$(.NAMESize - 1)
                            Get FileHandle, , .NAMEValue
                            Seek FileHandle, Seek(FileHandle) + 1
                            Get FileHandle, , NextRecordType
                        Case "ZNAM"
                            .Disabled = 1
                            Seek FileHandle, Seek(FileHandle) + 5
                            Get FileHandle, , NextRecordType
                        Case "XSCL"
                            Get FileHandle, , .XSCLSize
                            Get FileHandle, , .XSCLValue
                            Get FileHandle, , NextRecordType
                        Case "DODT"
                            Get FileHandle, , .DODTSize
                            Get FileHandle, , .DODTPosX
                            Get FileHandle, , .DODTPosY
                            Get FileHandle, , .DODTPosZ
                            Get FileHandle, , .DODTRotX
                            Get FileHandle, , .DODTRotY
                            Get FileHandle, , .DODTRotZ
                            Get FileHandle, , NextRecordType
                        Case "DNAM"
                            Get FileHandle, , .DNAMSize
                            .DNAMValue = Space$(.DNAMSize - 1)
                            Get FileHandle, , .DNAMValue
                            Seek FileHandle, Seek(FileHandle) + 1
                            Get FileHandle, , NextRecordType
                        Case "FLTV"
                            Get FileHandle, , .FLTVSize
                            Get FileHandle, , .FLTVValue
                            Get FileHandle, , NextRecordType
                        Case "KNAM"
                            Get FileHandle, , .KNAMSize
                            .KNAMValue = Space$(.KNAMSize - 1)
                            Get FileHandle, , .KNAMValue
                            Seek FileHandle, Seek(FileHandle) + 1
                            Get FileHandle, , NextRecordType
                        Case "TNAM"
                            Get FileHandle, , .TNAMSize
                            .TNAMValue = Space$(.TNAMSize - 1)
                            Get FileHandle, , .TNAMValue
                            Seek FileHandle, Seek(FileHandle) + 1
                            Get FileHandle, , NextRecordType
                        Case "CNAM"
                            Get FileHandle, , .CNAMSize
                            .CNAMValue = Space$(.CNAMSize - 1)
                            Get FileHandle, , .CNAMValue
                            Seek FileHandle, Seek(FileHandle) + 1
                            Get FileHandle, , NextRecordType
                        Case "UNAM"
                            Get FileHandle, , .UNAMSize
                            Get FileHandle, , .UNAMValue
                            Get FileHandle, , NextRecordType
                        Case "ANAM"
                            Get FileHandle, , .ANAMSize
                            .ANAMValue = Space$(.ANAMSize - 1)
                            Get FileHandle, , .ANAMValue
                            Seek FileHandle, Seek(FileHandle) + 1
                            Get FileHandle, , NextRecordType
                        Case "BNAM"
                            Get FileHandle, , .BNAMSize
                            .BNAMValue = Space$(.BNAMSize - 1)
                            Get FileHandle, , .BNAMValue
                            Seek FileHandle, Seek(FileHandle) + 1
                            Get FileHandle, , NextRecordType
                        Case "INTV"
                            Get FileHandle, , .INTVSize
                            Get FileHandle, , .INTVValue
                            Get FileHandle, , NextRecordType
                        Case "INDX"
                            Get FileHandle, , .INDXSize
                            Get FileHandle, , .INDXValue
                            Get FileHandle, , NextRecordType
                        Case "XCHG"
                            Get FileHandle, , .XCHGSize
                            Get FileHandle, , .XCHGValue
                            Get FileHandle, , NextRecordType
                        Case "NAM9"
                            Get FileHandle, , .NAM9Size
                            Get FileHandle, , .NAM9Value
                            Get FileHandle, , NextRecordType
                        Case "XSOL"
                            Get FileHandle, , .XSOLSize
                            .XSOLValue = Space$(.XSOLSize - 1)
                            Get FileHandle, , .XSOLValue
                            Seek FileHandle, Seek(FileHandle) + 1
                            Get FileHandle, , NextRecordType
                        Case "DATA"
                            Get FileHandle, , .DATASize
                            Get FileHandle, , .DATAPosX
                            Get FileHandle, , .DATAPosY
                            Get FileHandle, , .DATAPosZ
                            Get FileHandle, , .DATARotX
                            Get FileHandle, , .DATARotY
                            Get FileHandle, , .DATARotZ
                            Get FileHandle, , NextRecordType
                            If NextRecordType = "DATA" Then
                                Get FileHandle, , .DATA2Size
                                Get FileHandle, , .DATA2PosX
                                Get FileHandle, , .DATA2PosY
                                Get FileHandle, , .DATA2PosZ
                                Get FileHandle, , .DATA2RotX
                                Get FileHandle, , .DATA2RotY
                                Get FileHandle, , .DATA2RotZ
                                Get FileHandle, , NextRecordType
                            End If
                        Case "DELE"
                            'Reference Deleted. Skip the data.
                            .Deleted = 1
                            Seek FileHandle, Seek(FileHandle) + 8
                            Get FileHandle, , NextRecordType
                        'Unknown subrecords...
                        Case "LVCR"
                            Get FileHandle, , temp
                            .RefUnknown(UBound(.RefUnknown)) = Space$(temp)
                            Get FileHandle, , .RefUnknown(UBound(.RefUnknown))
                            .RefUnknown(UBound(.RefUnknown)) = NextRecordType & .RefUnknown(UBound(.RefUnknown))
                            ReDim RefUnknown(UBound(.RefUnknown) + 1)
                            Get FileHandle, , NextRecordType
                        Case "ACDT"
                            Get FileHandle, , temp
                            .RefUnknown(UBound(.RefUnknown)) = Space$(temp)
                            Get FileHandle, , .RefUnknown(UBound(.RefUnknown))
                            .RefUnknown(UBound(.RefUnknown)) = NextRecordType & .RefUnknown(UBound(.RefUnknown))
                            ReDim RefUnknown(UBound(.RefUnknown) + 1)
                            Get FileHandle, , NextRecordType
                        Case "ACSC"
                            Get FileHandle, , temp
                            .RefUnknown(UBound(.RefUnknown)) = Space$(temp)
                            Get FileHandle, , .RefUnknown(UBound(.RefUnknown))
                            .RefUnknown(UBound(.RefUnknown)) = NextRecordType & .RefUnknown(UBound(.RefUnknown))
                            ReDim RefUnknown(UBound(.RefUnknown) + 1)
                            Get FileHandle, , NextRecordType
                        Case "ACSL"
                            Get FileHandle, , temp
                            .RefUnknown(UBound(.RefUnknown)) = Space$(temp)
                            Get FileHandle, , .RefUnknown(UBound(.RefUnknown))
                            .RefUnknown(UBound(.RefUnknown)) = NextRecordType & .RefUnknown(UBound(.RefUnknown))
                            ReDim RefUnknown(UBound(.RefUnknown) + 1)
                            Get FileHandle, , NextRecordType
                        Case "CREC"
                            Get FileHandle, , temp
                            .RefUnknown(UBound(.RefUnknown)) = Space$(temp)
                            Get FileHandle, , .RefUnknown(UBound(.RefUnknown))
                            .RefUnknown(UBound(.RefUnknown)) = NextRecordType & .RefUnknown(UBound(.RefUnknown))
                            ReDim RefUnknown(UBound(.RefUnknown) + 1)
                            Get FileHandle, , NextRecordType
                        Case "SCRI"
                            Get FileHandle, , temp
                            .RefUnknown(UBound(.RefUnknown)) = Space$(temp)
                            Get FileHandle, , .RefUnknown(UBound(.RefUnknown))
                            .RefUnknown(UBound(.RefUnknown)) = NextRecordType & .RefUnknown(UBound(.RefUnknown))
                            ReDim RefUnknown(UBound(.RefUnknown) + 1)
                            Get FileHandle, , NextRecordType
                        Case "SLCS"
                            Get FileHandle, , temp
                            .RefUnknown(UBound(.RefUnknown)) = Space$(temp)
                            Get FileHandle, , .RefUnknown(UBound(.RefUnknown))
                            .RefUnknown(UBound(.RefUnknown)) = NextRecordType & .RefUnknown(UBound(.RefUnknown))
                            ReDim RefUnknown(UBound(.RefUnknown) + 1)
                            Get FileHandle, , NextRecordType
                        Case "SLSD"
                            Get FileHandle, , temp
                            .RefUnknown(UBound(.RefUnknown)) = Space$(temp)
                            Get FileHandle, , .RefUnknown(UBound(.RefUnknown))
                            .RefUnknown(UBound(.RefUnknown)) = NextRecordType & .RefUnknown(UBound(.RefUnknown))
                            ReDim RefUnknown(UBound(.RefUnknown) + 1)
                            Get FileHandle, , NextRecordType
                        Case "CRED"
                            Get FileHandle, , temp
                            .RefUnknown(UBound(.RefUnknown)) = Space$(temp)
                            Get FileHandle, , .RefUnknown(UBound(.RefUnknown))
                            .RefUnknown(UBound(.RefUnknown)) = NextRecordType & .RefUnknown(UBound(.RefUnknown))
                            ReDim RefUnknown(UBound(.RefUnknown) + 1)
                            Get FileHandle, , NextRecordType
                        Case "SLFD"
                            Get FileHandle, , temp
                            .RefUnknown(UBound(.RefUnknown)) = Space$(temp)
                            Get FileHandle, , .RefUnknown(UBound(.RefUnknown))
                            .RefUnknown(UBound(.RefUnknown)) = NextRecordType & .RefUnknown(UBound(.RefUnknown))
                            ReDim RefUnknown(UBound(.RefUnknown) + 1)
                            Get FileHandle, , NextRecordType
                        Case "CHRD"
                            Get FileHandle, , temp
                            .RefUnknown(UBound(.RefUnknown)) = Space$(temp)
                            Get FileHandle, , .RefUnknown(UBound(.RefUnknown))
                            .RefUnknown(UBound(.RefUnknown)) = NextRecordType & .RefUnknown(UBound(.RefUnknown))
                            ReDim RefUnknown(UBound(.RefUnknown) + 1)
                            Get FileHandle, , NextRecordType
                        Case "STPR"
                            Get FileHandle, , temp
                            .RefUnknown(UBound(.RefUnknown)) = Space$(temp)
                            Get FileHandle, , .RefUnknown(UBound(.RefUnknown))
                            .RefUnknown(UBound(.RefUnknown)) = NextRecordType & .RefUnknown(UBound(.RefUnknown))
                            ReDim RefUnknown(UBound(.RefUnknown) + 1)
                            Get FileHandle, , NextRecordType
                        Case "ACTN"
                            Get FileHandle, , temp
                            .RefUnknown(UBound(.RefUnknown)) = Space$(temp)
                            Get FileHandle, , .RefUnknown(UBound(.RefUnknown))
                            .RefUnknown(UBound(.RefUnknown)) = NextRecordType & .RefUnknown(UBound(.RefUnknown))
                            ReDim RefUnknown(UBound(.RefUnknown) + 1)
                            Get FileHandle, , NextRecordType
                        Case "MNAM"
                            Get FileHandle, , temp
                            .RefUnknown(UBound(.RefUnknown)) = Space$(temp)
                            Get FileHandle, , .RefUnknown(UBound(.RefUnknown))
                            .RefUnknown(UBound(.RefUnknown)) = NextRecordType & .RefUnknown(UBound(.RefUnknown))
                            ReDim RefUnknown(UBound(.RefUnknown) + 1)
                            Get FileHandle, , NextRecordType
                        Case "ANIS"
                            Get FileHandle, , temp
                            .RefUnknown(UBound(.RefUnknown)) = Space$(temp)
                            Get FileHandle, , .RefUnknown(UBound(.RefUnknown))
                            .RefUnknown(UBound(.RefUnknown)) = NextRecordType & .RefUnknown(UBound(.RefUnknown))
                            ReDim RefUnknown(UBound(.RefUnknown) + 1)
                            Get FileHandle, , NextRecordType
                        Case "LSTN"
                            Get FileHandle, , temp
                            .RefUnknown(UBound(.RefUnknown)) = Space$(temp)
                            Get FileHandle, , .RefUnknown(UBound(.RefUnknown))
                            .RefUnknown(UBound(.RefUnknown)) = NextRecordType & .RefUnknown(UBound(.RefUnknown))
                            ReDim RefUnknown(UBound(.RefUnknown) + 1)
                            Get FileHandle, , NextRecordType
                        Case "ND3D"
                            Get FileHandle, , temp
                            .RefUnknown(UBound(.RefUnknown)) = Space$(temp)
                            Get FileHandle, , .RefUnknown(UBound(.RefUnknown))
                            .RefUnknown(UBound(.RefUnknown)) = NextRecordType & .RefUnknown(UBound(.RefUnknown))
                            ReDim RefUnknown(UBound(.RefUnknown) + 1)
                            Get FileHandle, , NextRecordType
                        Case "CSTN"
                            Get FileHandle, , temp
                            .RefUnknown(UBound(.RefUnknown)) = Space$(temp)
                            Get FileHandle, , .RefUnknown(UBound(.RefUnknown))
                            .RefUnknown(UBound(.RefUnknown)) = NextRecordType & .RefUnknown(UBound(.RefUnknown))
                            ReDim RefUnknown(UBound(.RefUnknown) + 1)
                            Get FileHandle, , NextRecordType
                        Case "TGTN"
                            Get FileHandle, , temp
                            .RefUnknown(UBound(.RefUnknown)) = Space$(temp)
                            Get FileHandle, , .RefUnknown(UBound(.RefUnknown))
                            .RefUnknown(UBound(.RefUnknown)) = NextRecordType & .RefUnknown(UBound(.RefUnknown))
                            ReDim RefUnknown(UBound(.RefUnknown) + 1)
                            Get FileHandle, , NextRecordType
                        Case "CSHN"
                            Get FileHandle, , temp
                            .RefUnknown(UBound(.RefUnknown)) = Space$(temp)
                            Get FileHandle, , .RefUnknown(UBound(.RefUnknown))
                            .RefUnknown(UBound(.RefUnknown)) = NextRecordType & .RefUnknown(UBound(.RefUnknown))
                            ReDim RefUnknown(UBound(.RefUnknown) + 1)
                            Get FileHandle, , NextRecordType
                        Case "FGTN"
                            Get FileHandle, , temp
                            .RefUnknown(UBound(.RefUnknown)) = Space$(temp)
                            Get FileHandle, , .RefUnknown(UBound(.RefUnknown))
                            .RefUnknown(UBound(.RefUnknown)) = NextRecordType & .RefUnknown(UBound(.RefUnknown))
                            ReDim RefUnknown(UBound(.RefUnknown) + 1)
                            Get FileHandle, , NextRecordType
                        Case "LSHN"
                            Get FileHandle, , temp
                            .RefUnknown(UBound(.RefUnknown)) = Space$(temp)
                            Get FileHandle, , .RefUnknown(UBound(.RefUnknown))
                            .RefUnknown(UBound(.RefUnknown)) = NextRecordType & .RefUnknown(UBound(.RefUnknown))
                            ReDim RefUnknown(UBound(.RefUnknown) + 1)
                            Get FileHandle, , NextRecordType
                        Case "AADT"
                            Get FileHandle, , temp
                            .RefUnknown(UBound(.RefUnknown)) = Space$(temp)
                            Get FileHandle, , .RefUnknown(UBound(.RefUnknown))
                            .RefUnknown(UBound(.RefUnknown)) = NextRecordType & .RefUnknown(UBound(.RefUnknown))
                            ReDim RefUnknown(UBound(.RefUnknown) + 1)
                            Get FileHandle, , NextRecordType
                        Case "WNAM"
                            Get FileHandle, , temp
                            .RefUnknown(UBound(.RefUnknown)) = Space$(temp)
                            Get FileHandle, , .RefUnknown(UBound(.RefUnknown))
                            .RefUnknown(UBound(.RefUnknown)) = NextRecordType & .RefUnknown(UBound(.RefUnknown))
                            ReDim RefUnknown(UBound(.RefUnknown) + 1)
                            Get FileHandle, , NextRecordType
                        Case Else
                            Exit Do
                        End Select
                    Loop
                End With
                i = i + 1
            Wend
        Case "MVRF"
            While NextRecordType = "MVRF"
                ReDim Preserve .References(i)
                With .References(i)
                    If Pers = True Then
                        .Persistant = 0
                    Else
                        .Persistant = 1
                    End If
                    ReDim .RefUnknown(0)
                    Get FileHandle, , .MVRFSize
                    Get FileHandle, , .MVRFObjectIndex
                    Get FileHandle, , .MVRFModIndex
                    Get FileHandle, , NextRecordType
                    If NextRecordType = "CNDT" Then
                        Get FileHandle, , .CNDTSize
                        Get FileHandle, , .CNDTGridX
                        Get FileHandle, , .CNDTGridY
                    ElseIf NextRecordType = "CNAM" Then
                        Get FileHandle, , .MVRFCNAMSize
                        .MVRFCNAMValue = Space$(.MVRFCNAMSize)
                        Get FileHandle, , .MVRFCNAMValue
                    End If
                    Seek FileHandle, Seek(FileHandle) + 4
                    Get FileHandle, , .FRMRSize
                    Get FileHandle, , .FRMRObjIndex
                    Get FileHandle, , .FRMRModIndex
                    Get FileHandle, , NextRecordType
                    Do
                        Select Case NextRecordType
                        Case "NAME"
                            Get FileHandle, , .NAMESize
                            .NAMEValue = Space$(.NAMESize - 1)
                            Get FileHandle, , .NAMEValue
                            Seek FileHandle, Seek(FileHandle) + 1
                            Get FileHandle, , NextRecordType
                        Case "ZNAM"
                            .Disabled = 1
                            Seek FileHandle, Seek(FileHandle) + 5
                            Get FileHandle, , NextRecordType
                        Case "XSCL"
                            Get FileHandle, , .XSCLSize
                            Get FileHandle, , .XSCLValue
                            Get FileHandle, , NextRecordType
                        Case "DODT"
                            Get FileHandle, , .DODTSize
                            Get FileHandle, , .DODTPosX
                            Get FileHandle, , .DODTPosY
                            Get FileHandle, , .DODTPosZ
                            Get FileHandle, , .DODTRotX
                            Get FileHandle, , .DODTRotY
                           Get FileHandle, , .DODTRotZ
                            Get FileHandle, , NextRecordType
                        Case "DNAM"
                            Get FileHandle, , .DNAMSize
                            .DNAMValue = Space$(.DNAMSize - 1)
                            Get FileHandle, , .DNAMValue
                            Seek FileHandle, Seek(FileHandle) + 1
                            Get FileHandle, , NextRecordType
                        Case "FLTV"
                            Get FileHandle, , .FLTVSize
                            Get FileHandle, , .FLTVValue
                            Get FileHandle, , NextRecordType
                        Case "KNAM"
                            Get FileHandle, , .KNAMSize
                            .KNAMValue = Space$(.KNAMSize - 1)
                            Get FileHandle, , .KNAMValue
                            Seek FileHandle, Seek(FileHandle) + 1
                            Get FileHandle, , NextRecordType
                        Case "TNAM"
                            Get FileHandle, , .TNAMSize
                            .TNAMValue = Space$(.TNAMSize - 1)
                            Get FileHandle, , .TNAMValue
                            Seek FileHandle, Seek(FileHandle) + 1
                            Get FileHandle, , NextRecordType
                        Case "CNAM"
                            Get FileHandle, , .CNAMSize
                            .CNAMValue = Space$(.CNAMSize - 1)
                            Get FileHandle, , .CNAMValue
                            Seek FileHandle, Seek(FileHandle) + 1
                            Get FileHandle, , NextRecordType
                        Case "UNAM"
                            Get FileHandle, , .UNAMSize
                            Get FileHandle, , .UNAMValue
                            Get FileHandle, , NextRecordType
                        Case "ANAM"
                            Get FileHandle, , .ANAMSize
                            .ANAMValue = Space$(.ANAMSize - 1)
                            Get FileHandle, , .ANAMValue
                            Seek FileHandle, Seek(FileHandle) + 1
                            Get FileHandle, , NextRecordType
                        Case "BNAM"
                            Get FileHandle, , .BNAMSize
                            .BNAMValue = Space$(.BNAMSize - 1)
                            Get FileHandle, , .BNAMValue
                            Seek FileHandle, Seek(FileHandle) + 1
                            Get FileHandle, , NextRecordType
                        Case "INTV"
                            Get FileHandle, , .INTVSize
                            Get FileHandle, , .INTVValue
                            Get FileHandle, , NextRecordType
                        Case "INDX"
                            Get FileHandle, , .INDXSize
                            Get FileHandle, , .INDXValue
                            Get FileHandle, , NextRecordType
                        Case "XCHG"
                            Get FileHandle, , .XCHGSize
                            Get FileHandle, , .XCHGValue
                            Get FileHandle, , NextRecordType
                        Case "NAM9"
                            Get FileHandle, , .NAM9Size
                            Get FileHandle, , .NAM9Value
                            Get FileHandle, , NextRecordType
                        Case "XSOL"
                            Get FileHandle, , .XSOLSize
                            .XSOLValue = Space$(.XSOLSize - 1)
                            Get FileHandle, , .XSOLValue
                            Seek FileHandle, Seek(FileHandle) + 1
                            Get FileHandle, , NextRecordType
                        Case "DATA"
                            Get FileHandle, , .DATASize
                            Get FileHandle, , .DATAPosX
                            Get FileHandle, , .DATAPosY
                            Get FileHandle, , .DATAPosZ
                            Get FileHandle, , .DATARotX
                            Get FileHandle, , .DATARotY
                            Get FileHandle, , .DATARotZ
                            Get FileHandle, , NextRecordType
                            If NextRecordType = "DATA" Then
                                Get FileHandle, , .DATA2Size
                                Get FileHandle, , .DATA2PosX
                                Get FileHandle, , .DATA2PosY
                                Get FileHandle, , .DATA2PosZ
                                Get FileHandle, , .DATA2RotX
                                Get FileHandle, , .DATA2RotY
                                Get FileHandle, , .DATA2RotZ
                                Get FileHandle, , NextRecordType
                            End If
                        Case "DELE"
                            'Record Deleted. Skip the data.
                            .Deleted = 1
                            Seek FileHandle, Seek(FileHandle) + 8
                            Get FileHandle, , NextRecordType
                        'Unknown subrecords...
                        Case "LVCR"
                            Get FileHandle, , temp
                            .RefUnknown(UBound(.RefUnknown)) = Space$(temp)
                            Get FileHandle, , .RefUnknown(UBound(.RefUnknown))
                            .RefUnknown(UBound(.RefUnknown)) = NextRecordType & .RefUnknown(UBound(.RefUnknown))
                            ReDim RefUnknown(UBound(.RefUnknown) + 1)
                            Get FileHandle, , NextRecordType
                        Case "ACDT"
                            Get FileHandle, , temp
                            .RefUnknown(UBound(.RefUnknown)) = Space$(temp)
                            Get FileHandle, , .RefUnknown(UBound(.RefUnknown))
                            .RefUnknown(UBound(.RefUnknown)) = NextRecordType & .RefUnknown(UBound(.RefUnknown))
                            ReDim RefUnknown(UBound(.RefUnknown) + 1)
                            Get FileHandle, , NextRecordType
                        Case "ACSC"
                            Get FileHandle, , temp
                            .RefUnknown(UBound(.RefUnknown)) = Space$(temp)
                            Get FileHandle, , .RefUnknown(UBound(.RefUnknown))
                            .RefUnknown(UBound(.RefUnknown)) = NextRecordType & .RefUnknown(UBound(.RefUnknown))
                            ReDim RefUnknown(UBound(.RefUnknown) + 1)
                            Get FileHandle, , NextRecordType
                        Case "ACSL"
                            Get FileHandle, , temp
                            .RefUnknown(UBound(.RefUnknown)) = Space$(temp)
                            Get FileHandle, , .RefUnknown(UBound(.RefUnknown))
                            .RefUnknown(UBound(.RefUnknown)) = NextRecordType & .RefUnknown(UBound(.RefUnknown))
                            ReDim RefUnknown(UBound(.RefUnknown) + 1)
                            Get FileHandle, , NextRecordType
                        Case "CREC"
                            Get FileHandle, , temp
                            .RefUnknown(UBound(.RefUnknown)) = Space$(temp)
                            Get FileHandle, , .RefUnknown(UBound(.RefUnknown))
                            .RefUnknown(UBound(.RefUnknown)) = NextRecordType & .RefUnknown(UBound(.RefUnknown))
                            ReDim RefUnknown(UBound(.RefUnknown) + 1)
                            Get FileHandle, , NextRecordType
                        Case "SCRI"
                            Get FileHandle, , temp
                            .RefUnknown(UBound(.RefUnknown)) = Space$(temp)
                            Get FileHandle, , .RefUnknown(UBound(.RefUnknown))
                            .RefUnknown(UBound(.RefUnknown)) = NextRecordType & .RefUnknown(UBound(.RefUnknown))
                            ReDim RefUnknown(UBound(.RefUnknown) + 1)
                            Get FileHandle, , NextRecordType
                        Case "SLCS"
                            Get FileHandle, , temp
                            .RefUnknown(UBound(.RefUnknown)) = Space$(temp)
                            Get FileHandle, , .RefUnknown(UBound(.RefUnknown))
                            .RefUnknown(UBound(.RefUnknown)) = NextRecordType & .RefUnknown(UBound(.RefUnknown))
                            ReDim RefUnknown(UBound(.RefUnknown) + 1)
                            Get FileHandle, , NextRecordType
                        Case "CRED"
                            Get FileHandle, , temp
                            .RefUnknown(UBound(.RefUnknown)) = Space$(temp)
                            Get FileHandle, , .RefUnknown(UBound(.RefUnknown))
                            .RefUnknown(UBound(.RefUnknown)) = NextRecordType & .RefUnknown(UBound(.RefUnknown))
                            ReDim RefUnknown(UBound(.RefUnknown) + 1)
                            Get FileHandle, , NextRecordType
                        Case "SLSD"
                            Get FileHandle, , temp
                            .RefUnknown(UBound(.RefUnknown)) = Space$(temp)
                            Get FileHandle, , .RefUnknown(UBound(.RefUnknown))
                            .RefUnknown(UBound(.RefUnknown)) = NextRecordType & .RefUnknown(UBound(.RefUnknown))
                            ReDim RefUnknown(UBound(.RefUnknown) + 1)
                            Get FileHandle, , NextRecordType
                        Case "SLFD"
                            Get FileHandle, , temp
                            .RefUnknown(UBound(.RefUnknown)) = Space$(temp)
                            Get FileHandle, , .RefUnknown(UBound(.RefUnknown))
                            .RefUnknown(UBound(.RefUnknown)) = NextRecordType & .RefUnknown(UBound(.RefUnknown))
                            ReDim RefUnknown(UBound(.RefUnknown) + 1)
                            Get FileHandle, , NextRecordType
                        Case "CHRD"
                            Get FileHandle, , temp
                            .RefUnknown(UBound(.RefUnknown)) = Space$(temp)
                            Get FileHandle, , .RefUnknown(UBound(.RefUnknown))
                            .RefUnknown(UBound(.RefUnknown)) = NextRecordType & .RefUnknown(UBound(.RefUnknown))
                            ReDim RefUnknown(UBound(.RefUnknown) + 1)
                            Get FileHandle, , NextRecordType
                        Case "STPR"
                            Get FileHandle, , temp
                            .RefUnknown(UBound(.RefUnknown)) = Space$(temp)
                            Get FileHandle, , .RefUnknown(UBound(.RefUnknown))
                            .RefUnknown(UBound(.RefUnknown)) = NextRecordType & .RefUnknown(UBound(.RefUnknown))
                            ReDim RefUnknown(UBound(.RefUnknown) + 1)
                            Get FileHandle, , NextRecordType
                        Case "ACTN"
                            Get FileHandle, , temp
                            .RefUnknown(UBound(.RefUnknown)) = Space$(temp)
                            Get FileHandle, , .RefUnknown(UBound(.RefUnknown))
                            .RefUnknown(UBound(.RefUnknown)) = NextRecordType & .RefUnknown(UBound(.RefUnknown))
                            ReDim RefUnknown(UBound(.RefUnknown) + 1)
                            Get FileHandle, , NextRecordType
                        Case "MNAM"
                            Get FileHandle, , temp
                            .RefUnknown(UBound(.RefUnknown)) = Space$(temp)
                            Get FileHandle, , .RefUnknown(UBound(.RefUnknown))
                            .RefUnknown(UBound(.RefUnknown)) = NextRecordType & .RefUnknown(UBound(.RefUnknown))
                            ReDim RefUnknown(UBound(.RefUnknown) + 1)
                            Get FileHandle, , NextRecordType
                        Case "ANIS"
                            Get FileHandle, , temp
                            .RefUnknown(UBound(.RefUnknown)) = Space$(temp)
                            Get FileHandle, , .RefUnknown(UBound(.RefUnknown))
                            .RefUnknown(UBound(.RefUnknown)) = NextRecordType & .RefUnknown(UBound(.RefUnknown))
                            ReDim RefUnknown(UBound(.RefUnknown) + 1)
                            Get FileHandle, , NextRecordType
                        Case "LSTN"
                            Get FileHandle, , temp
                            .RefUnknown(UBound(.RefUnknown)) = Space$(temp)
                            Get FileHandle, , .RefUnknown(UBound(.RefUnknown))
                            .RefUnknown(UBound(.RefUnknown)) = NextRecordType & .RefUnknown(UBound(.RefUnknown))
                            ReDim RefUnknown(UBound(.RefUnknown) + 1)
                            Get FileHandle, , NextRecordType
                        Case "ND3D"
                            Get FileHandle, , temp
                            .RefUnknown(UBound(.RefUnknown)) = Space$(temp)
                            Get FileHandle, , .RefUnknown(UBound(.RefUnknown))
                            .RefUnknown(UBound(.RefUnknown)) = NextRecordType & .RefUnknown(UBound(.RefUnknown))
                            ReDim RefUnknown(UBound(.RefUnknown) + 1)
                            Get FileHandle, , NextRecordType
                        Case "CSTN"
                            Get FileHandle, , temp
                            .RefUnknown(UBound(.RefUnknown)) = Space$(temp)
                            Get FileHandle, , .RefUnknown(UBound(.RefUnknown))
                            .RefUnknown(UBound(.RefUnknown)) = NextRecordType & .RefUnknown(UBound(.RefUnknown))
                            ReDim RefUnknown(UBound(.RefUnknown) + 1)
                            Get FileHandle, , NextRecordType
                        Case "TGTN"
                            Get FileHandle, , temp
                            .RefUnknown(UBound(.RefUnknown)) = Space$(temp)
                            Get FileHandle, , .RefUnknown(UBound(.RefUnknown))
                            .RefUnknown(UBound(.RefUnknown)) = NextRecordType & .RefUnknown(UBound(.RefUnknown))
                            ReDim RefUnknown(UBound(.RefUnknown) + 1)
                            Get FileHandle, , NextRecordType
                        Case "CSHN"
                            Get FileHandle, , temp
                            .RefUnknown(UBound(.RefUnknown)) = Space$(temp)
                            Get FileHandle, , .RefUnknown(UBound(.RefUnknown))
                            .RefUnknown(UBound(.RefUnknown)) = NextRecordType & .RefUnknown(UBound(.RefUnknown))
                            ReDim RefUnknown(UBound(.RefUnknown) + 1)
                            Get FileHandle, , NextRecordType
                        Case "FGTN"
                            Get FileHandle, , temp
                            .RefUnknown(UBound(.RefUnknown)) = Space$(temp)
                            Get FileHandle, , .RefUnknown(UBound(.RefUnknown))
                            .RefUnknown(UBound(.RefUnknown)) = NextRecordType & .RefUnknown(UBound(.RefUnknown))
                            ReDim RefUnknown(UBound(.RefUnknown) + 1)
                            Get FileHandle, , NextRecordType
                        Case "LSHN"
                            Get FileHandle, , temp
                            .RefUnknown(UBound(.RefUnknown)) = Space$(temp)
                            Get FileHandle, , .RefUnknown(UBound(.RefUnknown))
                            .RefUnknown(UBound(.RefUnknown)) = NextRecordType & .RefUnknown(UBound(.RefUnknown))
                            ReDim RefUnknown(UBound(.RefUnknown) + 1)
                            Get FileHandle, , NextRecordType
                        Case "AADT"
                            Get FileHandle, , temp
                            .RefUnknown(UBound(.RefUnknown)) = Space$(temp)
                            Get FileHandle, , .RefUnknown(UBound(.RefUnknown))
                            .RefUnknown(UBound(.RefUnknown)) = NextRecordType & .RefUnknown(UBound(.RefUnknown))
                            ReDim RefUnknown(UBound(.RefUnknown) + 1)
                            Get FileHandle, , NextRecordType
                        Case "WNAM"
                            Get FileHandle, , temp
                            .RefUnknown(UBound(.RefUnknown)) = Space$(temp)
                            Get FileHandle, , .RefUnknown(UBound(.RefUnknown))
                            .RefUnknown(UBound(.RefUnknown)) = NextRecordType & .RefUnknown(UBound(.RefUnknown))
                            ReDim RefUnknown(UBound(.RefUnknown) + 1)
                            Get FileHandle, , NextRecordType
                        Case Else
                            Exit Do
                        End Select
                    Loop
                End With
                i = i + 1
            Wend
        Case "DELE"
            'Record Deleted. Skip the data.
            .Deleted = 1
            Seek FileHandle, Seek(FileHandle) + 8
            Get FileHandle, , NextRecordType
        Case Else
            Exit Do
        End Select
    Loop
End With

Exit Function

ErrHandler:
    Err.Raise (Err.Number)

End Function

Public Function ReadDIAL(ByVal FileHandle As Integer, ByRef NextRecordType As String) As ES_DIAL

Dim i As Long

With ReadDIAL
    Get FileHandle, , .Size
    Get FileHandle, , .UnknownHeader1
    Get FileHandle, , .Flag
    Get FileHandle, , NextRecordType
    Do
        Select Case NextRecordType
        Case "NAME"
            Get FileHandle, , .NAMESize
            .NAMEValue = Space$(.NAMESize - 1)
            Get FileHandle, , .NAMEValue
            Seek FileHandle, Seek(FileHandle) + 1
            CurrentDIAL = .NAMEValue
            Get FileHandle, , NextRecordType
        Case "DATA"
            Get FileHandle, , .DATASize
            If .DATASize = 4 Then
                Seek FileHandle, Seek(FileHandle) + 4
                .DATAType = 128
            Else
                Get FileHandle, , .DATAType
            End If
            Get FileHandle, , NextRecordType
        Case "XIDX"
            Get FileHandle, , .XIDXSize
            Get FileHandle, , .XIDXValue
            Get FileHandle, , NextRecordType
        Case "DELE"
            'Record Deleted. Skip the data.
            Seek FileHandle, Seek(FileHandle) + 8
            Get FileHandle, , NextRecordType
        Case Else
            Exit Do
        End Select
    Loop
End With

End Function

Public Function ReadINFO(ByVal FileHandle As Integer, ByRef NextRecordType As String) As ES_INFO

Dim i As Long

With ReadINFO
    Get FileHandle, , .Size
    Get FileHandle, , .UnknownHeader1
    Get FileHandle, , .Flag
    .ParentDIAL = CurrentDIAL
    Get FileHandle, , NextRecordType
    Do
        Select Case NextRecordType
        Case "INAM"
            Get FileHandle, , .INAMSize
            .INAMValue = Space$(.INAMSize - 1)
            Get FileHandle, , .INAMValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "PNAM"
            Get FileHandle, , .PNAMSize
            .PNAMValue = Space$(.PNAMSize - 1)
            Get FileHandle, , .PNAMValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "NNAM"
            Get FileHandle, , .NNAMSize
            .NNAMValue = Space$(.NNAMSize - 1)
            Get FileHandle, , .NNAMValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "XIDX"
            Get FileHandle, , .XIDXSize
            Get FileHandle, , .XIDXValue
            Get FileHandle, , NextRecordType
        Case "DATA"
            Get FileHandle, , .DATASize
            Get FileHandle, , .DATAType
            Get FileHandle, , .DATADisposition
            Get FileHandle, , .DATARank
            Get FileHandle, , .DATAGender
            Get FileHandle, , .DATAPCRank
            Get FileHandle, , .DATAUnknown
            Get FileHandle, , NextRecordType
        Case "ONAM"
            Get FileHandle, , .ONAMSize
            .ONAMValue = Space$(.ONAMSize - 1)
            Get FileHandle, , .ONAMValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "RNAM"
            Get FileHandle, , .RNAMSize
            .RNAMValue = Space$(.RNAMSize - 1)
            Get FileHandle, , .RNAMValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "CNAM"
            Get FileHandle, , .CNAMSize
            .CNAMValue = Space$(.CNAMSize - 1)
            Get FileHandle, , .CNAMValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "ANAM"
            Get FileHandle, , .ANAMSize
            .ANAMValue = Space$(.ANAMSize - 1)
            Get FileHandle, , .ANAMValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "FNAM"
            Get FileHandle, , .FNAMSize
            .FNAMValue = Space$(.FNAMSize - 1)
            Get FileHandle, , .FNAMValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "DNAM"
            Get FileHandle, , .DNAMSize
            .DNAMValue = Space$(.DNAMSize - 1)
            Get FileHandle, , .DNAMValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "NAME"
            Get FileHandle, , .NAMESize
            .NAMEValue = Space$(.NAMESize)
            Get FileHandle, , .NAMEValue
            Get FileHandle, , NextRecordType
        Case "SNAM"
            Get FileHandle, , .SNAMSize
            .SNAMValue = Space$(.SNAMSize - 1)
            Get FileHandle, , .SNAMValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "QSTN"
            Get FileHandle, , .QSTNSize
            Get FileHandle, , .QSTNValue
            Get FileHandle, , NextRecordType
        Case "QSTF"
            Get FileHandle, , .QSTFSize
            Get FileHandle, , .QSTFValue
            Get FileHandle, , NextRecordType
        Case "QSTR"
            Get FileHandle, , .QSTRSize
            Get FileHandle, , .QSTRValue
            Get FileHandle, , NextRecordType
        Case "BNAM"
            Get FileHandle, , .BNAMSize
            .BNAMValue = Space$(.BNAMSize)
            Get FileHandle, , .BNAMValue
            Get FileHandle, , NextRecordType
        Case "SCVR"
            With .SCVR(i)
                Get FileHandle, , .SCVRSize
                Get FileHandle, , .SCVRIndex
                Get FileHandle, , .SCVRType
                Get FileHandle, , .SCVRFunction
                Get FileHandle, , .SCVROperator
                .SCVRValue = Space$(.SCVRSize - 5)
                Get FileHandle, , .SCVRValue
                Get FileHandle, , NextRecordType
                If NextRecordType = "INTV" Then
                    Get FileHandle, , .INTVSize
                    Get FileHandle, , .INTVValue
                    Get FileHandle, , NextRecordType
                ElseIf NextRecordType = "FLTV" Then
                    Get FileHandle, , .FLTVSize
                    Get FileHandle, , .FLTVValue
                    Get FileHandle, , NextRecordType
                End If
            End With
            i = i + 1
        Case "ACDT"
            Get FileHandle, , .ACDTSize
            .ACDTValue = Space$(.ACDTSize - 1)
            Get FileHandle, , .ACDTValue
            Seek FileHandle, Seek(FileHandle) + 1
            Get FileHandle, , NextRecordType
        Case "DELE"
            'Record Deleted. Skip the data.
            Seek FileHandle, Seek(FileHandle) + 8
            Get FileHandle, , NextRecordType
        Case Else
            Exit Do
        End Select
    Loop
End With

End Function

'***************************************************************************
'*                                                                         *
'*                           Main Read Function                            *
'*                                                                         *
'***************************************************************************

Public Function ReadFile(ByVal FileName As String, PBar As ProgressBar, Optional ByRef RecordsRead As Long, Optional ByVal RemoveUnusedElements As Boolean) As Double

Dim i As Long, x As Long, TimeLost As Double
Dim xTime As Double
Dim buffer As String * 4
Dim FileHandle As Integer

xTime = GetTickCount()

If UCase$(Left$(Right$(FileName, 3), 2)) <> "ES" Then
    MsgBox "The selected file is invalid."
    ReadFile = -1
    RecordsRead = 0
    Exit Function
End If

CleanUp

FileHandle = FreeFile

PBar.Min = 0
PBar.Max = 1
Open FileName For Binary As FileHandle

Get FileHandle, , buffer
While EOF(FileHandle) = False
    PBar.Value = Seek(FileHandle) / LOF(FileHandle)
    Select Case buffer
    Case "TES3"
        i = UBound(TES3)
        TES3(i) = ReadTES3(FileHandle, buffer)
        i = i + 1
        ReDim Preserve TES3(i)
    Case "GMST"
        i = UBound(GMST)
        GMST(i) = ReadGMST(FileHandle, buffer)
        i = i + 1
        ReDim Preserve GMST(i)
    Case "GLOB"
        i = UBound(GLOB)
        GLOB(i) = ReadGLOB(FileHandle, buffer)
        i = i + 1
        ReDim Preserve GLOB(i)
    Case "CLAS"
        i = UBound(CLAS)
        CLAS(i) = ReadCLAS(FileHandle, buffer)
        i = i + 1
        ReDim Preserve CLAS(i)
    Case "FACT"
        i = UBound(FACT)
        FACT(i) = ReadFACT(FileHandle, buffer)
        i = i + 1
        ReDim Preserve FACT(i)
    Case "RACE"
        i = UBound(RACE)
        RACE(i) = ReadRACE(FileHandle, buffer)
        i = i + 1
        ReDim Preserve RACE(i)
    Case "SOUN"
        i = UBound(SOUN)
        SOUN(i) = ReadSOUN(FileHandle, buffer)
        i = i + 1
        ReDim Preserve SOUN(i)
    Case "SKIL"
        i = UBound(SKIL)
        SKIL(i) = ReadSKIL(FileHandle, buffer)
        i = i + 1
        ReDim Preserve SKIL(i)
    Case "MGEF"
        i = UBound(MGEF)
        MGEF(i) = ReadMGEF(FileHandle, buffer)
        i = i + 1
        ReDim Preserve MGEF(i)
    Case "SCPT"
        i = UBound(SCPT)
        SCPT(i) = ReadSCPT(FileHandle, buffer)
        i = i + 1
        ReDim Preserve SCPT(i)
    Case "REGN"
        i = UBound(REGN)
        REGN(i) = ReadREGN(FileHandle, buffer)
        i = i + 1
        ReDim Preserve REGN(i)
    Case "BSGN"
        i = UBound(BSGN)
        BSGN(i) = ReadBSGN(FileHandle, buffer)
        i = i + 1
        ReDim Preserve BSGN(i)
    Case "LTEX"
        i = UBound(LTEX)
        LTEX(i) = ReadLTEX(FileHandle, buffer)
        i = i + 1
        ReDim Preserve LTEX(i)
    Case "STAT"
        i = UBound(STAT)
        STAT(i) = ReadSTAT(FileHandle, buffer)
        i = i + 1
        ReDim Preserve STAT(i)
    Case "DOOR"
        i = UBound(DOOR)
        DOOR(i) = ReadDOOR(FileHandle, buffer)
        i = i + 1
        ReDim Preserve DOOR(i)
    Case "MISC"
        i = UBound(MISC)
        MISC(i) = ReadMISC(FileHandle, buffer)
        i = i + 1
        ReDim Preserve MISC(i)
    Case "WEAP"
        i = UBound(WEAP)
        WEAP(i) = ReadWEAP(FileHandle, buffer)
        i = i + 1
        ReDim Preserve WEAP(i)
    Case "CONT"
        i = UBound(CONT)
        CONT(i) = ReadCONT(FileHandle, buffer)
        i = i + 1
        ReDim Preserve CONT(i)
    Case "SPEL"
        i = UBound(SPEL)
        SPEL(i) = ReadSPEL(FileHandle, buffer)
        i = i + 1
        ReDim Preserve SPEL(i)
    Case "ENCH"
        i = UBound(ENCH)
        ENCH(i) = ReadENCH(FileHandle, buffer)
        i = i + 1
        ReDim Preserve ENCH(i)
    Case "BODY"
        i = UBound(BODY)
        BODY(i) = ReadBODY(FileHandle, buffer)
        i = i + 1
        ReDim Preserve BODY(i)
    Case "LIGH"
        i = UBound(LIGH)
        LIGH(i) = ReadLIGH(FileHandle, buffer)
        i = i + 1
        ReDim Preserve LIGH(i)
    Case "ARMO"
        i = UBound(ARMO)
        ARMO(i) = ReadARMO(FileHandle, buffer)
        i = i + 1
        ReDim Preserve ARMO(i)
    Case "CLOT"
        i = UBound(CLOT)
        CLOT(i) = ReadCLOT(FileHandle, buffer)
        i = i + 1
        ReDim Preserve CLOT(i)
    Case "REPA"
        i = UBound(REPA)
        REPA(i) = ReadREPA(FileHandle, buffer)
        i = i + 1
        ReDim Preserve REPA(i)
    Case "ACTI"
        i = UBound(ACTI)
        ACTI(i) = ReadACTI(FileHandle, buffer)
        i = i + 1
        ReDim Preserve ACTI(i)
    Case "APPA"
        i = UBound(APPA)
        APPA(i) = ReadAPPA(FileHandle, buffer)
        i = i + 1
        ReDim Preserve APPA(i)
    Case "LOCK"
        i = UBound(L_CK)
        L_CK(i) = ReadLOCK(FileHandle, buffer)
        i = i + 1
        ReDim Preserve L_CK(i)
    Case "PROB"
        i = UBound(PROB)
        PROB(i) = ReadPROB(FileHandle, buffer)
        i = i + 1
        ReDim Preserve PROB(i)
    Case "INGR"
        i = UBound(INGR)
        INGR(i) = ReadINGR(FileHandle, buffer)
        i = i + 1
        ReDim Preserve INGR(i)
    Case "BOOK"
        i = UBound(BOOK)
        BOOK(i) = ReadBOOK(FileHandle, buffer)
        i = i + 1
        ReDim Preserve BOOK(i)
    Case "ALCH"
        i = UBound(ALCH)
        ALCH(i) = ReadALCH(FileHandle, buffer)
        i = i + 1
        ReDim Preserve ALCH(i)
    Case "LEVI"
        i = UBound(LEVI)
        LEVI(i) = ReadLEVI(FileHandle, buffer)
        i = i + 1
        ReDim Preserve LEVI(i)
    Case "LEVC"
        i = UBound(LEVC)
        LEVC(i) = ReadLEVC(FileHandle, buffer)
        i = i + 1
        ReDim Preserve LEVC(i)
    Case "SNDG"
        i = UBound(SNDG)
        SNDG(i) = ReadSNDG(FileHandle, buffer)
        i = i + 1
        ReDim Preserve SNDG(i)
    Case "SSCR"
        i = UBound(SSCR)
        SSCR(i) = ReadSSCR(FileHandle, buffer)
        i = i + 1
        ReDim Preserve SSCR(i)
    Case "PGRD"
        i = UBound(PGRD)
        PGRD(i) = ReadPGRD(FileHandle, buffer)
        i = i + 1
        ReDim Preserve PGRD(i)
    Case "NPC_"
        i = UBound(NPC_)
        NPC_(i) = ReadNPC_(FileHandle, buffer)
        i = i + 1
        ReDim Preserve NPC_(i)
    Case "CREA"
        i = UBound(CREA)
        CREA(i) = ReadCREA(FileHandle, buffer)
        i = i + 1
        ReDim Preserve CREA(i)
    Case "CELL"
        i = UBound(CELL)
        CELL(i) = ReadCELL(FileHandle, buffer)
        i = i + 1
        ReDim Preserve CELL(i)
    Case "LAND"
        i = UBound(LAND)
        LAND(i) = ReadUnknown(FileHandle, buffer)
        i = i + 1
        ReDim Preserve LAND(i)
    Case "DIAL"
        i = UBound(DIAL)
        DIAL(i) = ReadDIAL(FileHandle, buffer)
        i = i + 1
        ReDim Preserve DIAL(i)
    Case "INFO"
        i = UBound(INFO)
        INFO(i) = ReadINFO(FileHandle, buffer)
        i = i + 1
        ReDim Preserve INFO(i)
    Case "CNTC"
        i = UBound(CNTC)
        CNTC(i) = ReadUnknown(FileHandle, buffer)
        i = i + 1
        ReDim Preserve CNTC(i)
    Case "CREC"
        i = UBound(CREC)
        CREC(i) = ReadUnknown(FileHandle, buffer)
        i = i + 1
        ReDim Preserve CREC(i)
    Case "FMAP"
        i = UBound(FMAP)
        FMAP(i) = ReadUnknown(FileHandle, buffer)
        i = i + 1
        ReDim Preserve FMAP(i)
    Case "GAME"
        i = UBound(GAME)
        GAME(i) = ReadUnknown(FileHandle, buffer)
        i = i + 1
        ReDim Preserve GAME(i)
    Case "JOUR"
        i = UBound(JOUR)
        JOUR(i) = ReadUnknown(FileHandle, buffer)
        i = i + 1
        ReDim Preserve JOUR(i)
    Case "KLST"
        i = UBound(KLST)
        KLST(i) = ReadUnknown(FileHandle, buffer)
        i = i + 1
        ReDim Preserve KLST(i)
    Case "NPCC"
        i = UBound(NPCC)
        NPCC(i) = ReadUnknown(FileHandle, buffer)
        i = i + 1
        ReDim Preserve NPCC(i)
    Case "PCDT"
        i = UBound(PCDT)
        PCDT(i) = ReadUnknown(FileHandle, buffer)
        i = i + 1
        ReDim Preserve PCDT(i)
    Case "QUES"
        i = UBound(QUES)
        QUES(i) = ReadUnknown(FileHandle, buffer)
        i = i + 1
        ReDim Preserve QUES(i)
    Case "REFR"
        i = UBound(REFR)
        REFR(i) = ReadUnknown(FileHandle, buffer)
        i = i + 1
        ReDim Preserve REFR(i)
    Case "SPLM"
        i = UBound(SPLM)
        SPLM(i) = ReadUnknown(FileHandle, buffer)
        i = i + 1
        ReDim Preserve SPLM(i)
    Case "STLN"
        i = UBound(STLN)
        STLN(i) = ReadUnknown(FileHandle, buffer)
        i = i + 1
        ReDim Preserve STLN(i)
    Case Else
        If YesToAll = False Then
            TimeLost = GetTickCount
            x = MsgBox("Unknown record encountered at address: " & (Seek(FileHandle) - 5) & "." & vbCrLf & "Continue reading? Cancel is Yes To All." & vbCrLf & "Record Name: """ & buffer & """", vbYesNoCancel)
            If x = 7 Then
                CleanUp
                Close FileHandle
                Exit Function
            ElseIf x = 2 Then
                YesToAll = True
            End If
            TimeLost = GetTickCount - TimeLost
        End If
        i = UBound(Unknown)
        Unknown(i) = ReadUnknown(FileHandle, buffer, 1)
        i = i + 1
        ReDim Preserve Unknown(i)
    End Select
    RecordsRead = RecordsRead + 1
Wend

Close FileHandle
If RemoveUnusedElements = True Then
    RemovePadding
End If

YesToAll = False
On Error Resume Next
ReadFile = GetTickCount() - xTime - TimeLost

End Function
