Attribute VB_Name = "ESTypes"
Option Explicit

'***************************************************************************
'*                                                                         *
'*                       Subrecord\Helper Types                            *
'*                                                                         *
'***************************************************************************

Public Type Long3Bytes
'3-bytes long, used for FRMR. The last byte is assumed to always be equal to 0.
Byte_01 As Byte
Byte_02 As Byte
Byte_03 As Byte
'Byte_04 As Byte = 00

End Type

'__________________________________________________________________

Public Type LongFlag
'4-byte flag
Flag_01 As Byte
Flag_02 As Byte
Flag_03 As Byte
Flag_04 As Byte

End Type

'__________________________________________________________________

Type ULARGE_INTEGER
'64-bit unsigned integer.
LowPart As Long
HighPart As Long

End Type

'__________________________________________________________________

Public Type ES_ParentFile
'An entry in a usual array of masters(parents) for a file. Variable length.
'MASTName As String * 4   'Constant, MAST
MASTSize As Long
MASTValue As String      'NOTE: Variable length, null-terminated
'Size of the parent
'DATAName As String * 4   'Constant, DATA
DATASize As Long
DATAValue As ULARGE_INTEGER

End Type

'__________________________________________________________________

Public Type ES_FactionRank
'An entry in an optinal array of ranks in a faction. 32 bytes.
'RNAMName As String * 4   'Constant, RNAM
RNAMSize As Long         'Constant, 32
RNAMValue As String * 32

End Type

'__________________________________________________________________

Public Type ES_RankData
'An entry in a usual array of data for each rank in a faction. 20 bytes.
Attribute1 As Long
Attribute2 As Long
FirstSkill As Long
SecondSkill As Long
FactionReputation As Long

End Type

'__________________________________________________________________

Public Type ES_FactionReaction
'An entry in a usual array of faction reactions.
'Faction Name
'ANAMName As String * 4   'Constant, ANAM
ANAMSize As Long
ANAMValue As String
'Reaction Value
'INTVName As String * 4   'Constant, INTV
INTVSize As Long         'Constant, 4
INTVValue As Long        'Actually a 'signed' byte(-128 to 128).

End Type

'__________________________________________________________________

Public Type ES_RacePower
'An entry in a usual array of race powers or abilities.
'NPCSName As String * 4   'Constant, NPCS
NPCSSize As Long         'Constant, 32
NPCSValue As String * 32

End Type

'__________________________________________________________________

Public Type ES_RegionSound
'An entry in a usual array of sounds for a region.
'SNAMName As String * 4   'Constant, SNAM
SNAMSize As Long         'Constant, 33
SNAMSound As String * 32 'Should be trimmed until first Null, after that junk.
SNAMChance As Byte

End Type

'__________________________________________________________________

Public Type ES_ContainerItem
'An entry in a usual array of items in a container.
'NPCOName As String * 4   'Constant, NPCO
NPCOSize As Long         'Constant, 36
NPCOCount As Long
NPCOItem As String * 32

End Type

'__________________________________________________________________

Public Type ES_ContainerSpell
'An entry in a usual array of items in a container.
'NPCSName As String * 4   'Constant, NPCS
NPCSSize As Long         'Constant, 32
NPCSItem As String * 32

End Type

'__________________________________________________________________

Public Type ES_SpellEffect
'An entry in a usual array of spell effects in a spell\enchantment.
'ENAMName As String * 4   'Constant, ENAM
ENAMSize As Long         'Constant, 24
ENAMEffectID As Integer
ENAMSkillID As Byte      '-1 if NA
ENAMAttributeID As Byte  '-1 if NA
ENAMRange As Byte
'Padding(1 - 3) As Byte = Null
ENAMArea As Long
ENAMDuration As Long
ENAMMagnitudeMin As Long
ENAMMagnitudeMax As Long

End Type

'__________________________________________________________________

Public Type ES_BipedPart
'An entry in a usual array of biped parts in an armor\clothing.
'Index(Part type)
'INDXName As String * 4   'Constant, INDX
INDXSize As Long         'Constant, 1
INDXValue As Byte
'Male Part
'BNAMName As String * 4   'Constant, BNAM                          \
BNAMSize As Long         '                                        |-Optional
BNAMValue As String      'Variable length, -NOT- null-terminated  /
'Female Part
'CNAMName As String * 4   'Constant, CNAM                          \
CNAMSize As Long         '                                        |-Optional
CNAMValue As String      'Variable length, -NOT- null-terminated  /

'NOTE: Either CNAM, BNAM, ot both must exist.

End Type

'__________________________________________________________________

Public Type ES_LevItemEntry
'An entry in a usual array of entries in a levelled item list.
'Item ID
'INAMName As String * 4   'Constant, INAM
INAMSize As Long
INAMValue As String      'Variable length, null-terminated
'PC Level
'INTVName As String * 4   'Constant, INTV
INTVSize As Long         'Constant, 2
INTVValue As Integer

End Type

'__________________________________________________________________

Public Type ES_LevCreatEntry
'An entry in a usual array of entries in a levelled creature list.
'Creature ID
'CNAMName As String * 4   'Constant, CNAM
CNAMSize As Long
CNAMValue As String      'Variable length, null-terminated
'PC Level
'INTVName As String * 4   'Constant, INTV
INTVSize As Long         'Constant, 2
INTVValue As Integer

End Type

'__________________________________________________________________

Public Type ES_NPDTSmall
'The 12-bytes version of NPDT(NPC Data) record.
NPDTLevel As Integer
NPDTDisposition As Byte
NPDTUnknown1 As Byte
NPDTRank As Byte
NPDTUnknown2 As Byte
NPDTUnknown3 As Byte
NPDTUnknown4 As Byte
NPDTBarterGold As Long

End Type

'__________________________________________________________________

Public Type ES_NPDTLarge
'The 52-bytes version of NPDT(NPC Data) record.
NPDTLevel As Integer
NPDTStrength As Byte
NPDTIntelligence As Byte
NPDTWillpower As Byte
NPDTAgility As Byte
NPDTSpeed As Byte
NPDTEndurance As Byte
NPDTPersonality As Byte
NPDTLuck As Byte
NPDTSkills(26) As Byte
NPDTReputation1 As Byte
NPDTHealth As Integer
NPDTMagicka As Integer
NPDTFatigue As Integer
NPDTDisposition As Byte
NPDTReputation2 As Byte
NPDTRank As Byte
NPDTUnknown As Byte
NPDTBarterGold As Long

End Type

'__________________________________________________________________

Public Type ES_NPDTVeryLarge
'The 96-bytes version of NPDT(Creature Data) record.
'NPDTName As String * 4    'Constant, NPDT
NPDTSize As Long          '96
NPDTType As Long
NPDTLevel As Long
NPDTStrength As Long
NPDTIntelligence As Long
NPDTWillpower As Long
NPDTAgility As Long
NPDTSpeed As Long
NPDTEndurance As Long
NPDTPersonality As Long
NPDTLuck As Long
NPDTHealth As Long
NPDTMagicka As Long
NPDTFatigue As Long
NPDTSoul As Long
NPDTCombat As Long
NPDTMagic As Long
NPDTStealth As Long
NPDTAtack1Min As Long
NPDTAtack1Max As Long
NPDTAtack2Min As Long
NPDTAtack2Max As Long
NPDTAtack3Min As Long
NPDTAtack3Max As Long
NPDTGold As Long

End Type

'__________________________________________________________________

Public Type ES_Destination
'An entry in an optional array of travel destinations for NPC\Creature.
'NOTE: Optional. Either None, or DODT only, or both.
'Coordinates
'DODTName As String * 4   'Constant, DODT
DODTSize As Long         '24
DODTPosX As Single
DODTPosY As Single
DODTPosZ As Single
DODTRotX As Single
DODTRotY As Single
DODTRotZ As Single
'Cell Name if Interior
'DNAMName As String * 4   'Constant, DNAM
DNAMSize As Long
DNAMValue As String      'NOTE: Variable length, null terminated

End Type

'__________________________________________________________________

Public Type ES_PathGridPoint
'An entry in an optional array of points in a path grid.
'Coordinates
PGRPCoordX As Long
PGRPCoordY As Long
PGRPCoordZ As Long
PGRPUnknown1 As Byte
PGRPConnectCount As Byte
PGRPUnknown2 As Byte
PGRPUnknown3 As Byte

End Type

'__________________________________________________________________

Public Type ES_GridConnection
'An entry in an optional array of connections in a path grid.
'This type is just a Helper for operations on path grids.
StartPoint As Long
EndPoint As Long

End Type

'__________________________________________________________________

Public Type ES_Reference
'An entry in an optional array of references in a cell.
'NOTE: Everything's optional. Make a condition func.
'Index
'FRMRName As String * 4    'Constant, FRMR
FRMRSize As Long          'Constant, 4
FRMRObjIndex As Long3Bytes
FRMRModIndex As Byte
'Item ID
'NAMEName As String * 4    'Constant, NAME
NAMESize As Long
NAMEValue As String       'NOTE: Variable length, null-terminated
'Charge
'XCHGName As String * 4    'Constant, XCHG
XCHGSize As Long          'Constant, 4
XCHGValue As Single
'Scale
'XSCLName As String * 4    'Constant, XSCL
XSCLSize As Long          'Constant, 4
XSCLValue As Single
'Destination Data, only for doors
'DODTName As String * 4    'Constant, DODT
DODTSize As Long          'Constant, 24
DODTPosX As Single
DODTPosY As Single
DODTPosZ As Single
DODTRotX As Single
DODTRotY As Single
DODTRotZ As Single
'Destination Cell name, only doors
'DNAMName As String * 4    'Constant, DNAM
DNAMSize As Long
DNAMValue As String       'NOTE: Variable length, null-terminated
'Lock Level
'FLTVName As String * 4    'Constant, FLTV
FLTVSize As Long          'Constant, 4
FLTVValue As Long
'Key ID
'KNAMName As String * 4    'Constant, KNAM
KNAMSize As Long
KNAMValue As String       'NOTE: Variable length, null-terminated
'Trap ID
'TNAMName As String * 4    'Constant, TNAM
TNAMSize As Long
TNAMValue As String       'NOTE: Variable length, null-terminated
'Reference blocked
'UNAMName As String * 4    'Constant, UNAM
UNAMSize As Long          'Constant, 1
UNAMValue As Byte
'Owner(if person)
'ANAMName As String * 4    'Constant, ANAM
ANAMSize As Long
ANAMValue As String       'NOTE: Variable length, null-terminated
'Owner(if faction)
'CNAMName As String * 4    'Constant, CNAM
CNAMSize As Long
CNAMValue As String       'NOTE: Variable length, null-terminated
'Global variable
'BNAMName As String * 4    'Constant, BNAM
BNAMSize As Long
BNAMValue As String       'NOTE: Variable length, null-terminated
'Number of uses(lockpicks, etc.) or Health(weapons\armor)
'INTVName As String * 4    'Constant, INTV
INTVSize As Long          'Constant, 4
INTVValue As Long
'Rank ID
'INDXName As String * 4    'Constant, INDX
INDXSize As Long          'Constant, 4
INDXValue As Long
'Extra Data existance
'NAM9Name As String * 4    'Constant, NAM9
NAM9Size As Long          'Constant, 4
NAM9Value As Long         'The value is unimportant. If the record exists,
'there's extra data, otherwise no.
'Soul(inside gems)
'XSOLName As String * 4    'Constant, XSOL
XSOLSize As Long
XSOLValue As String       'NOTE: Variable length, null-terminated
'Position\Rotation data
'DATAName As String * 4    'Constant, DATA
DATASize As Long          'Constant, 24
DATAPosX As Single
DATAPosY As Single
DATAPosZ As Single
DATARotX As Single
DATARotY As Single
DATARotZ As Single
'Moved reference Index
'MVRFName As String * 4    'Constant, MVRF
MVRFSize As Long          'Constant, 4
MVRFObjectIndex As Long3Bytes
MVRFModIndex As Byte
'Moved reference origin
'CNDTName As String * 4    'Constant, CNDT
CNDTSize As Long          'Constant, 8
CNDTGridX As Single
CNDTGridY As Single
'Moved reference origin, INTERIOR?
'MVRFCNAMName As String * 4    'Constant, CNAM
MVRFCNAMSize As Long
MVRFCNAMValue As String
'Savegame specific
'Secondary Position\Rotation for Leveled Creatures
'DATA2Name As String * 4    'Constant, DATA
DATA2Size As Long          'Constant, 24
DATA2PosX As Single
DATA2PosY As Single
DATA2PosZ As Single
DATA2RotX As Single
DATA2RotY As Single
DATA2RotZ As Single

RefUnknown() As String

Disabled As Byte
Deleted As Byte
Persistant As Byte

End Type

'__________________________________________________________________

Public Type ES_InfoRequirement
'An entry in an optional array of requrements for a response
'Function
'SCVRName As String * 4    'Constant, SCVR
SCVRSize As Long
SCVRIndex As String * 1
SCVRType As String * 1
SCVRFunction As String * 2
SCVROperator As String * 1
SCVRValue As String       'NOTE: Variable length, not always null-terminated
'Result, integer
'INTVName As String * 4   'Constant, INTV
INTVSize As Long
INTVValue As Long
'Result, float
'FLTVName As String * 4   'Constant, FLTV
FLTVSize As Long
FLTVValue As Long

End Type

'__________________________________________________________________

Public Type ES_TripleCoord
'An entry in a usual array of triple coordinates for each point in a
'LAND record in VNML\VCLR subrecords.
VNMLCoordX As Byte
VNMLCoordY As Byte
VNMLCoordZ As Byte

End Type

'__________________________________________________________________

Public Type ES_AI_W

'AI Wander Settings
'AI_WName As String * 4    'Constant, AI_W                        \
AI_WSize As Long          'Constant, 14                           |
AI_WDistance As Integer   '                                       |
AI_WDuration As Integer   '                                       |-Optional
AI_WTime As Byte          '                                       |
AI_WIdles(7) As Byte      '                                       |
AI_WUnknown As Byte       '                                       /

End Type

'__________________________________________________________________

Public Type ES_AI_T

'AI Travel Settings
'AI_TName As String * 4    'Constant, AI_T                        \
AI_TSize As Long          'Constant, 16                           |
AI_TCoordX As Single      '                                       |_Optional
AI_TCoordY As Single      '                                       |
AI_TCoordZ As Single      '                                       |
AI_TUnknown As Long       '                                       /

End Type

'__________________________________________________________________

Public Type ES_AI_F

'AI Follow Settings
'AI_FName As String * 4    'Constant, AI_F                        \
AI_FSize As Long          'Constant, 48                           |
AI_FCoordX As Single      '                                       |
AI_FCoordY As Single      '                                       |-Optional
AI_FCoordZ As Single      '                                       |
AI_FDuration As Integer   '                                       |
AI_FCharacter As String * 32 '                                    /
AI_FUnknown As Integer
'AI Follow Destination Cell
'CNDTNameF As String * 4    'Constant, CNDT                        \
CNDTSizeF As Long          '                                       |-Optional
CNDTValueF As String       'NOTE: Variable length, null terminated /

End Type

'__________________________________________________________________

Public Type ES_AI_E

'AI Escort Settings
'AI_EName As String * 4    'Constant, AI_E                       \
AI_ESize As Long          'Constant, 48                          |
AI_ECoordX As Single      '                                      |
AI_ECoordY As Single      '                                      |_Optional
AI_ECoordZ As Single      '                                      |
AI_EDuration As Integer   '                                      |
AI_ECharacter As String * 32 'Trim until first null,             |
AI_EUnknown As Integer    '                                      /
'AI Escort Destination Cell
'CNDTNameE As String * 4    'Constant, CNDT                        \
CNDTSizeE As Long          '                                       |-Optional
CNDTValueE As String       'NOTE: Variable length, null terminated /

End Type

'__________________________________________________________________

Public Type ES_AI_A

'AI Activate Settings
'AI_AName As String * 4    'Constant, AI_A                        \
AI_ASize As Long          'Constant, 33                           |
AI_ATarget As String * 32 '                                       |-Optional
AI_AUnknown As Byte       '                                       /

End Type



'***************************************************************************
'*                                                                         *
'*                              Record Types                               *
'*                                                                         *
'***************************************************************************

Public Type ES_TES3
'File Header
'Name As String * 4        'Constant, TES3
Size As Long
UnknownHeader1 As Long
Flag As LongFlag
'File Header misc. info
'HEDRName As String * 4    'Constant, HEDR
HEDRSize As Long          'Constant, 300
HEDRVersion As Single
HEDRFormatFlag As LongFlag
HEDRAuthor As String * 32
HEDRDescript As String * 256
HEDRRecNum As Long
'An array of masters that the file depends on.
MASTArray() As ES_ParentFile
'Savegame-specific data
'GMDTName As String * 4    'Constant, GMDT
GMDTSize As Long          'Constant, 124
GMDTCurHealth As Single
GMDTMaxHealth As Single
GMDTUnknown1 As Single
GMDTDay As Single
GMDTMonth As Single
GMDTYear As Single
GMDTCellName As String * 64
GMDTUnknown2 As Single
GMDTCharacterName As String * 32
'More savegame-specific data
'SCRDName As String * 4    'Constant, SCRD
SCRDSize As Long          'Constant, 20
SCRDValue(19) As Byte
'Screenshot
'SCRSName As String * 4    'Constant, SCRS
SCRSSize As Long          'Constant, 65536
SCRSValue As String

End Type

'__________________________________________________________________

Public Type ES_GMST
'Game Setting
'Name As String * 4        'Constant, GMST
Size As Long
UnknownHeader1 As Long
Flag As LongFlag
'Game Setting ID
'NAMEName As String * 4    'Constant, NAME
NAMESize As Long
NAMEValue As String       'NOTE: Variable size, -NOT- null-terminated
'Game Setting Value if String
'STRVName As String * 4    'Constant, STRV
STRVSize As Long
STRVValue As String       'NOTE: Variable size, -NOT- null-terminated
'Game Setting Value if Integer
'INTVName As String * 4    'Constant, INTV
INTVSize As Long          'Constant, 4
INTVValue As Long
'Game Setting Value if Float
'FLTVName As String * 4    'Constant, FLTV
FLTVSize As Long          'Constant, 4
FLTVValue As Single


End Type

'__________________________________________________________________

Public Type ES_GLOB
'Global Variable
'Name As String * 4        'Constant, GLOB
Size As Long
UnknownHeader1 As Long
Flag As LongFlag
'Global Variable ID
'NAMEName As String * 4    'Constant, NAME
NAMESize As Long
NAMEValue As String       'NOTE: Variable size, null-terminated
'Global Variable Type(s\f\l)
'FNAMName As String * 4    'Constant, FNAM
FNAMSize As Long          'Constant, 1
FNAMValue As String * 1
'Global Variable Value
'FLTVName As String * 4    'Constant, FLTV
FLTVSize As Long          'Constant, 4
FLTVValue As Single       'Should be rounded to <=4 decimal numbers. Best 2.


End Type

'__________________________________________________________________

Public Type ES_CLAS
'Class
'Name As String * 4        'Constant, CLAS
Size As Long
UnknownHeader1 As Long
Flag As LongFlag
'Class ID
'NAMEName As String * 4    'Constant, NAME
NAMESize As Long
NAMEValue As String       'NOTE: Variable size, null-terminated
'Class Name
'FNAMName As String * 4    'Constant, FNAM
FNAMSize As Long
FNAMValue As String       'NOTE: Variable size, null-terminated
'Class Data
'CLDTName As String * 4    'Constant, CLDT
CLDTSize As Long          'Constant, 60
CLDTAttributeID1 As Long
CLDTAttributeID2 As Long
CLDTSpecialization As Long
CLDTMinorID1 As Long
CLDTMajorID1 As Long
CLDTMinorID2 As Long
CLDTMajorID2 As Long
CLDTMinorID3 As Long
CLDTMajorID3 As Long
CLDTMinorID4 As Long
CLDTMajorID4 As Long
CLDTMinorID5 As Long
CLDTMajorID5 As Long
CLDTPlayable As Byte
'Padding(1-3) As Byte = Null
CLDTAutoCalcFlags As Long
'Class Description
'DESCName As String * 4    'Constant, DESC
DESCSize As Long
DESCValue As String       'NOTE: Variable size, -NOT- null-terminated

End Type

'__________________________________________________________________

Public Type ES_FACT
'Faction
'Name As String * 4        'Constant, FACT
Size As Long
UnknownHeader1 As Long
Flag As LongFlag
'Faction ID
'NAMEName As String * 4    'Constant, NAME
NAMESize As Long
NAMEValue As String       'NOTE: Variable size, null-terminated
'Faction Name
'FNAMName As String * 4    'Constant, FNAM
FNAMSize As Long
FNAMValue As String       'NOTE: Variable size, null-terminated
'Rank Array
RankArray(9) As ES_FactionRank 'Size: 32*X; X<=10
'Faction Data
'FADTName As String * 4    'Constant, FADT
FADTSize As Long          'Constant, 240
'Favoured Attributes
FADTAttributeID1 As Long
FADTAttributeID2 As Long
'Skill requirements for Ranks. Always appears 10 times
FADTRankData(9) As ES_RankData 'All always exist.
'Favoured Skills
FADTSkillID1 As Long
FADTSkillID2 As Long
FADTSkillID3 As Long
FADTSkillID4 As Long
FADTSkillID5 As Long
FADTSkillID6 As Long
'Unknown value
FADTUnknown1 As Long
'Hidden from PC
FADTHiddenFlag As LongFlag
'Faction reactions
ReactionsArray() As ES_FactionReaction


End Type

'__________________________________________________________________

Public Type ES_RACE
'Race
'Name As String * 4        'Constant, RACE
Size As Long
UnknownHeader1 As Long
Flag As LongFlag
'Race ID
'NAMEName As String * 4    'Constant, NAME
NAMESize As Long
NAMEValue As String       'NOTE: Variable size, null-terminated
'Race Name
'FNAMName As String * 4    'Constant, FNAM
FNAMSize As Long
FNAMValue As String       'NOTE: Variable size, null-terminated
'Race Data
'RADTNAme As String * 4    'Constant, RADT
RADTSize As Long          'Constant, 140
'Skill IDs-Bonuses pairs
RADTSkillID1 As Long
RADTSkillBonus1 As Long
RADTSkillID2 As Long
RADTSkillBonus2 As Long
RADTSkillID3 As Long
RADTSkillBonus3 As Long
RADTSkillID4 As Long
RADTSkillBonus4 As Long
RADTSkillID5 As Long
RADTSkillBonus5 As Long
RADTSkillID6 As Long
RADTSkillBonus6 As Long
RADTSkillID7 As Long
RADTSkillBonus7 As Long
'Attributes Bonuses Male-Female pairs
RADTStrengthMale As Long
RADTStrengthFemale As Long
RADTIntelligenceMale As Long
RADTIntelligenceFemale As Long
RADTWillpowerMale As Long
RADTWillpowerFemale As Long
RADTAgilityMale As Long
RADTAgilityFemale As Long
RADTSpeedMale As Long
RADTSpeedFemale As Long
RADTEnduranceMale As Long
RADTEnduranceFemale As Long
RADTPersonalityMale As Long
RADTPersonalityFemale As Long
RADTLuckMale As Long
RADTLuckFemale As Long
'Height\Weight
RADTHeightMale As Single
RADTHeightFemale As Single
RADTWeightMale As Single
RADTWeightFemale As Single
'Playable\Beast flag
RADTFlags As Long
'Powers\Abilities
NPCS() As ES_RacePower
'Race description
'DESCName As String * 4    'Constant, DESC
DESCSize As Long
DESCValue As String       'NOTE: Variable length, -NOT- null-terminated


End Type

'__________________________________________________________________

Public Type ES_SOUN
'Sound
'Name As String * 4        'Constant, SOUN
Size As Long
UnknownHeader1 As Long
Flag As LongFlag
'Sound ID
'NAMEName As String * 4    'Constant, NAME
NAMESize As Long
NAMEValue As String       'NOTE: Variable length, null-terminated
'Sound filename\path relative to the "Sounds" directory.
'FNAMName As String * 4    'Constant, FNAM
FNAMSize As Long
FNAMValue As String       'NOTE: Variable length, null-terminated
'Sound misc. data
'DATAName As String * 4    'Constant, DATA
DATASize As Long          'Constant, 3
DATAVolume As Byte        'TESCS converts this to a float between 0 and 1
DATAMinRange As Byte
DATAMaxRange As Byte


End Type
'__________________________________________________________________

Public Type ES_SKIL
'Skill
'Name As String * 4        'Constant, SKIL
Size As Long
UnknownHeader1 As Long
Flag As LongFlag
'Skill Id\Index
'INDXName As String * 4    'Constant, INDX
INDXSize As Long          'Constant, 4
INDXValue As Long         'Ranges from 0 to 26
'Skill game data:
'SKDTName As String * 4    'Constant, SKDT
SKDTSize As Long
SKDTAttibute As Long
SKDTSpecialization As Long '0 = Combat; 1 = Magic; 2 = Stealth
'Use Value, hard-coded
SKDTUseValue1 As Long
SKDTUseValue2 As Long
SKDTUseValue3 As Long
SKDTUseValue4 As Long
'Skill description
'DESCName As String * 4    'Constant, DESC
DESCSize As Long
DESCValue As String       'NOTE: Variable length, -NOT- null-terminated
'A note about skills: Their actual names which you see ingame are encoded
'in GMSTs, and can not be changed directly from this record.


End Type
'__________________________________________________________________

Public Type ES_MGEF
'Magic Effect
'Name As String * 4        'Constant, MGEF
Size As Long
UnknownHeader1 As Long
Flag As LongFlag
'Magic Effect Id\Index
'INDXName As String * 4    'Constant, INDX
INDXSize As Long          'Constant, 4
INDXValue As Long         'Ranges from 0 to 140. 137 in MW, 1 in TB, 3 in BM
'Magic Effect game data:
'MEDTName As String * 4    'Constant, MEDT
MEDTSize As Long          'Constant, 36
MEDTSchool As Long
MEDTBaseCost As Long
MEDTFlags As Long
'Magic Effect Colour
MEDTRed As Long
MEDTBlue As Long
MEDTGreen As Long
'Visual settings
MEDTSpeedX As Single
MEDTSizeX As Single
MEDTSizeCap As Single
'Magic Effect icon
'ITEXName As String * 4    'Constant, ITEX
ITEXSize As Long
ITEXValue As String       'NOTE: Variable length, null-terminated
'Magic Effect particle texture
'PTEXName As String * 4    'Constant, PTEX
PTEXSize As Long
PTEXValue As String       'NOTE: Variable length, null-terminated
'Sounds, optional. If not specified the default sound for the schools is used.
'BSNDName As String * 4    'Constant, BSND
BSNDSize As Long
BSNDValue As String       'NOTE: Variable length, null-terminated
'CSNDName As String * 4    'Constant, CSND
CSNDSize As Long
CSNDValue As String       'NOTE: Variable length, null-terminated
'HSNDName As String * 4    'Constant, HSND
HSNDSize As Long
HSNDValue As String       'NOTE: Variable length, null-terminated
'ASNDName As String * 4    'Constant, ASND
ASNDSize As Long
ASNDValue As String       'NOTE: Variable length, null-terminated
'Casting Visual
'CVFXName As String * 4    'Constant, CVFX
CVFXSize As Long
CVFXValue As String       'NOTE: Variable length, null-terminated
'Bolt Visual
'BVFXName As String * 4    'Constant, BVFX
BVFXSize As Long
BVFXValue As String       'NOTE: Variable length, null-terminated
'Hit Visual
'HVFXName As String * 4    'Constant, HVFX
HVFXSize As Long
HVFXValue As String       'NOTE: Variable length, null-terminated
'Area Visual
'AVFXName As String * 4    'Constant, AVFX
AVFXSize As Long
AVFXValue As String       'NOTE: Variable length, null-terminated
'Magic Effect description
'DESCName As String * 4    'Constant, DESC
DESCSize As Long
DESCValue As String       'NOTE: Variable length, -NOT- null-terminated


End Type
'__________________________________________________________________

Public Type ES_SCPT
'Script
'Name As String * 4        'Constant, SCPT
Size As Long
UnknownHeader1 As Long
Flag As LongFlag
'Script header
'SCHDName As String * 4    'Constant, SCHD
SCHDSize As Long          'Constant, 52
SCHDScriptName As String * 32
SCHDNumShorts As Long
SCHDNumLongs As Long
SCHDNumFloats As Long
SCHDCodeSize As Long
SCHDLocalSize As Long
'Local Variables
'SCVRName As String * 4   'Constant, SCVR                       \
SCVRSize As Long          '                                     |
SCVRShorts() As String    'Array of short vars, split by Null   |-Optional
SCVRLongs() As String     'Array of long vars, split by Null    |
SCVRFloats() As String    'Array of float vars, split by Null   /
'Compiled script DATA
'SCDTName As String * 4    'Constant, SCDT
SCDTSize As Long
SCDTValue As String       'NOTE: Variable length, -NOT- null-terminated
'Actually not a string but code. Right now there's no reason to decode it.
'Script Text
'SCTXName As String * 4    'Constant, SCTX
SCTXSize As Long
SCTXValue As String       'NOTE: Variable length, -NOT- null-terminated
'Savegame specific data
'Script running
'RNAMName As String * 4    'Constant, RNAM
RNAMSize As Long
RNAMValue As String
'Short variables values
'SLSDName As String * 4    'Constant, SLSD
SLSDSize As Long
SLSDValue() As Integer
'Float variables value
'SLFDName As String * 4    'Constant, SLFD
SLFDSize As Long
SLFDValue() As Single
'???
'SLCSName As String * 4    'Constant, SLCS
SLCSSize As Long
SLCSValue As String

End Type
'__________________________________________________________________

Public Type ES_REGN
'Region
'Name As String * 4        'Constant, REGN
Size As Long
UnknownHeader1 As Long
Flag As LongFlag
'Region ID
'NAMEName As String * 4    'Constant, NAME
NAMESize As Long
NAMEValue As String       'NOTE: Variable length, null-terminated
'Region Name
'FNAMName As String * 4    'Constant, FNAM
FNAMSize As Long
FNAMValue As String       'NOTE: Variable length, null-terminated
'Weather Chances
'WEATName As String * 4    'Constant, WEAT
WEATSize As Long
WEATChances() As Byte     'Variable length. With BM = 10 bytes. Otherwise 8.
'Sleep Creture LevList
'BNAMName As String * 4    'Constant, BNAM
BNAMSize As Long
BNAMValue As String       'NOTE: Variable length, null-terminated
'Creature levelled list from which creatures that wake you up are taken.
'Map color
'CNAMName As String * 4    'Constant, CNAM
CNAMSize As Long
CNAMRed As Byte
CNAMGreen As Byte
CNAMBlue As Byte
'Padding As Byte = Null
SNAM() As ES_RegionSound
'Current weather, savegame-specific
'WNAMName As String * 4    'Constant, WNAM
WNAMSize As Long          'Constant, 4
WNAMValue As Long

End Type
'__________________________________________________________________

Public Type ES_BSGN
'Birthsign
'Name As String * 4        'Constant, BSGN
Size As Long
UnknownHeader1 As Long
Flag As LongFlag
'Birthsign ID
'NAMEName As String * 4    'Constant, NAME
NAMESize As Long
NAMEValue As String       'NOTE: Variable length, null-terminated
'Birthsign Name
'FNAMName As String * 4    'Constant, FNAM
FNAMSize As Long
FNAMValue As String       'NOTE: Variable length, null-terminated
'Birthsign Picure\Texture filename
'TNAMName As String * 4    'Constant, TNAM
TNAMSize As Long
TNAMValue As String       'NOTE: Variable length, null-terminated
'Birthsign descriotion
'DESCName As String * 4    'Constant, DESC
DESCSize As Long
DESCValue As String       'NOTE: Variable length, null-terminated
'Birthsign Powers\Abilities
NPCS() As ES_RacePower


End Type
'__________________________________________________________________

Public Type ES_LTEX
'Land texture
'Name As String * 4        'Constant, LTEX
Size As Long
UnknownHeader1 As Long
Flag As LongFlag
'Land texture ID
'NAMEName As String * 4    'Constant, NAME
NAMESize As Long
NAMEValue As String       'NOTE: Variable length, null-terminated
'Land texture Index
'INTVName As String * 4    'Constant, INTV
INTVSize As Long          'Constant, 4
INTVValue As Long
'Land texture filename
'DATAName As String * 4    'Constant, DATA
DATASize As Long
DATAValue As String       'NOTE: Variable length, null-terminated


End Type
'__________________________________________________________________

Public Type ES_STAT
'Static object
'Name As String * 4        'Constant, STAT
Size As Long
UnknownHeader1 As Long
Flag As LongFlag
'Static ID
'NAMEName As String * 4    'Constant, NAME
NAMESize As Long
NAMEValue As String       'NOTE: Variable length, null-terminated
'Static NIF model
'MODLName As String * 4    'Constant, MODL
MODLSize As Long
MODLValue As String       'NOTE: Variable length, null-terminated


End Type
'__________________________________________________________________

Public Type ES_DOOR
'Door
'Name As String * 4        'Constant, DOOR
Size As Long
UnknownHeader1 As Long
Flag As LongFlag
'Door ID
'NAMEName As String * 4    'Constant, NAME
NAMESize As Long
NAMEValue As String       'NOTE: Variable length, null-terminated
'Door NIF model
'MODLName As String * 4    'Constant, MODL
MODLSize As Long
MODLValue As String       'NOTE: Variable length, null-terminated
'Door Name
'FNAMName As String * 4    'Constant, FNAM                         \
FNAMSize As Long          '                                        |-Optional
FNAMValue As String       'NOTE: Variable length, null-terminated  /
'Attached script
'SCRIName As String * 4    'Constant, SCRI                         \
SCRISize As Long          '                                        |-Optional
SCRIValue As String       'NOTE: Variable length, null-terminated  /
'Opening door sound
'SNAMName As String * 4    'Constant, SNAM                         \
SNAMSize As Long          '                                        |-Optional
SNAMValue As String       'NOTE: Variable length, null-terminated  /
'Closing door sound
'ANAMName As String * 4    'Constant, ANAM                         \
ANAMSize As Long          '                                        |-Optional
ANAMValue As String       'NOTE: Variable length, null-terminated  /


End Type
'__________________________________________________________________

Public Type ES_MISC
'Misc. item
'Name As String * 4        'Constant, MISC
Size As Long
UnknownHeader1 As Long
Flag As LongFlag
'Misc. item ID
'NAMEName As String * 4    'Constant, NAME
NAMESize As Long
NAMEValue As String       'NOTE: Variable length, null-terminated
'Misc. item NIF model
'MODLName As String * 4    'Constant, MODL
MODLSize As Long
MODLValue As String       'NOTE: Variable length, null-terminated
'Misc. item Name
'FNAMName As String * 4    'Constant, FNAM                         \
FNAMSize As Long          '                                        |-Optional
FNAMValue As String       'NOTE: Variable length, null-terminated  /
'Misc data
'MCDTName As String * 4    'Constant, MCDT
MCDTSize As Long          'Constant, 12
MCDTWeight As Single
MCDTValue As Long
MCDTUnknown1 As Long      'Usually 0, must check...
'Attached script
'SCRIName As String * 4    'Constant, SCRI                         \
SCRISize As Long          '                                        |-Optional
SCRIValue As String       'NOTE: Variable length, null-terminated  /
'Icon
'ITEXName As String * 4    'Constant, ITEX                         \
ITEXSize As Long          '                                        |-Optional
ITEXValue As String       'NOTE: Variable length, null-terminated  /


End Type
'__________________________________________________________________

Public Type ES_WEAP
'Weapon
'Name As String * 4        'Constant, WEAP
Size As Long
UnknownHeader1 As Long
Flag As LongFlag
'Weapon ID
'NAMEName As String * 4    'Constant, NAME
NAMESize As Long
NAMEValue As String       'NOTE: Variable length, null-terminated
'Weapon NIF model
'MODLName As String * 4    'Constant, MODL
MODLSize As Long
MODLValue As String       'NOTE: Variable length, null-terminated
'Weapon Name
'FNAMName As String * 4    'Constant, FNAM                         \
FNAMSize As Long          '                                        |-Optional
FNAMValue As String       'NOTE: Variable length, null-terminated  /
'Weapon data
'WPDTName As String * 4    'Constant, WPDT
WPDTSize As Long          'Constant, 32
WPDTWeight As Single
WPDTValue As Long
WPDTType As Integer
WPDTHealth As Integer
WPDTSpeed As Single
WPDTReach As Single
WPDTEnchPoints As Integer
WPDTChopMin As Byte
WPDTChopMax As Byte
WPDTSlashMin As Byte
WPDTSlashMax As Byte
WPDTThrustMin As Byte
WPDTThrustMax As Byte
WPDTFlags As Byte
'Padding as Byte(1-3) = Null
'Attached script
'SCRIName As String * 4    'Constant, SCRI                         \
SCRISize As Long          '                                        |-Optional
SCRIValue As String       'NOTE: Variable length, null-terminated  /
'Icon
'ITEXName As String * 4    'Constant, ITEX                         \
ITEXSize As Long          '                                        |-Optional
ITEXValue As String       'NOTE: Variable length, null-terminated  /
'Enchantment
'ENAMName As String * 4    'Constant, ENAM                         \
ENAMSize As Long          '                                        |-Optional
ENAMValue As String       'NOTE: Variable length, null-terminated  /


End Type
'__________________________________________________________________

Public Type ES_CONT
'Container
'Name As String * 4        'Constant, CONT
Size As Long
UnknownHeader1 As Long
Flag As LongFlag
'Container ID
'NAMEName As String * 4    'Constant, NAME
NAMESize As Long
NAMEValue As String       'NOTE: Variable length, null-terminated
'Container NIF model
'MODLName As String * 4    'Constant, MODL
MODLSize As Long
MODLValue As String       'NOTE: Variable length, null-terminated
'Container Name
'FNAMName As String * 4    'Constant, FNAM                         \
FNAMSize As Long          '                                        |-Optional
FNAMValue As String       'NOTE: Variable length, null-terminated  /
'Attached Script
'SCRIName As String * 4    'Constant, SCRI                         \
SCRISize As Long          '                                        |-Optional
SCRIValue As String       'NOTE: Variable length, null-terminated  /
'Container Data
'CNDTName As String * 4    'Constant, CNDT
CNDTSize As Long          'Constant, 4
CNDTWeight As Long
'Savegame-specific. Unknown
'INDXName As String * 4    'Constant, INDX
INDXSize As Long          'Constant, 4
INDXValue As Long
'Container Flags
'FLAGName As String * 4    'Constant, FLAG
FLAGSize As Long          'Constant, 4
FLAGFlag As Byte
'Padding(1 - 3) As Byte = Null
NPCO() As ES_ContainerItem '-Optional


End Type
'__________________________________________________________________

Public Type ES_SPEL
'Spell
'Name As String * 4        'Constant, SPEL
Size As Long
UnknownHeader1 As Long
Flag As LongFlag
'Spell ID
'NAMEName As String * 4    'Constant, NAME
NAMESize As Long
NAMEValue As String       'NOTE: Variable length, null-terminated
'Spell Name
'FNAMName As String * 4    'Constant, FNAM                         \
FNAMSize As Long          '                                        |-Optional
FNAMValue As String       'NOTE: Variable length, null-terminated  /
'Spell Data
'SPDTName As String * 4    'Constant, SPDT
SPDTSize As Long          'Constant, 12
SPDTType As Long
SPDTCost As Long
SPDTFlags As Byte
'Padding(1 - 3) As Byte = Null
ENAM(7) As ES_SpellEffect '-Optional


End Type
'__________________________________________________________________

Public Type ES_ENCH
'Enchantment
Name As String * 4        'Constant, ENCH
Size As Long
UnknownHeader1 As Long
Flag As LongFlag
'Enchantment ID
'NAMEName As String * 4    'Constant, NAME
NAMESize As Long
NAMEValue As String       'NOTE: Variable length, null-terminated
'Spell Data
'ENDTName As String * 4    'Constant, ENDT
ENDTSize As Long          'Constant, 16
ENDTType As Long
ENDTCost As Long
ENDTCharge As Long
ENDTAutoCalc As Byte
'Padding(1 - 3) As Byte = Null
ENAM(7) As ES_SpellEffect '-Optional


End Type
'__________________________________________________________________

Public Type ES_BODY
'Body part
Name As String * 4        'Constant, BODY
Size As Long
UnknownHeader1 As Long
Flag As LongFlag
'Bodypart ID
'NAMEName As String * 4    'Constant, NAME
NAMESize As Long
NAMEValue As String       'NOTE: Variable length, null-terminated
'Bodypart NIF model
'MODLName As String * 4    'Constant, MODL
MODLSize As Long
MODLValue As String       'NOTE: Variable length, null-terminated
'Bodypart Race name, even if clothing\armor
'FNAMName As String * 4    'Constant, FNAM
FNAMSize As Long
FNAMValue As String       'NOTE: Variable length, null-terminated
'Bodypart Data
'BYDTName As String * 4    'Constant, BYDT
BYDTSize As Long          'Constant, 4
BYDTPart As Byte
BYDTVampire As Byte
BYDTFlags As Byte
BYDTType As Byte

End Type
'__________________________________________________________________

Public Type ES_LIGH
'Light
'Name As String * 4        'Constant, LIGH
Size As Long
UnknownHeader1 As Long
Flag As LongFlag
'Light ID
'NAMEName As String * 4    'Constant, NAME
NAMESize As Long
NAMEValue As String       'NOTE: Variable length, null-terminated
'Light NIF model
'MODLName As String * 4    'Constant, MODL
MODLSize As Long
MODLValue As String       'NOTE: Variable length, null-terminated
'Light Name
'FNAMName As String * 4    'Constant, FNAM                         \
FNAMSize As Long          '                                        |-Optional
FNAMValue As String       'NOTE: Variable length, null-terminated  /
'Light Icon
'ITEXName As String * 4    'Constant, ITEX                         \
ITEXSize As Long          '                                        |-Optional
ITEXValue As String       'NOTE: Variable length, null-terminated  /
'Light Data
'LHDTName As String * 4    'Constant, LHDT
LHDTSize As Long          'Constant, 24
LHDTWeight As Single
LHDTValue As Long
LHDTTime As Single
LHDTRadius As Long
LHDTRed As Byte
LHDTGreen As Byte
LHDTBlue As Byte
'Padding As Byte = Null
LHDTFlags As Long
'Attached script
'SCRIName As String * 4    'Constant, SCRI                         \
SCRISize As Long          '                                        |-Optional
SCRIValue As String       'NOTE: Variable length, null-terminated  /
'Light sound
'SNAMName As String * 4    'Constant, SNAM                         \
SNAMSize As Long          '                                        |-Optional
SNAMValue As String       'NOTE: Variable length, null-terminated  /


End Type
'__________________________________________________________________

Public Type ES_ARMO
'Armors
'Name As String * 4        'Constant, ARMO
Size As Long
UnknownHeader1 As Long
Flag As LongFlag
'Armor ID
'NAMEName As String * 4    'Constant, NAME
NAMESize As Long
NAMEValue As String       'NOTE: Variable length, null-terminated
'Armor World NIF model
'MODLName As String * 4    'Constant, MODL
MODLSize As Long
MODLValue As String       'NOTE: Variable length, null-terminated
'Armor Name
'FNAMName As String * 4    'Constant, FNAM
FNAMSize As Long
FNAMValue As String       'NOTE: Variable length, null-terminated
'Attached script
'SCRIName As String * 4    'Constant, SCRI                         \
SCRISize As Long          '                                        |-Optional
SCRIValue As String       'NOTE: Variable length, null-terminated  /
'Armor Data
'AODTName As String * 4    'Constant, AODT
AODTSize As Long          'Constant, 24
AODTType As Long
AODTWeight As Single
AODTValue As Long
AODTHealth As Long
AODTEnchPoints As Long
AODTArmorRating As Long
'Armor Icon
'ITEXName As String * 4    'Constant, ITEX                         \
ITEXSize As Long          '                                        |-Optional
ITEXValue As String       'NOTE: Variable length, null-terminated  /

BipedParts(6) As ES_BipedPart '                                    |-Optional

'Enchantment
'ENAMName As String * 4    'Constant, ENAM                         \
ENAMSize As Long          '                                        |-Optional
ENAMValue As String       'NOTE: Variable length, null-terminated  /


End Type
'__________________________________________________________________

Public Type ES_CLOT
'Clothing item
'Name As String * 4        'Constant, CLOT
Size As Long
UnknownHeader1 As Long
Flag As LongFlag
'Clothing ID
'NAMEName As String * 4    'Constant, NAME
NAMESize As Long
NAMEValue As String       'NOTE: Variable length, null-terminated
'Clothing World NIF model
'MODLName As String * 4    'Constant, MODL
MODLSize As Long
MODLValue As String       'NOTE: Variable length, null-terminated
'Clothing Name
'FNAMName As String * 4    'Constant, FNAM                         \
FNAMSize As Long          '                                        |-Optional
FNAMValue As String       'NOTE: Variable length, null-terminated  /
'Clothing Data
'CTDTName As String * 4    'Constant, CTDT
CTDTSize As Long          'Constant, 12
CTDTType As Long
CTDTWeight As Single
CTDTValue As Integer
CTDTEnchPoints As Integer
'Clothing script
'SCRIName As String * 4    'Constant, SCRI                         \
SCRISize As Long          '                                        |-Optional
SCRIValue As String       'NOTE: Variable length, null-terminated  /
'Clothing Icon
'ITEXName As String * 4    'Constant, ITEX                         \
ITEXSize As Long          '                                        |-Optional
ITEXValue As String       'NOTE: Variable length, null-terminated  /

BipedParts(6) As ES_BipedPart '                                    |-Optional

'Enchantment
'ENAMName As String * 4    'Constant, ENAM                         \
ENAMSize As Long          '                                        |-Optional
ENAMValue As String       'NOTE: Variable length, null-terminated  /


End Type
'__________________________________________________________________

Public Type ES_REPA
'Repair item
'Name As String * 4        'Constant, REPA
Size As Long
UnknownHeader1 As Long
Flag As LongFlag
'Repair item ID
'NAMEName As String * 4    'Constant, NAME
NAMESize As Long
NAMEValue As String       'NOTE: Variable length, null-terminated
'Repair item NIF model
'MODLName As String * 4    'Constant, MODL
MODLSize As Long
MODLValue As String       'NOTE: Variable length, null-terminated
'Repair item Name
'FNAMName As String * 4    'Constant, FNAM                         \
FNAMSize As Long          '                                        |-Optional
FNAMValue As String       'NOTE: Variable length, null-terminated  /
'Repair item data
'RIDTName As String * 4    'Constant, RIDT
RIDTSize As Long          'Constant, 16
RIDTWeight As Single
RIDTValue As Long
RIDTUses As Long
RIDTQuality As Single
'Attached script
'SCRIName As String * 4    'Constant, SCRI                         \
SCRISize As Long          '                                        |-Optional
SCRIValue As String       'NOTE: Variable length, null-terminated  /
'Repair item Icon
'ITEXName As String * 4    'Constant, ITEX                         \
ITEXSize As Long          '                                        |-Optional
ITEXValue As String       'NOTE: Variable length, null-terminated  /


End Type
'__________________________________________________________________

Public Type ES_ACTI
'Activator
'Name As String * 4        'Constant, ACTI
Size As Long
UnknownHeader1 As Long
Flag As LongFlag
'Activator ID
'NAMEName As String * 4    'Constant, NAME
NAMESize As Long
NAMEValue As String       'NOTE: Variable length, null-terminated
'Activator NIF model
'MODLName As String * 4    'Constant, MODL
MODLSize As Long
MODLValue As String       'NOTE: Variable length, null-terminated
'Activator Name
'FNAMName As String * 4    'Constant, FNAM
FNAMSize As Long
FNAMValue As String       'NOTE: Variable length, null-terminated
'Attached script
'SCRIName As String * 4    'Constant, SCRI                         \
SCRISize As Long          '                                        |-Optional
SCRIValue As String       'NOTE: Variable length, null-terminated  /


End Type
'__________________________________________________________________

Public Type ES_APPA
'Apparatus
'Name As String * 4        'Constant, APPA
Size As Long
UnknownHeader1 As Long
Flag As LongFlag
'Apparatus ID
'NAMEName As String * 4    'Constant, NAME
NAMESize As Long
NAMEValue As String       'NOTE: Variable length, null-terminated
'Apparatus NIF model
'MODLName As String * 4    'Constant, MODL
MODLSize As Long
MODLValue As String       'NOTE: Variable length, null-terminated
'Apparatus Name
'FNAMName As String * 4    'Constant, FNAM
FNAMSize As Long
FNAMValue As String       'NOTE: Variable length, null-terminated
'Attached script
'SCRIName As String * 4    'Constant, SCRI                         \
SCRISize As Long          '                                        |-Optional
SCRIValue As String       'NOTE: Variable length, null-terminated  /
'Apparatus data
'AADTName As String * 4    'Constant, AADT
AADTSize As Long          'Constant, 16
AADTType As Long
AADTQuality As Single
AADTWeight As Single
AADTValue As Long
'Apparatus Icon
'ITEXName As String * 4    'Constant, ITEX                         \
ITEXSize As Long          '                                        |-Optional
ITEXValue As String       'NOTE: Variable length, null-terminated  /


End Type
'_________________________________________________________________

Public Type ES_LOCK
'Lockpick
'Name As String * 4        'Constant, LOCK
Size As Long
UnknownHeader1 As Long
Flag As LongFlag
'Lockpick ID
'NAMEName As String * 4    'Constant, NAME
NAMESize As Long
NAMEValue As String       'NOTE: Variable length, null-terminated
'Lockpick NIF model
'MODLName As String * 4    'Constant, MODL
MODLSize As Long
MODLValue As String       'NOTE: Variable length, null-terminated
'Lockpick name
'FNAMName As String * 4    'Constant, FNAM                         \
FNAMSize As Long          '                                        |-Optional
FNAMValue As String       'NOTE: Variable length, null-terminated  /
'Lockpick data
'LKDTName As String * 4    'Constant, LKDT
LKDTSize As Long          'Constant, 16
LKDTWeight As Single
LKDTValue As Long
LKDTQuality As Single
LKDTUses As Long
'Attached script
'SCRIName As String * 4    'Constant, SCRI                         \
SCRISize As Long          '                                        |-Optional
SCRIValue As String       'NOTE: Variable length, null-terminated  /
'Lockpick Icon
'ITEXName As String * 4    'Constant, ITEX                         \
ITEXSize As Long          '                                        |-Optional
ITEXValue As String       'NOTE: Variable length, null-terminated  /


End Type
'_________________________________________________________________

Public Type ES_PROB
'Probe
'Name As String * 4        'Constant, PROB
Size As Long
UnknownHeader1 As Long
Flag As LongFlag
'Probe ID
'NAMEName As String * 4    'Constant, NAME
NAMESize As Long
NAMEValue As String       'NOTE: Variable length, null-terminated
'Probe NIF model
'MODLName As String * 4    'Constant, MODL
MODLSize As Long
MODLValue As String       'NOTE: Variable length, null-terminated
'Probe Name
'FNAMName As String * 4    'Constant, FNAM                         \
FNAMSize As Long          '                                        |-Optional
FNAMValue As String       'NOTE: Variable length, null-terminated  /
'Probe data
'PBDTName As String * 4    'Constant, PBDT
PBDTSize As Long          'Constant, 16
PBDTWeight As Single
PBDTValue As Long
PBDTQuality As Single
PBDTUses As Long
'Attached script
'SCRIName As String * 4    'Constant, SCRI                         \
SCRISize As Long          '                                        |-Optional
SCRIValue As String       'NOTE: Variable length, null-terminated  /
'Probe Icon
'ITEXName As String * 4    'Constant, ITEX                         \
ITEXSize As Long          '                                        |-Optional
ITEXValue As String       'NOTE: Variable length, null-terminated  /


End Type
'_________________________________________________________________

Public Type ES_INGR
'Ingredient
'Name As String * 4        'Constant, INGR
Size As Long
UnknownHeader1 As Long
Flag As LongFlag
'Ingredient ID
'NAMEName As String * 4    'Constant, NAME
NAMESize As Long
NAMEValue As String       'NOTE: Variable length, null-terminated
'Ingredient NIF model
'MODLName As String * 4    'Constant, MODL
MODLSize As Long
MODLValue As String       'NOTE: Variable length, null-terminated
'Ingredient Name
'FNAMName As String * 4    'Constant, FNAM                         \
FNAMSize As Long          '                                        |-Optional
FNAMValue As String       'NOTE: Variable length, null-terminated  /
'Ingredient data
'IRDTName As String * 4    'Constant, IRDT
IRDTSize As Long          'Constant, 56
IRDTWeight As Single
IRDTValue As Long
IRDTEffectID(3) As Long
IRDTSkillID(3) As Long
IRDTAttributeID(3) As Long
'Attached script
'SCRIName As String * 4    'Constant, SCRI                         \
SCRISize As Long          '                                        |-Optional
SCRIValue As String       'NOTE: Variable length, null-terminated  /
'Ingredient Icon
'ITEXName As String * 4    'Constant, ITEX                         \
ITEXSize As Long          '                                        |-Optional
ITEXValue As String       'NOTE: Variable length, null-terminated  /


End Type
'_________________________________________________________________

Public Type ES_BOOK
'Book
'Name As String * 4        'Constant, BOOK
Size As Long
UnknownHeader1 As Long
Flag As LongFlag
'Book ID
'NAMEName As String * 4    'Constant, NAME
NAMESize As Long
NAMEValue As String       'NOTE: Variable length, null-terminated
'Book NIF model
'MODLName As String * 4    'Constant, MODL
MODLSize As Long
MODLValue As String       'NOTE: Variable length, null-terminated
'Book Name
'FNAMName As String * 4    'Constant, FNAM                         \
FNAMSize As Long          '                                        |-Optional
FNAMValue As String       'NOTE: Variable length, null-terminated  /
'Book data
'BKDTName As String * 4    'Constant, BKDT
BKDTSize As Long          'Constant, 20
BKDTWeight As Single
BKDTValue As Long
BKDTScroll As Long
BKDTSkillID As Long
BKDTEnchantVal As Long
'Attached script
'SCRIName As String * 4    'Constant, SCRI                         \
SCRISize As Long          '                                        |-Optional
SCRIValue As String       'NOTE: Variable length, null-terminated  /
'Book icon
'ITEXName As String * 4    'Constant, ITEX                         \
ITEXSize As Long          '                                        |-Optional
ITEXValue As String       'NOTE: Variable length, null-terminated  /
'Book text
'TEXTName As String * 4    'Constant, TEXT                             \
TEXTSize As Long          '                                            |-Optional
TEXTValue As String       'NOTE: Variable length, -NOT- null-terminated/
'Book enxhantment
'ENAMName As String * 4    'Constant, ENAM                         \
ENAMSize As Long          '                                        |-Optional
ENAMValue As String       'NOTE: Variable length, null-terminated  /


End Type
'_________________________________________________________________

Public Type ES_ALCH
'Potion(Alchemy)
'Name As String * 4        'Constant, ALCH
Size As Long
UnknownHeader1 As Long
Flag As LongFlag
'Potion ID
'NAMEName As String * 4    'Constant, NAME
NAMESize As Long
NAMEValue As String       'NOTE: Variable length, null-terminated
'Potion NIF model
'MODLName As String * 4    'Constant, MODL                         \
MODLSize As Long          '                                        |-Optional
MODLValue As String       'NOTE: Variable length, null-terminated  /
'Potion Icon
'TEXTName As String * 4    'Constant, TEXT                         \
TEXTSize As Long          '                                        |-Optional
TEXTValue As String       'NOTE: Variable length, null-terminated  /
'Attached script
'SCRIName As String * 4    'Constant, SCRI                         \
SCRISize As Long          '                                        |-Optional
SCRIValue As String       'NOTE: Variable length, null-terminated  /
'Potion Name
'FNAMName As String * 4    'Constant, FNAM                         \
FNAMSize As Long          '                                        |-Optional
FNAMValue As String       'NOTE: Variable length, null-terminated  /
'Potion data
'ALDTName As String * 4    'Constant, ALDT
ALDTSize As Long          'Constant, 12
ALDTWeight As Single
ALDTValue As Long
ALDTAutoCalc As Long

ENAM(7) As ES_SpellEffect '                                         -Optional


End Type
'_________________________________________________________________

Public Type ES_LEVI
'Levelled item list
'Name As String * 4        'Constant, LEVI
Size As Long
UnknownHeader1 As Long
Flag As LongFlag
'Levelled item list ID
'NAMEName As String * 4    'Constant, NAME
NAMESize As Long
NAMEValue As String       'NOTE: Variable length, null-terminated
'Levelled item list data
'DATAName As String * 4    'Constant, DATA
DATASize As Long          'Constant, 4
DATAValue As Byte
'Padding(1-3) As Byte = Null
'Chance of none
'NNAMName As String * 4    'Constant, NNAM
NNAMSize As Long          'Constant, 1
NNAMValue As Byte
'Number of items in the list
'INDXName As String * 4    'Constant, INDX   \
INDXSize As Long          'Constant, 4       |-Optional
INDXValue As Long         '                  /

Items() As ES_LevItemEntry '                  -Optional


End Type
'________________________________________________________________

Public Type ES_LEVC
'Levelled item list
'Name As String * 4        'Constant, LEVC
Size As Long
UnknownHeader1 As Long
Flag As LongFlag
'Levelled item list ID
'NAMEName As String * 4    'Constant, NAME
NAMESize As Long
NAMEValue As String       'NOTE: Variable length, null-terminated
'Levelled item list data
'DATAName As String * 4    'Constant, DATA
DATASize As Long          'Constant, 4
DATAValue As Byte
'Padding(1-3) As Byte = Null
'Chance of none
'NNAMName As String * 4    'Constant, NNAM
NNAMSize As Long          'Constant, 1
NNAMValue As Byte
'Number of items in the list
'INDXName As String * 4    'Constant, INDX   \
INDXSize As Long          'Constant, 4       |-Optional
INDXValue As Long         '                  /

Creatures() As ES_LevCreatEntry '             -Optional


End Type
'________________________________________________________________

Public Type ES_SNDG
'Sound generator
'Name As String * 4        'Constant, SNDG
Size As Long
UnknownHeader1 As Long
Flag As LongFlag
'Unknown. Looks like a reference name\index string...
'NAMEName As String * 4    'Constant, NAME
NAMESize As Long
NAMEValue As String       'NOTE: Variable length, null-terminated
'Levelled item list data
'DATAName As String * 4    'Constant, DATA
DATASize As Long          'Constant, 4
DATAValue As Byte
'Padding(1-3) As Byte = Null
'Creature ID
'CNAMName As String * 4    'Constant, CNAM                         \
CNAMSize As Long          '                                        |-Optional
CNAMValue As String       'NOTE: Variable length, null-terminated  /
'Sound ID
'SNAMName As String * 4    'Constant, SNAM
SNAMSize As Long
SNAMValue As String       'NOTE: Variable length, null-terminated


End Type
'________________________________________________________________

Public Type ES_SSCR
'Start Script, Tribunal only
'Name As String * 4        'Constant, SSCR
Size As Long
UnknownHeader1 As Long
Flag As LongFlag
'Start Script numerical ID.
'DATAName As String * 4    'Constant, DATA
DATASize As Long          'Constant, 20
DATAValue As String       '-NOT- null-terminated
'This is needed because IDs are unique so it can not be given the same ID as
'the script name.
'The ID of the script to start
'NAMEName As String * 4    'Constant, NAME
NAMESize As Long
NAMEValue As String       'NOTE: Variable length, -NOT- null-terminated


End Type
'________________________________________________________________

Public Type ES_PGRD
'Path Grid
'Name As String * 4        'Constant, PGRD
Size As Long
UnknownHeader1 As Long
Flag As LongFlag
'Path Grid misc. Data
'DATAName As String * 4    'Constant, DATA
DATASize As Long          'Constant, 12
DATAGridX As Long         '0 if interior
DATAGridY As Long         '0 if interior
DATAGranularity As Integer
DATAPointsCount As Integer
'The ID of the cell that the path grid relates to, exists even if the cell is
'unnamed(Region name used)
'NAMEName As String * 4    'Constant, NAME
NAMESize As Long
NAMEValue As String       'NOTE: Variable length, null-terminated
'Path Grid Points
'PGRPName As String * 4    'Constant, PGRP                          \
PGRPSize As Long          '"Chunks" of 16 bytes for each point.     |-Optional
PGRPPoints() As ES_PathGridPoint '                                  /
'Path Grid Connections
'PGRCName As String * 4    'Constant, PGRC                          \
PGRCSize As Long          '                                         |-Optional
PGRCData() As Long        '                                         /
'Array members count should be the sum of PGRPConnectCount of all PGRPPoints().
'-----------------Helper
Connections() As ES_GridConnection
'-----------------Helper


End Type
'________________________________________________________________

Public Type ES_NPC_
'Non-Playable Character
'Name As String * 4        'Constant, NPC_
Size As Long
UnknownHeader1 As Long
Flag As LongFlag
'NPC ID
'NAMEName As String * 4    'Constant, NAME
NAMESize As Long
NAMEValue As String       'NOTE: Variable length, null-terminated
'NPC Animation File
'MODLName As String * 4    'Constant, MODL                         \
MODLSize As Long          '                                       |-Optional
MODLValue As String       'NOTE: Variable length, null-terminated /
'NPC Name
'FNAMName As String * 4    'Constant, FNAM                         \
FNAMSize As Long          '                                       |-Optional
FNAMValue As String       'NOTE: Variable length, null-terminated /
'NPC Race
'RNAMName As String * 4    'Constant, RNAM
RNAMSize As Long
RNAMValue As String       'NOTE: Variable length, null-terminated
'NPC Class
'CNAMName As String * 4    'Constant, CNAM
CNAMSize As Long
CNAMValue As String       'NOTE: Variable length, null-terminated
'NPC Faction
'ANAMName As String * 4    'Constant, ANAM
ANAMSize As Long
ANAMValue As String       'NOTE: Variable length, null-terminated
'NPC Head Model
'BNAMName As String * 4    'Constant, BNAM
BNAMSize As Long
BNAMValue As String       'NOTE: Variable length, null-terminated
'NPC Hair Name
'KNAMName As String * 4    'Constant, KNAM
KNAMSize As Long
KNAMValue As String       'NOTE: Variable length, null-terminated
'Attaced Script
'SCRIName As String * 4    'Constant, SCRI                        \
SCRISize As Long          '                                       |-Optional
SCRIValue As String       'NOTE: Variable length, null-terminated /
'NPC General Data
'NPDTName As String * 4    'Constant, NPDT
NPDTSize As Long
NPDTDataS As ES_NPDTSmall
NPDTDataL As ES_NPDTLarge
'NPC Flags
'FLAGName As String * 4    'Constant, FLAG
FLAGSize As Long          'Constant, 4
FLAGGeneral As Byte
FLAGBlood As Byte
'Padding(1) As Byte
NPCO() As ES_ContainerItem  '                                     |-Optional
NPCS() As ES_ContainerSpell '                                     |-Optional
'NPC AI Data
'AIDTName As String * 4    'Constant, AIDT
AIDTSize As Long          'Constant, 12                           \
AIDTHello As Byte         '                                       |
AIDTUnknown1 As Byte      '                                       |
AIDTFight As Byte         '                                       |
AIDTFlee As Byte          '                                       |_Optional
AIDTAlarm As Byte         '                                       |
AIDTUnknown2 As Byte      '                                       |
AIDTUnknown3 As Byte      '                                       |
AIDTUnknown4 As Byte      '                                       |
AIDTFlag As LongFlag      '                                       /
'AI Wander Settings
AI_W() As ES_AI_W
'AI Travel Settings
AI_T() As ES_AI_T
'AI Follow Settings
AI_F() As ES_AI_F
'AI Escort Settings
AI_E() As ES_AI_E
'AI Activate Settings
AI_A() As ES_AI_A
DODT(3) As ES_Destination '                                       |-Optional
'Savegame-specific. Index?
'INDXName as String * 4    'Constant, INDX
INDXSize As Long          'Constant, 4
INDXValue As Long


End Type
'________________________________________________________________

Public Type ES_CREA
'Creature
'Name As String * 4        'Constant, CREA
Size As Long
UnknownHeader1 As Long
Flag As LongFlag
'Creature ID
'NAMEName As String * 4    'Constant, NAME
NAMESize As Long
NAMEValue As String       'NOTE: Variable length, null-terminated
'Creature Model
'MODLName As String * 4    'Constant, MODL
MODLSize As Long
MODLValue As String       'NOTE: Variable length, null-terminated
'Creature Sound Gen
'CNAMName As String * 4    'Constant, CNAM                        \
CNAMSize As Long          '                                       |-Optional
CNAMValue As String       'NOTE: Variable length, null-terminated /
'Creature Name
'FNAMName As String * 4    'Constant, FNAM                        \
FNAMSize As Long          '                                       |-Optional
FNAMValue As String       'NOTE: Variable length, null-terminated /
'Attaced Script
'SCRIName As String * 4    'Constant, SCRI                        \
SCRISize As Long          '                                       |-Optional
SCRIValue As String       'NOTE: Variable length, null-terminated /
'Creature General Data
NPDTData As ES_NPDTVeryLarge
'Creature Flags
'FLAGName As String * 4    'Constant, FLAG
FLAGSize As Long          'Constant, 4
FLAGGeneral As Byte
FLAGBlood As Byte
'Padding(1) As Byte
'Creature Scale
'XSCLName As String * 4    'Constant, XSCL                         \
XSCLSize As Long          'Constant, 4                            |-Optional
XSCLValue As Long         '                                       /
'Padding(1) As Byte
NPCO() As ES_ContainerItem  '                                     |-Optional
NPCS() As ES_ContainerSpell '                                     |-Optional
'Creature AI Data
'AIDTName As String * 4    'Constant, AIDT
AIDTSize As Long          'Constant, 12                           \
AIDTHello As Byte         '                                       |
AIDTUnknown1 As Byte      '                                       |
AIDTFight As Byte         '                                       |
AIDTFlee As Byte          '                                       |_Optional
AIDTAlarm As Byte         '                                       |
AIDTUnknown2 As Byte      '                                       |
AIDTUnknown3 As Byte      '                                       |
AIDTUnknown4 As Byte      '                                       |
AIDTFlag As LongFlag      '                                       /
'AI Wander Settings
AI_W() As ES_AI_W
'AI Travel Settings
AI_T() As ES_AI_T
'AI Follow Settings
AI_F() As ES_AI_F
'AI Escort Settings
AI_E() As ES_AI_E
'AI Activate Settings
AI_A() As ES_AI_A
'Travel service destinations
DODT(3) As ES_Destination '                                       |-Optional
'Savegame-specific. Index?
'INDXName as String * 4    'Constant, INDX
INDXSize As Long          'Constant, 4
INDXValue As Long

End Type
'________________________________________________________________

Public Type ES_CELL
'Cell
'Name As String * 4        'Constant, CELL
Size As Long
UnknownHeader1 As Long
Flag As LongFlag
'Cell ID
'NAMEName As String * 4    'Constant, NAME
NAMESize As Long
NAMEValue As String       'NOTE: Variable length, null-terminated
'Cell Data
'DATAName As String * 4    'Constant, DATA
DATASize As Long          '12
DATAFlag As LongFlag
DATAGridX As Long
DATAGridY As Long
'Region Name
'RGNNName As String * 4    'Constant, RGNN                    \
RGNNSize As Long          '                                   |-Optional
RGNNValue As String       'Variable length, null-terminated   /
'Number of objects
'NAM0Name As String * 4    'Constant, NAM0                    \
NAM0Size As Long          'Constant, 4                        |-Optional
NAM0Value As Long         '                                   /
'Exterior Cell Map Color
'NAM5Name As String * 4    'Constant, NAM5                    \
NAM5Size As Long          'Constant, 4                        |
NAM5Red As Byte           '                                   |_Optional
NAM5Green As Byte         '                                   |
NAM5Blue As Byte          '                                   |
'Padding As Byte = Null                                       /
'Interior Cell water height
'WHGTName As String * 4    'Constant, WHGT                    \
WHGTSize As Long          'Constant, 4                        |-Optional
WHGTValue As Single       '                                   /
'Interior Cell, Unknown
'INTVName As String * 4    'Constant, INTV                    \
INTVSize As Long          'Constant, 4                        |-Optional
INTVValue As Long         '                                   /
'Interior Cell Light Settings
'AMBIName As String * 4    'Constant, AMBI                    \
AMBISize As Long          'Constant, 16                       |
AMBIRed As Byte           '                                   |
AMBIGreen As Byte         '                                   |
AMBIBlue As Byte          '                                   |
'Padding As Byte = Null                                       |
AMBISunRed As Byte        '                                   |
AMBISunGreen As Byte      '                                   |-Optional
AMBISunBlue As Byte       '                                   |
'Padding As Byte = Null                                       |
AMBIFogRed As Byte        '                                   |
AMBIFogGreen As Byte      '                                   |
AMBIFogBlue As Byte       '                                   |
'Padding As Byte = Null                                       |
AMBIFogDensity As Single  '                                   /
'Map data
'MPCDName As String * 4    'Constant, MPCD                    \
MPCDSize As Long          'Constant, 12                       |
MPCDValueX As Single      '                                   |-Optional
MPCDValueY As Single      '                                   |
MPCDValueZ As Single      '                                   /
'Visibility map?
'NAM8Name As String * 4    'Constant, NAM8                    \
NAM8Size As Long          '                                   |-Optional
NAM8Value As String       '                                   /

References() As ES_Reference '                                 -Optional
Deleted As Byte

End Type
'________________________________________________________________

Public Type ES_LAND
'Landscape
'NOTE: There're 4225 vertices and 256 texturable rectangles in a Cell.
'Name As String * 4        'Constant, LAND
Size As Long
UnknownHeader1 As Long
Flag As LongFlag
'Grid of the related Cell
'INTVName As String * 4    'Constant, INTV
INTVSize As Long          'Contstant, 8
INTVGridX As Long
INTVGridY As Long

'Unknown data...
'DATAName As String * 4    'Constant, DATA
DATASize As Long          'Constant, 4
DATAValue As Long

'Vertex Normals
'VNMLName As String * 4    'Constant, VNML
VNMLSize As Long          'Constant, 12675
VNMLData(4224) As ES_TripleCoord

'Vertex Color
'VCLRName As String * 4    'Constant, VCLR
VCLRSize As Long          'Constant, 12675
VCLRData(4224) As ES_TripleCoord

'Vertex Height
'VHGTName As String * 4    'Constant, VHGT
VHGTSize As Long          'Constant, 4232
VHGTOffset As Single
VHGTUnknown1 As Byte
VHGTData(4224) As ES_TripleCoord
VHGTUnknown2 As Byte
VHGTUnknown3 As Byte

'WNAM subrecord, something to do with height
'WNAMName As String * 4    'Constant, WNAM
WNAMSize As Long          'Constant, 81
WNAMData(80) As Byte

'Polygons Texture
'VTEXName As String * 4    'Constant, VTEX
VTEXSize As Long          'Constant, 512
VTEXData(255) As Integer
'The value used here = (the "index" of the texture in LTEX record + 1)


End Type
'________________________________________________________________

Public Type ES_DIAL
'Dialog topic
'Name As String * 4        'Constant, DIAL
Size As Long
UnknownHeader1 As Long
Flag As LongFlag
'Dialog topic ID
'NAMEName As String * 4    'Constant, NAME
NAMESize As Long
NAMEValue As String       'NOTE: Variable length, null-terminated
'Topic type
'DATAName As String * 4    'Constant, DATA
DATASize As Long          '1 or 4
DATAType As Byte          '   \_One of these
'Deleted_Padding(3) As byte  '/
'Current Index, savegame-specific
'XIDXName As String * 4    'Constant, XIDX
XIDXSize As Long
XIDXValue As Long


End Type
'________________________________________________________________

Public Type ES_INFO
'Response\Journal entry\voice...
'Name As String * 4        'Constant, INFO
Size As Long
UnknownHeader1 As Long
Flag As LongFlag
'Parent Dialogue ID
ParentDIAL As String
'Response numerical ID
'INAMName As String * 4    'Constant, INAM
INAMSize As Long
INAMValue As String       'NOTE: Variable length, null-terminated
'Previous response numerical ID
'PNAMName As String * 4    'Constant, PNAM
PNAMSize As Long
PNAMValue As String       'NOTE: Variable length, null-terminated
'Next response numerical ID
'NNAMName As String * 4    'Constant, NNAM
NNAMSize As Long
NNAMValue As String       'NOTE: Variable length, null-terminated
'Miscellaneous response data
'DATAName As String * 4    'Constant, DATA
DATASize As Long          'Constant, 12
DATAType As Long
DATADisposition As Long   'Also index for journal.
DATARank As Byte
DATAGender As Byte
DATAPCRank As Byte
DATAUnknown As Byte      'Padding?
'Character ID
'ONAMName As String * 4    'Constant, ONAM
ONAMSize As Long
ONAMValue As String       'NOTE: Variable length, null-terminated
'Character Race
'RNAMName As String * 4    'Constant, RNAM
RNAMSize As Long
RNAMValue As String       'NOTE: Variable length, null-terminated
'Character Class
'CNAMName As String * 4    'Constant, CNAM
CNAMSize As Long
CNAMValue As String       'NOTE: Variable length, null-terminated
'Character Faction
'FNAMName As String * 4    'Constant, FNAM
FNAMSize As Long
FNAMValue As String       'NOTE: Variable length, null-terminated
'Cell name
'ANAMName As String * 4    'Constant, ANAM
ANAMSize As Long
ANAMValue As String       'NOTE: Variable length, null-terminated
'PC Faction
'DNAMName As String * 4    'Constant, DNAM
DNAMSize As Long
DNAMValue As String       'NOTE: Variable length, null-terminated
'Response text
'NAMEName As String * 4    'Constant, NAME
NAMESize As Long
NAMEValue As String       'NOTE: Variable length, -NOT- null-terminated
'Sound filename
'SNAMName As String * 4    'Constant, SNAM
SNAMSize As Long
SNAMValue As String       'NOTE: Variable length, null-terminated
'Quest Name
'QSTNName As String * 4    'Constant, QSTN
QSTNSize As Long          'Constant, 1
QSTNValue As Byte
'Quest Finished
'QSTFName As String * 4    'Constant, QSTF
QSTFSize As Long          'Constant, 1
QSTFValue As Byte
'Quest Restart
'QSTRName As String * 4    'Constant, QSTR
QSTRSize As Long          'Constant, 1
QSTRValue As Byte
'Sayer
'ACDTName As String * 4    'Constant, ACDT
ACDTSize As Long
ACDTValue As String       'NOTE: Variable length, null-terminated

SCVR(5) As ES_InfoRequirement

'Result code, not compiled
'BNAMName As String * 4    'Constant, BNAM
BNAMSize As Long
BNAMValue As String       'NOTE: Variable length, -NOT- null-terminated
'Journal Index, savegame-specific
'XIDXName As String * 4    'Constant, XIDX
XIDXSize As Long
XIDXValue As Long

End Type
'________________________________________________________________

Public Type ES_Unknown
'Unknown
Name As String * 4
Size As Long
UnknownHeader1 As Long
Flag As LongFlag
Data As String
LANDGridX As Long
LANDGridY As Long

End Type
'________________________________________________________________
