Attribute VB_Name = "ESWrite"
Option Explicit

'***************************************************************************
'*                                                                         *
'*                            Write Functions                              *
'*                                                                         *
'***************************************************************************

Public Function WriteUnknown(ByVal FileHandle As Integer, ByRef Record As ES_Unknown)

Dim i As Long

With Record
    Put FileHandle, , .Name
    Put FileHandle, , .Size
    Put FileHandle, , .UnknownHeader1
    Put FileHandle, , .Flag
    Put FileHandle, , .Data
End With

End Function

Public Function WriteTES3(ByVal FileHandle As Integer, ByRef Record As ES_TES3, ByVal RecordsCount As Long, ByVal FileType As Long)

Dim i As Long
Dim buffer As Byte

buffer = 0
With Record
    Put FileHandle, , "TES3"
    Put FileHandle, , .Size
    Put FileHandle, , .UnknownHeader1
    Put FileHandle, , .Flag
    Put FileHandle, , "HEDR"
    Put FileHandle, , .HEDRSize
    Put FileHandle, , .HEDRVersion
    Put FileHandle, , FileType
    Put FileHandle, , .HEDRAuthor
    Put FileHandle, , .HEDRDescript
    Put FileHandle, , (RecordsCount - 1)
    If .Flag.Flag_01 >= 20 Then
        Put FileHandle, , "DELE"
        Put FileHandle, , CLng(4)
        Put FileHandle, , CLng(0)
        Exit Function
    End If
    On Error Resume Next
    If .MASTArray(LBound(.MASTArray)).MASTValue = "" Then
    Else
        For i = LBound(.MASTArray) To UBound(.MASTArray)
            Put FileHandle, , "MAST"
            Put FileHandle, , .MASTArray(i).MASTSize
            Put FileHandle, , .MASTArray(i).MASTValue
            Put FileHandle, , buffer
            Put FileHandle, , "DATA"
            Put FileHandle, , .MASTArray(i).DATASize
            Put FileHandle, , .MASTArray(i).DATAValue
        Next
    End If
    On Error GoTo ErrHandler
    If .GMDTSize <> 0 Then
        Put FileHandle, , "GMDT"
        Put FileHandle, , .GMDTSize
        Put FileHandle, , .GMDTCurHealth
        Put FileHandle, , .GMDTMaxHealth
        Put FileHandle, , .GMDTUnknown1
        Put FileHandle, , .GMDTDay
        Put FileHandle, , .GMDTMonth
        Put FileHandle, , .GMDTYear
        Put FileHandle, , .GMDTCellName
        Put FileHandle, , .GMDTUnknown2
        Put FileHandle, , .GMDTCharacterName
    End If
    If .SCRDSize <> 0 Then
        Put FileHandle, , "SCRD"
            Put FileHandle, , .SCRDSize
            For i = 0 To 19
                Put FileHandle, , .SCRDValue(i)
            Next
    End If
    If .SCRSSize <> 0 Then
        Put FileHandle, , "SCRS"
        Put FileHandle, , .SCRSSize
        Put FileHandle, , .SCRSValue
    End If
End With

Exit Function

ErrHandler:
    MsgBox Err.Description, vbExclamation, "ES Parser"

End Function


Public Function WriteGLOB(ByVal FileHandle As Integer, ByRef Record As ES_GLOB)

Dim buffer As Byte

With Record
    Put FileHandle, , "GLOB"
    Put FileHandle, , .Size
    Put FileHandle, , .UnknownHeader1
    Put FileHandle, , .Flag
    Put FileHandle, , "NAME"
    Put FileHandle, , .NAMESize
    Put FileHandle, , .NAMEValue
    Put FileHandle, , buffer
    If .Flag.Flag_01 >= 20 Then
        Put FileHandle, , "DELE"
        Put FileHandle, , CLng(4)
        Put FileHandle, , CLng(0)
        Exit Function
    End If
    Put FileHandle, , "FNAM"
    Put FileHandle, , .FNAMSize
    Put FileHandle, , .FNAMValue
    Put FileHandle, , "FLTV"
    Put FileHandle, , .FLTVSize
    Put FileHandle, , .FLTVValue
End With

End Function

Public Function WriteGMST(ByVal FileHandle As Integer, ByRef Record As ES_GMST)

With Record
    Put FileHandle, , "GMST"
    Put FileHandle, , .Size
    Put FileHandle, , .UnknownHeader1
    Put FileHandle, , .Flag
    Put FileHandle, , "NAME"
    Put FileHandle, , .NAMESize
    Put FileHandle, , .NAMEValue
    If .Flag.Flag_01 >= 20 Then
        Put FileHandle, , "DELE"
        Put FileHandle, , CLng(4)
        Put FileHandle, , CLng(0)
        Exit Function
    End If
    If .STRVSize <> 0 Then
        Put FileHandle, , "STRV"
        Put FileHandle, , .STRVSize
        Put FileHandle, , .STRVValue
    ElseIf .INTVSize <> 0 Then
        Put FileHandle, , "INTV"
        Put FileHandle, , .INTVSize
        Put FileHandle, , .INTVValue
    ElseIf .FLTVSize <> 0 Then
        Put FileHandle, , "FLTV"
        Put FileHandle, , .FLTVSize
        Put FileHandle, , .FLTVValue
    End If
End With

End Function

Public Function WriteCLAS(ByVal FileHandle As Integer, ByRef Record As ES_CLAS)

Dim buffer As Byte

With Record
    Put FileHandle, , "CLAS"
    Put FileHandle, , .Size
    Put FileHandle, , .UnknownHeader1
    Put FileHandle, , .Flag
    Put FileHandle, , "NAME"
    Put FileHandle, , .NAMESize
    Put FileHandle, , .NAMEValue
    Put FileHandle, , buffer
    If .Flag.Flag_01 >= 20 Then
        Put FileHandle, , "DELE"
        Put FileHandle, , CLng(4)
        Put FileHandle, , CLng(0)
        Exit Function
    End If
    Put FileHandle, , "FNAM"
    Put FileHandle, , .FNAMSize
    Put FileHandle, , .FNAMValue
    Put FileHandle, , buffer
    Put FileHandle, , "CLDT"
    Put FileHandle, , .CLDTSize
    Put FileHandle, , .CLDTAttributeID1
    Put FileHandle, , .CLDTAttributeID2
    Put FileHandle, , .CLDTSpecialization
    Put FileHandle, , .CLDTMinorID1
    Put FileHandle, , .CLDTMajorID1
    Put FileHandle, , .CLDTMinorID2
    Put FileHandle, , .CLDTMajorID2
    Put FileHandle, , .CLDTMinorID3
    Put FileHandle, , .CLDTMajorID3
    Put FileHandle, , .CLDTMinorID4
    Put FileHandle, , .CLDTMajorID4
    Put FileHandle, , .CLDTMinorID5
    Put FileHandle, , .CLDTMajorID5
    Put FileHandle, , .CLDTPlayable
    Put FileHandle, , buffer
    Put FileHandle, , buffer
    Put FileHandle, , buffer
    Put FileHandle, , .CLDTAutoCalcFlags
    If .DESCSize <> 0 Then
        Put FileHandle, , "DESC"
        Put FileHandle, , .DESCSize
        Put FileHandle, , .DESCValue
    End If
End With

End Function

Public Function WriteFACT(ByVal FileHandle As Integer, ByRef Record As ES_FACT)

Dim buffer As Byte
Dim i As Long

With Record
    Put FileHandle, , "FACT"
    Put FileHandle, , .Size
    Put FileHandle, , .UnknownHeader1
    Put FileHandle, , .Flag
    Put FileHandle, , "NAME"
    Put FileHandle, , .NAMESize
    Put FileHandle, , .NAMEValue
    Put FileHandle, , buffer
    If .Flag.Flag_01 >= 20 Then
        Put FileHandle, , "DELE"
        Put FileHandle, , CLng(4)
        Put FileHandle, , CLng(0)
        Exit Function
    End If
    Put FileHandle, , "FNAM"
    Put FileHandle, , .FNAMSize
    Put FileHandle, , .FNAMValue
    Put FileHandle, , buffer
    For i = 0 To 9
        If .RankArray(i).RNAMSize <> 0 Then
            Put FileHandle, , "RNAM"
            Put FileHandle, , .RankArray(i).RNAMSize
            Put FileHandle, , .RankArray(i).RNAMValue
        End If
    Next
    Put FileHandle, , "FADT"
    Put FileHandle, , .FADTSize
    Put FileHandle, , .FADTAttributeID1
    Put FileHandle, , .FADTAttributeID2
    For i = 0 To 9
        Put FileHandle, , .FADTRankData(i).Attribute1
        Put FileHandle, , .FADTRankData(i).Attribute2
        Put FileHandle, , .FADTRankData(i).FirstSkill
        Put FileHandle, , .FADTRankData(i).SecondSkill
        Put FileHandle, , .FADTRankData(i).FactionReputation
    Next
    Put FileHandle, , .FADTSkillID1
    Put FileHandle, , .FADTSkillID2
    Put FileHandle, , .FADTSkillID3
    Put FileHandle, , .FADTSkillID4
    Put FileHandle, , .FADTSkillID5
    Put FileHandle, , .FADTSkillID6
    Put FileHandle, , .FADTUnknown1
    Put FileHandle, , .FADTHiddenFlag
    On Error Resume Next
    If .ReactionsArray(LBound(.ReactionsArray)).ANAMSize = 0 Then
    Else
        For i = LBound(.ReactionsArray) To UBound(.ReactionsArray)
            Put FileHandle, , "ANAM"
            Put FileHandle, , .ReactionsArray(i).ANAMSize
            Put FileHandle, , .ReactionsArray(i).ANAMValue
            Put FileHandle, , "INTV"
            Put FileHandle, , .ReactionsArray(i).INTVSize
            Put FileHandle, , .ReactionsArray(i).INTVValue
        Next
    End If
End With

End Function

Public Function WriteRACE(ByVal FileHandle As Integer, ByRef Record As ES_RACE)

Dim buffer As Byte
Dim i As Long

With Record
    Put FileHandle, , "RACE"
    Put FileHandle, , .Size
    Put FileHandle, , .UnknownHeader1
    Put FileHandle, , .Flag
    Put FileHandle, , "NAME"
    Put FileHandle, , .NAMESize
    Put FileHandle, , .NAMEValue
    Put FileHandle, , buffer
    If .Flag.Flag_01 >= 20 Then
        Put FileHandle, , "DELE"
        Put FileHandle, , CLng(4)
        Put FileHandle, , CLng(0)
        Exit Function
    End If
    Put FileHandle, , "FNAM"
    Put FileHandle, , .FNAMSize
    Put FileHandle, , .FNAMValue
    Put FileHandle, , buffer
    Put FileHandle, , "RADT"
    Put FileHandle, , .RADTSize
    Put FileHandle, , .RADTSkillID1
    Put FileHandle, , .RADTSkillBonus1
    Put FileHandle, , .RADTSkillID2
    Put FileHandle, , .RADTSkillBonus2
    Put FileHandle, , .RADTSkillID3
    Put FileHandle, , .RADTSkillBonus3
    Put FileHandle, , .RADTSkillID4
    Put FileHandle, , .RADTSkillBonus4
    Put FileHandle, , .RADTSkillID5
    Put FileHandle, , .RADTSkillBonus5
    Put FileHandle, , .RADTSkillID6
    Put FileHandle, , .RADTSkillBonus6
    Put FileHandle, , .RADTSkillID7
    Put FileHandle, , .RADTSkillBonus7
    Put FileHandle, , .RADTStrengthMale
    Put FileHandle, , .RADTStrengthFemale
    Put FileHandle, , .RADTIntelligenceMale
    Put FileHandle, , .RADTIntelligenceFemale
    Put FileHandle, , .RADTWillpowerMale
    Put FileHandle, , .RADTWillpowerFemale
    Put FileHandle, , .RADTAgilityMale
    Put FileHandle, , .RADTAgilityFemale
    Put FileHandle, , .RADTSpeedMale
    Put FileHandle, , .RADTSpeedFemale
    Put FileHandle, , .RADTEnduranceMale
    Put FileHandle, , .RADTEnduranceFemale
    Put FileHandle, , .RADTPersonalityMale
    Put FileHandle, , .RADTPersonalityFemale
    Put FileHandle, , .RADTLuckMale
    Put FileHandle, , .RADTLuckFemale
    Put FileHandle, , .RADTHeightMale
    Put FileHandle, , .RADTHeightFemale
    Put FileHandle, , .RADTWeightMale
    Put FileHandle, , .RADTWeightFemale
    Put FileHandle, , .RADTFlags
    On Error Resume Next
    If .NPCS(LBound(.NPCS)).NPCSSize = 0 Then
    Else
        For i = LBound(.NPCS) To UBound(.NPCS)
            Put FileHandle, , "NPCS"
            Put FileHandle, , .NPCS(i).NPCSSize
            Put FileHandle, , .NPCS(i).NPCSValue
        Next
    End If
    If .DESCSize <> 0 Then
        Put FileHandle, , "DESC"
        Put FileHandle, , .DESCSize
        Put FileHandle, , .DESCValue
    End If
End With

End Function

Public Function WriteSOUN(ByVal FileHandle As Integer, ByRef Record As ES_SOUN)

Dim buffer As Byte

With Record
    Put FileHandle, , "SOUN"
    Put FileHandle, , .Size
    Put FileHandle, , .UnknownHeader1
    Put FileHandle, , .Flag
    Put FileHandle, , "NAME"
    Put FileHandle, , .NAMESize
    Put FileHandle, , .NAMEValue
    Put FileHandle, , buffer
    If .Flag.Flag_01 >= 20 Then
        Put FileHandle, , "DELE"
        Put FileHandle, , CLng(4)
        Put FileHandle, , CLng(0)
        Exit Function
    End If
    Put FileHandle, , "FNAM"
    Put FileHandle, , .FNAMSize
    Put FileHandle, , .FNAMValue
    Put FileHandle, , buffer
    Put FileHandle, , "DATA"
    Put FileHandle, , .DATASize
    Put FileHandle, , .DATAVolume
    Put FileHandle, , .DATAMinRange
    Put FileHandle, , .DATAMaxRange
End With

End Function

Public Function WriteSKIL(ByVal FileHandle As Integer, ByRef Record As ES_SKIL)

Dim buffer As Byte

With Record
    Put FileHandle, , "SKIL"
    Put FileHandle, , .Size
    Put FileHandle, , .UnknownHeader1
    Put FileHandle, , .Flag
    Put FileHandle, , "INDX"
    Put FileHandle, , .INDXSize
    Put FileHandle, , .INDXValue
    If .Flag.Flag_01 >= 20 Then
        Put FileHandle, , "DELE"
        Put FileHandle, , CLng(4)
        Put FileHandle, , CLng(0)
        Exit Function
    End If
    Put FileHandle, , "SKDT"
    Put FileHandle, , .SKDTSize
    Put FileHandle, , .SKDTAttibute
    Put FileHandle, , .SKDTSpecialization
    Put FileHandle, , .SKDTUseValue1
    Put FileHandle, , .SKDTUseValue2
    Put FileHandle, , .SKDTUseValue3
    Put FileHandle, , .SKDTUseValue4
    If .DESCSize <> 0 Then
        Put FileHandle, , "DESC"
        Put FileHandle, , .DESCSize
        Put FileHandle, , .DESCValue
    End If
End With

End Function

Public Function WriteMGEF(ByVal FileHandle As Integer, ByRef Record As ES_MGEF)

Dim buffer As Byte

With Record
    Put FileHandle, , "MGEF"
    Put FileHandle, , .Size
    Put FileHandle, , .UnknownHeader1
    Put FileHandle, , .Flag
    Put FileHandle, , "INDX"
    Put FileHandle, , .INDXSize
    Put FileHandle, , .INDXValue
    If .Flag.Flag_01 >= 20 Then
        Put FileHandle, , "DELE"
        Put FileHandle, , CLng(4)
        Put FileHandle, , CLng(0)
        Exit Function
    End If
    Put FileHandle, , "MEDT"
    Put FileHandle, , .MEDTSize
    Put FileHandle, , .MEDTSchool
    Put FileHandle, , .MEDTBaseCost
    Put FileHandle, , .MEDTFlags
    Put FileHandle, , .MEDTRed
    Put FileHandle, , .MEDTGreen
    Put FileHandle, , .MEDTBlue
    Put FileHandle, , .MEDTSpeedX
    Put FileHandle, , .MEDTSizeX
    Put FileHandle, , .MEDTSizeCap
    Put FileHandle, , "ITEX"
    Put FileHandle, , .ITEXSize
    Put FileHandle, , .ITEXValue
    Put FileHandle, , buffer
    If .PTEXSize <> 0 Then
        Put FileHandle, , "PTEX"
        Put FileHandle, , .PTEXSize
        Put FileHandle, , .PTEXValue
        Put FileHandle, , buffer
    End If
    If .BSNDSize <> 0 Then
        Put FileHandle, , "BSND"
        Put FileHandle, , .BSNDSize
        Put FileHandle, , .BSNDValue
        Put FileHandle, , buffer
    End If
    If .CSNDSize <> 0 Then
        Put FileHandle, , "CSND"
        Put FileHandle, , .CSNDSize
        Put FileHandle, , .CSNDValue
        Put FileHandle, , buffer
    End If
    If .HSNDSize <> 0 Then
        Put FileHandle, , "HSND"
        Put FileHandle, , .HSNDSize
        Put FileHandle, , .HSNDValue
        Put FileHandle, , buffer
    End If
    If .ASNDSize <> 0 Then
        Put FileHandle, , "ASND"
        Put FileHandle, , .ASNDSize
        Put FileHandle, , .ASNDValue
        Put FileHandle, , buffer
    End If
    If .BVFXSize <> 0 Then
        Put FileHandle, , "BVFX"
        Put FileHandle, , .BVFXSize
        Put FileHandle, , .BVFXValue
        Put FileHandle, , buffer
    End If
    If .CVFXSize <> 0 Then
        Put FileHandle, , "CVFX"
        Put FileHandle, , .CVFXSize
        Put FileHandle, , .CVFXValue
        Put FileHandle, , buffer
    End If
    If .HVFXSize <> 0 Then
        Put FileHandle, , "HVFX"
        Put FileHandle, , .HVFXSize
        Put FileHandle, , .HVFXValue
        Put FileHandle, , buffer
    End If
    If .AVFXSize <> 0 Then
        Put FileHandle, , "AVFX"
        Put FileHandle, , .AVFXSize
        Put FileHandle, , .AVFXValue
        Put FileHandle, , buffer
    End If
    If .DESCSize <> 0 Then
        Put FileHandle, , "DESC"
        Put FileHandle, , .DESCSize
        Put FileHandle, , .DESCValue
    End If
End With

End Function

Public Function WriteSCPT(ByVal FileHandle As Integer, ByRef Record As ES_SCPT, ByVal ForceText As Boolean)

Dim buffer As Byte
Dim SCVR_buffer() As String
Dim i As Long

With Record
    Put FileHandle, , "SCPT"
    Put FileHandle, , .Size
    Put FileHandle, , .UnknownHeader1
    Put FileHandle, , .Flag
    Put FileHandle, , "SCHD"
    Put FileHandle, , .SCHDSize
    Put FileHandle, , .SCHDScriptName
    Put FileHandle, , .SCHDNumShorts
    Put FileHandle, , .SCHDNumLongs
    Put FileHandle, , .SCHDNumFloats
    Put FileHandle, , .SCHDCodeSize
    Put FileHandle, , .SCHDLocalSize
    If .SCVRSize <> 0 Then
        Put FileHandle, , "SCVR"
        Put FileHandle, , .SCVRSize
        On Error Resume Next
        If .SCVRShorts(LBound(.SCVRShorts)) = "" Then
        Else
            For i = LBound(.SCVRShorts) To UBound(.SCVRShorts)
                Put FileHandle, , .SCVRShorts(i)
                Put FileHandle, , buffer
            Next
        End If
        If .SCVRLongs(LBound(.SCVRLongs)) = "" Then
        Else
            For i = LBound(.SCVRLongs) To UBound(.SCVRLongs)
                Put FileHandle, , .SCVRLongs(i)
                Put FileHandle, , buffer
            Next
        End If
        If .SCVRFloats(LBound(.SCVRFloats)) = "" Then
        Else
            For i = LBound(.SCVRFloats) To UBound(.SCVRFloats)
                Put FileHandle, , .SCVRFloats(i)
                Put FileHandle, , buffer
            Next
        End If
        On Error GoTo ErrHandler
    End If
    If .SCDTSize <> 0 Then
        Put FileHandle, , "SCDT"
        Put FileHandle, , .SCDTSize
        Put FileHandle, , .SCDTValue
    End If
    If ForceText = True Then
        Put FileHandle, , "SCTX"
        Put FileHandle, , .SCTXSize
        Put FileHandle, , .SCTXValue
    Else
        If .SCTXSize <> 0 Then
            Put FileHandle, , "SCTX"
            Put FileHandle, , .SCTXSize
            Put FileHandle, , .SCTXValue
        End If
    End If
    'savagame specific data
    If .SLCSSize <> 0 Then
        Put FileHandle, , "SLCS"
        Put FileHandle, , .SLCSSize
        Put FileHandle, , .SLCSValue
    End If
    If .SLSDSize <> 0 Then
        Put FileHandle, , "SLSD"
        Put FileHandle, , .SLSDSize
        For i = LBound(.SLSDValue) To UBound(.SLSDValue)
            Put FileHandle, , CInt(.SLSDValue(i))
        Next
    End If
    If .SLFDSize <> 0 Then
        Put FileHandle, , "SLFD"
        Put FileHandle, , .SLFDSize
        For i = LBound(.SLFDValue) To UBound(.SLFDValue)
            Put FileHandle, , CSng(.SLFDValue(i))
        Next
    End If
    If .RNAMSize <> 0 Then
        Put FileHandle, , "RNAM"
        Put FileHandle, , .RNAMSize
        Put FileHandle, , .RNAMValue
    End If
End With

Exit Function

ErrHandler:
    MsgBox Err.Description, vbExclamation, "ES Parser"

End Function

Public Function WriteREGN(ByVal FileHandle As Integer, ByRef Record As ES_REGN)

Dim buffer As Byte
Dim i As Long

With Record
    Put FileHandle, , "REGN"
    Put FileHandle, , .Size
    Put FileHandle, , .UnknownHeader1
    Put FileHandle, , .Flag
    Put FileHandle, , "NAME"
    Put FileHandle, , .NAMESize
    Put FileHandle, , .NAMEValue
    Put FileHandle, , buffer
    If .Flag.Flag_01 >= 20 Then
        Put FileHandle, , "DELE"
        Put FileHandle, , CLng(4)
        Put FileHandle, , CLng(0)
        Exit Function
    End If
    Put FileHandle, , "FNAM"
    Put FileHandle, , .FNAMSize
    Put FileHandle, , .FNAMValue
    Put FileHandle, , buffer
    Put FileHandle, , "WEAT"
    Put FileHandle, , .WEATSize
    For i = LBound(.WEATChances) To UBound(.WEATChances)
        Put FileHandle, , .WEATChances(i)
    Next
    If .BNAMSize <> 0 Then
        Put FileHandle, , "BNAM"
        Put FileHandle, , .BNAMSize
        Put FileHandle, , .BNAMValue
        Put FileHandle, , buffer
    End If
    Put FileHandle, , "CNAM"
    Put FileHandle, , .CNAMSize
    Put FileHandle, , .CNAMRed
    Put FileHandle, , .CNAMGreen
    Put FileHandle, , .CNAMBlue
    Put FileHandle, , buffer
    On Error Resume Next
    If .SNAM(LBound(.SNAM)).SNAMSize = 0 Then
    Else
        For i = LBound(.SNAM) To UBound(.SNAM)
            With .SNAM(i)
                Put FileHandle, , "SNAM"
                Put FileHandle, , .SNAMSize
                Put FileHandle, , .SNAMSound
                Put FileHandle, , .SNAMChance
            End With
        Next
    End If
    If .WNAMSize <> 0 Then
        Put FileHandle, , "WNAM"
        Put FileHandle, , .WNAMSize
        Put FileHandle, , .WNAMValue
    End If
End With

End Function

Public Function WriteBSGN(ByVal FileHandle As Integer, ByRef Record As ES_BSGN)

Dim buffer As Byte
Dim i As Long

With Record
    Put FileHandle, , "BSGN"
    Put FileHandle, , .Size
    Put FileHandle, , .UnknownHeader1
    Put FileHandle, , .Flag
    Put FileHandle, , "NAME"
    Put FileHandle, , .NAMESize
    Put FileHandle, , .NAMEValue
    Put FileHandle, , buffer
    If .Flag.Flag_01 >= 20 Then
        Put FileHandle, , "DELE"
        Put FileHandle, , CLng(4)
        Put FileHandle, , CLng(0)
        Exit Function
    End If
    If .FNAMSize <> 0 Then
        Put FileHandle, , "FNAM"
        Put FileHandle, , .FNAMSize
        Put FileHandle, , .FNAMValue
        Put FileHandle, , buffer
    End If
    If .TNAMSize <> 0 Then
        Put FileHandle, , "TNAM"
        Put FileHandle, , .TNAMSize
        Put FileHandle, , .TNAMValue
        Put FileHandle, , buffer
    End If
    If .DESCSize <> 0 Then
        Put FileHandle, , "DESC"
        Put FileHandle, , .DESCSize
        Put FileHandle, , .DESCValue
    End If
    On Error Resume Next
    If .NPCS(LBound(.NPCS)).NPCSSize = 0 Then
    Else
        For i = LBound(.NPCS) To UBound(.NPCS)
            Put FileHandle, , "NPCS"
            Put FileHandle, , .NPCS(i).NPCSSize
            Put FileHandle, , .NPCS(i).NPCSValue
        Next
    End If
End With

End Function

Public Function WriteLTEX(ByVal FileHandle As Integer, ByRef Record As ES_LTEX)

Dim buffer As Byte

With Record
    Put FileHandle, , "LTEX"
    Put FileHandle, , .Size
    Put FileHandle, , .UnknownHeader1
    Put FileHandle, , .Flag
    Put FileHandle, , "NAME"
    Put FileHandle, , .NAMESize
    Put FileHandle, , .NAMEValue
    Put FileHandle, , buffer
    If .Flag.Flag_01 >= 20 Then
        Put FileHandle, , "DELE"
        Put FileHandle, , CLng(4)
        Put FileHandle, , CLng(0)
        Exit Function
    End If
    Put FileHandle, , "INTV"
    Put FileHandle, , .INTVSize
    Put FileHandle, , .INTVValue
    Put FileHandle, , "DATA"
    Put FileHandle, , .DATASize
    Put FileHandle, , .DATAValue
    Put FileHandle, , buffer
End With

End Function

Public Function WriteSTAT(ByVal FileHandle As Integer, ByRef Record As ES_STAT)

Dim buffer As Byte

With Record
    Put FileHandle, , "STAT"
    Put FileHandle, , .Size
    Put FileHandle, , .UnknownHeader1
    Put FileHandle, , .Flag
    Put FileHandle, , "NAME"
    Put FileHandle, , .NAMESize
    Put FileHandle, , .NAMEValue
    Put FileHandle, , buffer
    If .Flag.Flag_01 >= 20 Then
        Put FileHandle, , "DELE"
        Put FileHandle, , CLng(4)
        Put FileHandle, , CLng(0)
        Exit Function
    End If
    Put FileHandle, , "MODL"
    Put FileHandle, , .MODLSize
    Put FileHandle, , .MODLValue
    Put FileHandle, , buffer
End With

End Function

Public Function WriteDOOR(ByVal FileHandle As Integer, ByRef Record As ES_DOOR)

Dim buffer As Byte
Dim i As Long

With Record
    Put FileHandle, , "DOOR"
    Put FileHandle, , .Size
    Put FileHandle, , .UnknownHeader1
    Put FileHandle, , .Flag
    Put FileHandle, , "NAME"
    Put FileHandle, , .NAMESize
    Put FileHandle, , .NAMEValue
    Put FileHandle, , buffer
    If .Flag.Flag_01 >= 20 Then
        Put FileHandle, , "DELE"
        Put FileHandle, , CLng(4)
        Put FileHandle, , CLng(0)
        Exit Function
    End If
    Put FileHandle, , "MODL"
    Put FileHandle, , .MODLSize
    Put FileHandle, , .MODLValue
    Put FileHandle, , buffer
    If .FNAMSize <> 0 Then
        Put FileHandle, , "FNAM"
        Put FileHandle, , .FNAMSize
        Put FileHandle, , .FNAMValue
        Put FileHandle, , buffer
    End If
    If .SCRISize <> 0 Then
        Put FileHandle, , "SCRI"
        Put FileHandle, , .SCRISize
        Put FileHandle, , .SCRIValue
        Put FileHandle, , buffer
    End If
    If .SNAMSize <> 0 Then
        Put FileHandle, , "SNAM"
        Put FileHandle, , .SNAMSize
        Put FileHandle, , .SNAMValue
        Put FileHandle, , buffer
    End If
    If .ANAMSize <> 0 Then
        Put FileHandle, , "ANAM"
        Put FileHandle, , .ANAMSize
        Put FileHandle, , .ANAMValue
        Put FileHandle, , buffer
    End If
End With

End Function

Public Function WriteMISC(ByVal FileHandle As Integer, ByRef Record As ES_MISC)

Dim buffer As Byte

With Record
    Put FileHandle, , "MISC"
    Put FileHandle, , .Size
    Put FileHandle, , .UnknownHeader1
    Put FileHandle, , .Flag
    Put FileHandle, , "NAME"
    Put FileHandle, , .NAMESize
    Put FileHandle, , .NAMEValue
    Put FileHandle, , buffer
    If .Flag.Flag_01 >= 20 Then
        Put FileHandle, , "DELE"
        Put FileHandle, , CLng(4)
        Put FileHandle, , CLng(0)
        Exit Function
    End If
    Put FileHandle, , "MODL"
    Put FileHandle, , .MODLSize
    Put FileHandle, , .MODLValue
    Put FileHandle, , buffer
    If .FNAMSize <> 0 Then
        Put FileHandle, , "FNAM"
        Put FileHandle, , .FNAMSize
        Put FileHandle, , .FNAMValue
        Put FileHandle, , buffer
    End If
    Put FileHandle, , "MCDT"
    Put FileHandle, , .MCDTSize
    Put FileHandle, , .MCDTWeight
    Put FileHandle, , .MCDTValue
    Put FileHandle, , .MCDTUnknown1
    If .SCRISize <> 0 Then
        Put FileHandle, , "SCRI"
        Put FileHandle, , .SCRISize
        Put FileHandle, , .SCRIValue
        Put FileHandle, , buffer
    End If
    If .ITEXSize <> 0 Then
        Put FileHandle, , "ITEX"
        Put FileHandle, , .ITEXSize
        Put FileHandle, , .ITEXValue
        Put FileHandle, , buffer
    End If
End With

End Function

Public Function WriteWEAP(ByVal FileHandle As Integer, ByRef Record As ES_WEAP)

Dim buffer As Byte

With Record
    Put FileHandle, , "WEAP"
    Put FileHandle, , .Size
    Put FileHandle, , .UnknownHeader1
    Put FileHandle, , .Flag
    Put FileHandle, , "NAME"
    Put FileHandle, , .NAMESize
    Put FileHandle, , .NAMEValue
    Put FileHandle, , buffer
    If .Flag.Flag_01 >= 20 Then
        Put FileHandle, , "DELE"
        Put FileHandle, , CLng(4)
        Put FileHandle, , CLng(0)
        Exit Function
    End If
    Put FileHandle, , "MODL"
    Put FileHandle, , .MODLSize
    Put FileHandle, , .MODLValue
    Put FileHandle, , buffer
    If .FNAMSize <> 0 Then
        Put FileHandle, , "FNAM"
        Put FileHandle, , .FNAMSize
        Put FileHandle, , .FNAMValue
        Put FileHandle, , buffer
    End If
    Put FileHandle, , "WPDT"
    Put FileHandle, , .WPDTSize
    Put FileHandle, , .WPDTWeight
    Put FileHandle, , .WPDTValue
    Put FileHandle, , .WPDTType
    Put FileHandle, , .WPDTHealth
    Put FileHandle, , .WPDTSpeed
    Put FileHandle, , .WPDTReach
    Put FileHandle, , .WPDTEnchPoints
    Put FileHandle, , .WPDTChopMin
    Put FileHandle, , .WPDTChopMax
    Put FileHandle, , .WPDTSlashMin
    Put FileHandle, , .WPDTSlashMax
    Put FileHandle, , .WPDTThrustMin
    Put FileHandle, , .WPDTThrustMax
    Put FileHandle, , .WPDTFlags
    Put FileHandle, , buffer
    Put FileHandle, , buffer
    Put FileHandle, , buffer
    If .SCRISize <> 0 Then
        Put FileHandle, , "SCRI"
        Put FileHandle, , .SCRISize
        Put FileHandle, , .SCRIValue
        Put FileHandle, , buffer
    End If
    If .ITEXSize <> 0 Then
        Put FileHandle, , "ITEX"
        Put FileHandle, , .ITEXSize
        Put FileHandle, , .ITEXValue
        Put FileHandle, , buffer
    End If
    If .ENAMSize <> 0 Then
        Put FileHandle, , "ENAM"
        Put FileHandle, , .ENAMSize
        Put FileHandle, , .ENAMValue
        Put FileHandle, , buffer
    End If
End With

End Function

Public Function WriteCONT(ByVal FileHandle As Integer, ByRef Record As ES_CONT)

Dim buffer As Byte
Dim i As Long

With Record
    Put FileHandle, , "CONT"
    Put FileHandle, , .Size
    Put FileHandle, , .UnknownHeader1
    Put FileHandle, , .Flag
    Put FileHandle, , "NAME"
    Put FileHandle, , .NAMESize
    Put FileHandle, , .NAMEValue
    Put FileHandle, , buffer
    If .Flag.Flag_01 >= 20 Then
        Put FileHandle, , "DELE"
        Put FileHandle, , CLng(4)
        Put FileHandle, , CLng(0)
        Exit Function
    End If
    Put FileHandle, , "MODL"
    Put FileHandle, , .MODLSize
    Put FileHandle, , .MODLValue
    Put FileHandle, , buffer
    If .FNAMSize <> 0 Then
        Put FileHandle, , "FNAM"
        Put FileHandle, , .FNAMSize
        Put FileHandle, , .FNAMValue
        Put FileHandle, , buffer
    End If
    Put FileHandle, , "CNDT"
    Put FileHandle, , .CNDTSize
    Put FileHandle, , .CNDTWeight
    Put FileHandle, , "FLAG"
    Put FileHandle, , .FLAGSize
    Put FileHandle, , .FLAGFlag
    Put FileHandle, , buffer
    Put FileHandle, , buffer
    Put FileHandle, , buffer
    If .INDXSize <> 0 Then
        Put FileHandle, , "INDX"
        Put FileHandle, , .INDXSize
        Put FileHandle, , .INDXValue
    End If
    If .SCRISize <> 0 Then
        Put FileHandle, , "SCRI"
        Put FileHandle, , .SCRISize
        Put FileHandle, , .SCRIValue
        Put FileHandle, , buffer
    End If
    On Error Resume Next
    If .NPCO(LBound(.NPCO)).NPCOSize = 0 Then
    Else
        For i = LBound(.NPCO) To UBound(.NPCO)
            Put FileHandle, , "NPCO"
            Put FileHandle, , .NPCO(i).NPCOSize
            Put FileHandle, , .NPCO(i).NPCOCount
            Put FileHandle, , .NPCO(i).NPCOItem
        Next
    End If
End With

End Function

Public Function WriteSPEL(ByVal FileHandle As Integer, ByRef Record As ES_SPEL)

Dim buffer As Byte
Dim i As Long

With Record
    Put FileHandle, , "SPEL"
    Put FileHandle, , .Size
    Put FileHandle, , .UnknownHeader1
    Put FileHandle, , .Flag
    Put FileHandle, , "NAME"
    Put FileHandle, , .NAMESize
    Put FileHandle, , .NAMEValue
    Put FileHandle, , buffer
    If .Flag.Flag_01 >= 20 Then
        Put FileHandle, , "DELE"
        Put FileHandle, , CLng(4)
        Put FileHandle, , CLng(0)
        Exit Function
    End If
    If .FNAMSize <> 0 Then
        Put FileHandle, , "FNAM"
        Put FileHandle, , .FNAMSize
        Put FileHandle, , .FNAMValue
        Put FileHandle, , buffer
    End If
    Put FileHandle, , "SPDT"
    Put FileHandle, , .SPDTSize
    Put FileHandle, , .SPDTType
    Put FileHandle, , .SPDTCost
    Put FileHandle, , .SPDTFlags
    Put FileHandle, , buffer
    Put FileHandle, , buffer
    Put FileHandle, , buffer
    For i = LBound(.ENAM) To UBound(.ENAM)
        If .ENAM(i).ENAMSize <> 0 Then
            With .ENAM(i)
                Put FileHandle, , "ENAM"
                Put FileHandle, , .ENAMSize
                Put FileHandle, , .ENAMEffectID
                Put FileHandle, , .ENAMSkillID
                Put FileHandle, , .ENAMAttributeID
                Put FileHandle, , .ENAMRange
                Put FileHandle, , buffer
                Put FileHandle, , buffer
                Put FileHandle, , buffer
                Put FileHandle, , .ENAMArea
                Put FileHandle, , .ENAMDuration
                Put FileHandle, , .ENAMMagnitudeMin
                Put FileHandle, , .ENAMMagnitudeMax
            End With
        End If
    Next
End With

End Function

Public Function WriteENCH(ByVal FileHandle As Integer, ByRef Record As ES_ENCH)

Dim buffer As Byte
Dim i As Long

With Record
    Put FileHandle, , "ENCH"
    Put FileHandle, , .Size
    Put FileHandle, , .UnknownHeader1
    Put FileHandle, , .Flag
    Put FileHandle, , "NAME"
    Put FileHandle, , .NAMESize
    Put FileHandle, , .NAMEValue
    Put FileHandle, , buffer
    If .Flag.Flag_01 >= 20 Then
        Put FileHandle, , "DELE"
        Put FileHandle, , CLng(4)
        Put FileHandle, , CLng(0)
        Exit Function
    End If
    Put FileHandle, , "ENDT"
    Put FileHandle, , .ENDTSize
    Put FileHandle, , .ENDTType
    Put FileHandle, , .ENDTCost
    Put FileHandle, , .ENDTCharge
    Put FileHandle, , .ENDTAutoCalc
    Put FileHandle, , buffer
    Put FileHandle, , buffer
    Put FileHandle, , buffer
    For i = LBound(.ENAM) To UBound(.ENAM)
        If .ENAM(i).ENAMSize <> 0 Then
            With .ENAM(i)
                Put FileHandle, , "ENAM"
                Put FileHandle, , .ENAMSize
                Put FileHandle, , .ENAMEffectID
                Put FileHandle, , .ENAMSkillID
                Put FileHandle, , .ENAMAttributeID
                Put FileHandle, , .ENAMRange
                Put FileHandle, , buffer
                Put FileHandle, , buffer
                Put FileHandle, , buffer
                Put FileHandle, , .ENAMArea
                Put FileHandle, , .ENAMDuration
                Put FileHandle, , .ENAMMagnitudeMin
                Put FileHandle, , .ENAMMagnitudeMax
            End With
        End If
    Next
End With

End Function

Public Function WriteBODY(ByVal FileHandle As Integer, ByRef Record As ES_BODY)

Dim buffer As Byte

With Record
    Put FileHandle, , "BODY"
    Put FileHandle, , .Size
    Put FileHandle, , .UnknownHeader1
    Put FileHandle, , .Flag
    Put FileHandle, , "NAME"
    Put FileHandle, , .NAMESize
    Put FileHandle, , .NAMEValue
    Put FileHandle, , buffer
    If .Flag.Flag_01 >= 20 Then
        Put FileHandle, , "DELE"
        Put FileHandle, , CLng(4)
        Put FileHandle, , CLng(0)
        Exit Function
    End If
    Put FileHandle, , "MODL"
    Put FileHandle, , .MODLSize
    Put FileHandle, , .MODLValue
    Put FileHandle, , buffer
    If .FNAMSize <> 0 Then
        Put FileHandle, , "FNAM"
        Put FileHandle, , .FNAMSize
        Put FileHandle, , .FNAMValue
        Put FileHandle, , buffer
    End If
    Put FileHandle, , "BYDT"
    Put FileHandle, , .BYDTSize
    Put FileHandle, , .BYDTPart
    Put FileHandle, , .BYDTVampire
    Put FileHandle, , .BYDTFlags
    Put FileHandle, , .BYDTType
End With

End Function

Public Function WriteLIGH(ByVal FileHandle As Integer, ByRef Record As ES_LIGH)

Dim buffer As Byte

With Record
    Put FileHandle, , "LIGH"
    Put FileHandle, , .Size
    Put FileHandle, , .UnknownHeader1
    Put FileHandle, , .Flag
    Put FileHandle, , "NAME"
    Put FileHandle, , .NAMESize
    Put FileHandle, , .NAMEValue
    Put FileHandle, , buffer
    If .Flag.Flag_01 >= 20 Then
        Put FileHandle, , "DELE"
        Put FileHandle, , CLng(4)
        Put FileHandle, , CLng(0)
        Exit Function
    End If
    Put FileHandle, , "MODL"
    Put FileHandle, , .MODLSize
    Put FileHandle, , .MODLValue
    Put FileHandle, , buffer
    If .FNAMSize <> 0 Then
        Put FileHandle, , "FNAM"
        Put FileHandle, , .FNAMSize
        Put FileHandle, , .FNAMValue
        Put FileHandle, , buffer
    End If
    If .ITEXSize <> 0 Then
        Put FileHandle, , "ITEX"
        Put FileHandle, , .ITEXSize
        Put FileHandle, , .ITEXValue
        Put FileHandle, , buffer
    End If
    Put FileHandle, , "LHDT"
    Put FileHandle, , .LHDTSize
    Put FileHandle, , .LHDTWeight
    Put FileHandle, , .LHDTValue
    Put FileHandle, , .LHDTTime
    Put FileHandle, , .LHDTRadius
    Put FileHandle, , .LHDTRed
    Put FileHandle, , .LHDTGreen
    Put FileHandle, , .LHDTBlue
    Put FileHandle, , buffer
    Put FileHandle, , .LHDTFlags
    If .SCRISize <> 0 Then
        Put FileHandle, , "SCRI"
        Put FileHandle, , .SCRISize
        Put FileHandle, , .SCRIValue
        Put FileHandle, , buffer
    End If
    If .SNAMSize <> 0 Then
        Put FileHandle, , "SNAM"
        Put FileHandle, , .SNAMSize
        Put FileHandle, , .SNAMValue
        Put FileHandle, , buffer
    End If
End With

End Function

Public Function WriteARMO(ByVal FileHandle As Integer, ByRef Record As ES_ARMO)

Dim buffer As Byte
Dim i As Long

With Record
    Put FileHandle, , "ARMO"
    Put FileHandle, , .Size
    Put FileHandle, , .UnknownHeader1
    Put FileHandle, , .Flag
    Put FileHandle, , "NAME"
    Put FileHandle, , .NAMESize
    Put FileHandle, , .NAMEValue
    Put FileHandle, , buffer
    If .Flag.Flag_01 >= 20 Then
        Put FileHandle, , "DELE"
        Put FileHandle, , CLng(4)
        Put FileHandle, , CLng(0)
        Exit Function
    End If
    Put FileHandle, , "MODL"
    Put FileHandle, , .MODLSize
    Put FileHandle, , .MODLValue
    Put FileHandle, , buffer
    If .FNAMSize <> 0 Then
        Put FileHandle, , "FNAM"
        Put FileHandle, , .FNAMSize
        Put FileHandle, , .FNAMValue
        Put FileHandle, , buffer
    End If
    If .SCRISize <> 0 Then
        Put FileHandle, , "SCRI"
        Put FileHandle, , .SCRISize
        Put FileHandle, , .SCRIValue
        Put FileHandle, , buffer
    End If
    Put FileHandle, , "AODT"
    Put FileHandle, , .AODTSize
    Put FileHandle, , .AODTType
    Put FileHandle, , .AODTWeight
    Put FileHandle, , .AODTValue
    Put FileHandle, , .AODTHealth
    Put FileHandle, , .AODTEnchPoints
    Put FileHandle, , .AODTArmorRating
    If .ITEXSize <> 0 Then
        Put FileHandle, , "ITEX"
        Put FileHandle, , .ITEXSize
        Put FileHandle, , .ITEXValue
        Put FileHandle, , buffer
    End If
    For i = LBound(.BipedParts) To UBound(.BipedParts)
        With .BipedParts(i)
            If .INDXSize <> 0 Then
                Put FileHandle, , "INDX"
                Put FileHandle, , .INDXSize
                Put FileHandle, , .INDXValue
                If .BNAMSize <> 0 Then
                    Put FileHandle, , "BNAM"
                    Put FileHandle, , .BNAMSize
                    Put FileHandle, , .BNAMValue
                End If
                If .CNAMSize <> 0 Then
                    Put FileHandle, , "CNAM"
                    Put FileHandle, , .CNAMSize
                    Put FileHandle, , .CNAMValue
                End If
            End If
        End With
    Next
    If .ENAMSize <> 0 Then
        Put FileHandle, , "ENAM"
        Put FileHandle, , .ENAMSize
        Put FileHandle, , .ENAMValue
        Put FileHandle, , buffer
    End If
End With

End Function

Public Function WriteCLOT(ByVal FileHandle As Integer, ByRef Record As ES_CLOT)

Dim buffer As Byte
Dim i As Long

With Record
    Put FileHandle, , "CLOT"
    Put FileHandle, , .Size
    Put FileHandle, , .UnknownHeader1
    Put FileHandle, , .Flag
    Put FileHandle, , "NAME"
    Put FileHandle, , .NAMESize
    Put FileHandle, , .NAMEValue
    Put FileHandle, , buffer
    If .Flag.Flag_01 >= 20 Then
        Put FileHandle, , "DELE"
        Put FileHandle, , CLng(4)
        Put FileHandle, , CLng(0)
        Exit Function
    End If
    Put FileHandle, , "MODL"
    Put FileHandle, , .MODLSize
    Put FileHandle, , .MODLValue
    Put FileHandle, , buffer
    If .FNAMSize <> 0 Then
        Put FileHandle, , "FNAM"
        Put FileHandle, , .FNAMSize
        Put FileHandle, , .FNAMValue
        Put FileHandle, , buffer
    End If
    If .SCRISize <> 0 Then
        Put FileHandle, , "SCRI"
        Put FileHandle, , .SCRISize
        Put FileHandle, , .SCRIValue
        Put FileHandle, , buffer
    End If
    Put FileHandle, , "CTDT"
    Put FileHandle, , .CTDTSize
    Put FileHandle, , .CTDTType
    Put FileHandle, , .CTDTWeight
    Put FileHandle, , .CTDTValue
    Put FileHandle, , .CTDTEnchPoints
    If .ITEXSize <> 0 Then
        Put FileHandle, , "ITEX"
        Put FileHandle, , .ITEXSize
        Put FileHandle, , .ITEXValue
        Put FileHandle, , buffer
    End If
    For i = LBound(.BipedParts) To UBound(.BipedParts)
        With .BipedParts(i)
            If .INDXSize <> 0 Then
                Put FileHandle, , "INDX"
                Put FileHandle, , .INDXSize
                Put FileHandle, , .INDXValue
                If .BNAMSize <> 0 Then
                    Put FileHandle, , "BNAM"
                    Put FileHandle, , .BNAMSize
                    Put FileHandle, , .BNAMValue
                End If
                If .CNAMSize <> 0 Then
                    Put FileHandle, , "CNAM"
                    Put FileHandle, , .CNAMSize
                    Put FileHandle, , .CNAMValue
                End If
            End If
        End With
    Next
    If .ENAMSize <> 0 Then
        Put FileHandle, , "ENAM"
        Put FileHandle, , .ENAMSize
        Put FileHandle, , .ENAMValue
        Put FileHandle, , buffer
    End If
End With

End Function

Public Function WriteREPA(ByVal FileHandle As Integer, ByRef Record As ES_REPA)

Dim buffer As Byte
Dim i As Long

With Record
    Put FileHandle, , "REPA"
    Put FileHandle, , .Size
    Put FileHandle, , .UnknownHeader1
    Put FileHandle, , .Flag
    Put FileHandle, , "NAME"
    Put FileHandle, , .NAMESize
    Put FileHandle, , .NAMEValue
    Put FileHandle, , buffer
    If .Flag.Flag_01 >= 20 Then
        Put FileHandle, , "DELE"
        Put FileHandle, , CLng(4)
        Put FileHandle, , CLng(0)
        Exit Function
    End If
    Put FileHandle, , "MODL"
    Put FileHandle, , .MODLSize
    Put FileHandle, , .MODLValue
    Put FileHandle, , buffer
    If .FNAMSize <> 0 Then
        Put FileHandle, , "FNAM"
        Put FileHandle, , .FNAMSize
        Put FileHandle, , .FNAMValue
        Put FileHandle, , buffer
    End If
    Put FileHandle, , "RIDT"
    Put FileHandle, , .RIDTSize
    Put FileHandle, , .RIDTWeight
    Put FileHandle, , .RIDTValue
    Put FileHandle, , .RIDTUses
    Put FileHandle, , .RIDTQuality
    If .SCRISize <> 0 Then
        Put FileHandle, , "SCRI"
        Put FileHandle, , .SCRISize
        Put FileHandle, , .SCRIValue
        Put FileHandle, , buffer
    End If
    If .ITEXSize <> 0 Then
        Put FileHandle, , "ITEX"
        Put FileHandle, , .ITEXSize
        Put FileHandle, , .ITEXValue
        Put FileHandle, , buffer
    End If
End With

End Function

Public Function WriteACTI(ByVal FileHandle As Integer, ByRef Record As ES_ACTI)

Dim buffer As Byte
Dim i As Long

With Record
    Put FileHandle, , "ACTI"
    Put FileHandle, , .Size
    Put FileHandle, , .UnknownHeader1
    Put FileHandle, , .Flag
    Put FileHandle, , "NAME"
    Put FileHandle, , .NAMESize
    Put FileHandle, , .NAMEValue
    Put FileHandle, , buffer
    If .Flag.Flag_01 >= 20 Then
        Put FileHandle, , "DELE"
        Put FileHandle, , CLng(4)
        Put FileHandle, , CLng(0)
        Exit Function
    End If
    Put FileHandle, , "MODL"
    Put FileHandle, , .MODLSize
    Put FileHandle, , .MODLValue
    Put FileHandle, , buffer
    If .FNAMSize <> 0 Then
        Put FileHandle, , "FNAM"
        Put FileHandle, , .FNAMSize
        Put FileHandle, , .FNAMValue
        Put FileHandle, , buffer
    End If
    If .SCRISize <> 0 Then
        Put FileHandle, , "SCRI"
        Put FileHandle, , .SCRISize
        Put FileHandle, , .SCRIValue
        Put FileHandle, , buffer
    End If
End With

End Function

Public Function WriteAPPA(ByVal FileHandle As Integer, ByRef Record As ES_APPA)

Dim buffer As Byte
Dim i As Long

With Record
    Put FileHandle, , "APPA"
    Put FileHandle, , .Size
    Put FileHandle, , .UnknownHeader1
    Put FileHandle, , .Flag
    Put FileHandle, , "NAME"
    Put FileHandle, , .NAMESize
    Put FileHandle, , .NAMEValue
    Put FileHandle, , buffer
    If .Flag.Flag_01 >= 20 Then
        Put FileHandle, , "DELE"
        Put FileHandle, , CLng(4)
        Put FileHandle, , CLng(0)
        Exit Function
    End If
    Put FileHandle, , "MODL"
    Put FileHandle, , .MODLSize
    Put FileHandle, , .MODLValue
    Put FileHandle, , buffer
    If .FNAMSize <> 0 Then
        Put FileHandle, , "FNAM"
        Put FileHandle, , .FNAMSize
        Put FileHandle, , .FNAMValue
        Put FileHandle, , buffer
    End If
    If .SCRISize <> 0 Then
        Put FileHandle, , "SCRI"
        Put FileHandle, , .SCRISize
        Put FileHandle, , .SCRIValue
        Put FileHandle, , buffer
    End If
    Put FileHandle, , "AADT"
    Put FileHandle, , .AADTSize
    Put FileHandle, , .AADTType
    Put FileHandle, , .AADTQuality
    Put FileHandle, , .AADTWeight
    Put FileHandle, , .AADTValue
    If .ITEXSize <> 0 Then
        Put FileHandle, , "ITEX"
        Put FileHandle, , .ITEXSize
        Put FileHandle, , .ITEXValue
        Put FileHandle, , buffer
    End If
End With

End Function

Public Function WriteLOCK(ByVal FileHandle As Integer, ByRef Record As ES_LOCK)

Dim buffer As Byte
Dim i As Long

With Record
    Put FileHandle, , "LOCK"
    Put FileHandle, , .Size
    Put FileHandle, , .UnknownHeader1
    Put FileHandle, , .Flag
    Put FileHandle, , "NAME"
    Put FileHandle, , .NAMESize
    Put FileHandle, , .NAMEValue
    Put FileHandle, , buffer
    If .Flag.Flag_01 >= 20 Then
        Put FileHandle, , "DELE"
        Put FileHandle, , CLng(4)
        Put FileHandle, , CLng(0)
        Exit Function
    End If
    Put FileHandle, , "MODL"
    Put FileHandle, , .MODLSize
    Put FileHandle, , .MODLValue
    Put FileHandle, , buffer
    If .FNAMSize <> 0 Then
        Put FileHandle, , "FNAM"
        Put FileHandle, , .FNAMSize
        Put FileHandle, , .FNAMValue
        Put FileHandle, , buffer
    End If
    Put FileHandle, , "LKDT"
    Put FileHandle, , .LKDTSize
    Put FileHandle, , .LKDTWeight
    Put FileHandle, , .LKDTValue
    Put FileHandle, , .LKDTQuality
    Put FileHandle, , .LKDTUses
    If .SCRISize <> 0 Then
        Put FileHandle, , "SCRI"
        Put FileHandle, , .SCRISize
        Put FileHandle, , .SCRIValue
        Put FileHandle, , buffer
    End If
    If .ITEXSize <> 0 Then
        Put FileHandle, , "ITEX"
        Put FileHandle, , .ITEXSize
        Put FileHandle, , .ITEXValue
        Put FileHandle, , buffer
    End If
End With

End Function

Public Function WritePROB(ByVal FileHandle As Integer, ByRef Record As ES_PROB)

Dim buffer As Byte
Dim i As Long

With Record
    Put FileHandle, , "PROB"
    Put FileHandle, , .Size
    Put FileHandle, , .UnknownHeader1
    Put FileHandle, , .Flag
    Put FileHandle, , "NAME"
    Put FileHandle, , .NAMESize
    Put FileHandle, , .NAMEValue
    Put FileHandle, , buffer
    If .Flag.Flag_01 >= 20 Then
        Put FileHandle, , "DELE"
        Put FileHandle, , CLng(4)
        Put FileHandle, , CLng(0)
        Exit Function
    End If
    Put FileHandle, , "MODL"
    Put FileHandle, , .MODLSize
    Put FileHandle, , .MODLValue
    Put FileHandle, , buffer
    If .FNAMSize <> 0 Then
        Put FileHandle, , "FNAM"
        Put FileHandle, , .FNAMSize
        Put FileHandle, , .FNAMValue
        Put FileHandle, , buffer
    End If
    Put FileHandle, , "PBDT"
    Put FileHandle, , .PBDTSize
    Put FileHandle, , .PBDTWeight
    Put FileHandle, , .PBDTValue
    Put FileHandle, , .PBDTQuality
    Put FileHandle, , .PBDTUses
    If .SCRISize <> 0 Then
        Put FileHandle, , "SCRI"
        Put FileHandle, , .SCRISize
        Put FileHandle, , .SCRIValue
        Put FileHandle, , buffer
    End If
    If .ITEXSize <> 0 Then
        Put FileHandle, , "ITEX"
        Put FileHandle, , .ITEXSize
        Put FileHandle, , .ITEXValue
        Put FileHandle, , buffer
    End If
End With

End Function

Public Function WriteINGR(ByVal FileHandle As Integer, ByRef Record As ES_INGR)

Dim buffer As Byte
Dim i As Long

With Record
    Put FileHandle, , "INGR"
    Put FileHandle, , .Size
    Put FileHandle, , .UnknownHeader1
    Put FileHandle, , .Flag
    Put FileHandle, , "NAME"
    Put FileHandle, , .NAMESize
    Put FileHandle, , .NAMEValue
    Put FileHandle, , buffer
    If .Flag.Flag_01 >= 20 Then
        Put FileHandle, , "DELE"
        Put FileHandle, , CLng(4)
        Put FileHandle, , CLng(0)
        Exit Function
    End If
    Put FileHandle, , "MODL"
    Put FileHandle, , .MODLSize
    Put FileHandle, , .MODLValue
    Put FileHandle, , buffer
    If .FNAMSize <> 0 Then
        Put FileHandle, , "FNAM"
        Put FileHandle, , .FNAMSize
        Put FileHandle, , .FNAMValue
        Put FileHandle, , buffer
    End If
    Put FileHandle, , "IRDT"
    Put FileHandle, , .IRDTSize
    Put FileHandle, , .IRDTWeight
    Put FileHandle, , .IRDTValue
    Put FileHandle, , .IRDTEffectID(0)
    Put FileHandle, , .IRDTEffectID(1)
    Put FileHandle, , .IRDTEffectID(2)
    Put FileHandle, , .IRDTEffectID(3)
    Put FileHandle, , .IRDTSkillID(0)
    Put FileHandle, , .IRDTSkillID(1)
    Put FileHandle, , .IRDTSkillID(2)
    Put FileHandle, , .IRDTSkillID(3)
    Put FileHandle, , .IRDTAttributeID(0)
    Put FileHandle, , .IRDTAttributeID(1)
    Put FileHandle, , .IRDTAttributeID(2)
    Put FileHandle, , .IRDTAttributeID(3)
    If .SCRISize <> 0 Then
        Put FileHandle, , "SCRI"
        Put FileHandle, , .SCRISize
        Put FileHandle, , .SCRIValue
        Put FileHandle, , buffer
    End If
    If .ITEXSize <> 0 Then
        Put FileHandle, , "ITEX"
        Put FileHandle, , .ITEXSize
        Put FileHandle, , .ITEXValue
        Put FileHandle, , buffer
    End If
End With

End Function

Public Function WriteBOOK(ByVal FileHandle As Integer, ByRef Record As ES_BOOK)

Dim buffer As Byte
Dim i As Long

With Record
    Put FileHandle, , "BOOK"
    Put FileHandle, , .Size
    Put FileHandle, , .UnknownHeader1
    Put FileHandle, , .Flag
    Put FileHandle, , "NAME"
    Put FileHandle, , .NAMESize
    Put FileHandle, , .NAMEValue
    Put FileHandle, , buffer
    If .Flag.Flag_01 >= 20 Then
        Put FileHandle, , "DELE"
        Put FileHandle, , CLng(4)
        Put FileHandle, , CLng(0)
        Exit Function
    End If
    Put FileHandle, , "MODL"
    Put FileHandle, , .MODLSize
    Put FileHandle, , .MODLValue
    Put FileHandle, , buffer
    If .FNAMSize <> 0 Then
        Put FileHandle, , "FNAM"
        Put FileHandle, , .FNAMSize
        Put FileHandle, , .FNAMValue
        Put FileHandle, , buffer
    End If
    Put FileHandle, , "BKDT"
    Put FileHandle, , .BKDTSize
    Put FileHandle, , .BKDTWeight
    Put FileHandle, , .BKDTValue
    Put FileHandle, , .BKDTScroll
    Put FileHandle, , .BKDTSkillID
    Put FileHandle, , .BKDTEnchantVal
    If .SCRISize <> 0 Then
        Put FileHandle, , "SCRI"
        Put FileHandle, , .SCRISize
        Put FileHandle, , .SCRIValue
        Put FileHandle, , buffer
    End If
    If .ITEXSize <> 0 Then
        Put FileHandle, , "ITEX"
        Put FileHandle, , .ITEXSize
        Put FileHandle, , .ITEXValue
        Put FileHandle, , buffer
    End If
    If .TEXTSize <> 0 Then
        Put FileHandle, , "TEXT"
        Put FileHandle, , .TEXTSize
        Put FileHandle, , .TEXTValue
    End If
    If .ENAMSize <> 0 Then
        Put FileHandle, , "ENAM"
        Put FileHandle, , .ENAMSize
        Put FileHandle, , .ENAMValue
        Put FileHandle, , buffer
    End If
End With

End Function

Public Function WriteALCH(ByVal FileHandle As Integer, ByRef Record As ES_ALCH)

Dim buffer As Byte
Dim i As Long

With Record
    Put FileHandle, , "ALCH"
    Put FileHandle, , .Size
    Put FileHandle, , .UnknownHeader1
    Put FileHandle, , .Flag
    Put FileHandle, , "NAME"
    Put FileHandle, , .NAMESize
    Put FileHandle, , .NAMEValue
    Put FileHandle, , buffer
    If .Flag.Flag_01 >= 20 Then
        Put FileHandle, , "DELE"
        Put FileHandle, , CLng(4)
        Put FileHandle, , CLng(0)
        Exit Function
    End If
    Put FileHandle, , "MODL"
    Put FileHandle, , .MODLSize
    Put FileHandle, , .MODLValue
    Put FileHandle, , buffer
    If .FNAMSize <> 0 Then
        Put FileHandle, , "FNAM"
        Put FileHandle, , .FNAMSize
        Put FileHandle, , .FNAMValue
        Put FileHandle, , buffer
    End If
    Put FileHandle, , "ALDT"
    Put FileHandle, , .ALDTSize
    Put FileHandle, , .ALDTWeight
    Put FileHandle, , .ALDTValue
    Put FileHandle, , .ALDTAutoCalc
    If .SCRISize <> 0 Then
        Put FileHandle, , "SCRI"
        Put FileHandle, , .SCRISize
        Put FileHandle, , .SCRIValue
        Put FileHandle, , buffer
    End If
    If .TEXTSize <> 0 Then
        Put FileHandle, , "TEXT"
        Put FileHandle, , .TEXTSize
        Put FileHandle, , .TEXTValue
        Put FileHandle, , buffer
    End If
    For i = LBound(.ENAM) To UBound(.ENAM)
        If .ENAM(i).ENAMSize <> 0 Then
            With .ENAM(i)
                Put FileHandle, , "ENAM"
                Put FileHandle, , .ENAMSize
                Put FileHandle, , .ENAMEffectID
                Put FileHandle, , .ENAMSkillID
                Put FileHandle, , .ENAMAttributeID
                Put FileHandle, , .ENAMRange
                Put FileHandle, , buffer
                Put FileHandle, , buffer
                Put FileHandle, , buffer
                Put FileHandle, , .ENAMArea
                Put FileHandle, , .ENAMDuration
                Put FileHandle, , .ENAMMagnitudeMin
                Put FileHandle, , .ENAMMagnitudeMax
            End With
        End If
    Next
End With

End Function

Public Function WriteLEVI(ByVal FileHandle As Integer, ByRef Record As ES_LEVI)

Dim buffer As Byte
Dim i As Long

With Record
    Put FileHandle, , "LEVI"
    Put FileHandle, , .Size
    Put FileHandle, , .UnknownHeader1
    Put FileHandle, , .Flag
    Put FileHandle, , "NAME"
    Put FileHandle, , .NAMESize
    Put FileHandle, , .NAMEValue
    Put FileHandle, , buffer
    If .Flag.Flag_01 >= 20 Then
        Put FileHandle, , "DELE"
        Put FileHandle, , CLng(4)
        Put FileHandle, , CLng(0)
        Exit Function
    End If
    Put FileHandle, , "DATA"
    Put FileHandle, , .DATASize
    Put FileHandle, , .DATAValue
    Put FileHandle, , buffer
    Put FileHandle, , buffer
    Put FileHandle, , buffer
    Put FileHandle, , "NNAM"
    Put FileHandle, , .NNAMSize
    Put FileHandle, , .NNAMValue
    If .INDXSize <> 0 Then
        Put FileHandle, , "INDX"
        Put FileHandle, , .INDXSize
        Put FileHandle, , .INDXValue
    End If
    On Error Resume Next
    If .Items(LBound(.Items)).INAMSize = 0 Then
    Else
        For i = LBound(.Items) To UBound(.Items)
            With .Items(i)
                Put FileHandle, , "INAM"
                Put FileHandle, , .INAMSize
                Put FileHandle, , .INAMValue
                Put FileHandle, , buffer
                Put FileHandle, , "INTV"
                Put FileHandle, , .INTVSize
                Put FileHandle, , .INTVValue
            End With
        Next
    End If
End With

End Function

Public Function WriteLEVC(ByVal FileHandle As Integer, ByRef Record As ES_LEVC)

Dim buffer As Byte
Dim i As Long

With Record
    Put FileHandle, , "LEVC"
    Put FileHandle, , .Size
    Put FileHandle, , .UnknownHeader1
    Put FileHandle, , .Flag
    Put FileHandle, , "NAME"
    Put FileHandle, , .NAMESize
    Put FileHandle, , .NAMEValue
    Put FileHandle, , buffer
    If .Flag.Flag_01 >= 20 Then
        Put FileHandle, , "DELE"
        Put FileHandle, , CLng(4)
        Put FileHandle, , CLng(0)
        Exit Function
    End If
    Put FileHandle, , "DATA"
    Put FileHandle, , .DATASize
    Put FileHandle, , .DATAValue
    Put FileHandle, , buffer
    Put FileHandle, , buffer
    Put FileHandle, , buffer
    Put FileHandle, , "NNAM"
    Put FileHandle, , .NNAMSize
    Put FileHandle, , .NNAMValue
    If .INDXSize <> 0 Then
        Put FileHandle, , "INDX"
        Put FileHandle, , .INDXSize
        Put FileHandle, , .INDXValue
    End If
    On Error Resume Next
    If .Creatures(LBound(.Creatures)).CNAMSize = 0 Then
    Else
        For i = LBound(.Creatures) To UBound(.Creatures)
            With .Creatures(i)
                Put FileHandle, , "CNAM"
                Put FileHandle, , .CNAMSize
                Put FileHandle, , .CNAMValue
                Put FileHandle, , buffer
                Put FileHandle, , "INTV"
                Put FileHandle, , .INTVSize
                Put FileHandle, , .INTVValue
            End With
        Next
    End If
End With

End Function

Public Function WriteSNDG(ByVal FileHandle As Integer, ByRef Record As ES_SNDG)

Dim buffer As Byte
Dim i As Long

With Record
    Put FileHandle, , "SNDG"
    Put FileHandle, , .Size
    Put FileHandle, , .UnknownHeader1
    Put FileHandle, , .Flag
    Put FileHandle, , "NAME"
    Put FileHandle, , .NAMESize
    Put FileHandle, , .NAMEValue
    Put FileHandle, , buffer
    If .Flag.Flag_01 >= 20 Then
        Put FileHandle, , "DELE"
        Put FileHandle, , CLng(4)
        Put FileHandle, , CLng(0)
        Exit Function
    End If
    Put FileHandle, , "DATA"
    Put FileHandle, , .DATASize
    Put FileHandle, , .DATAValue
    Put FileHandle, , buffer
    Put FileHandle, , buffer
    Put FileHandle, , buffer
    Put FileHandle, , "SNAM"
    Put FileHandle, , .SNAMSize
    Put FileHandle, , .SNAMValue
    Put FileHandle, , buffer
    If .CNAMSize <> 0 Then
        Put FileHandle, , "CNAM"
        Put FileHandle, , .CNAMSize
        Put FileHandle, , .CNAMValue
        Put FileHandle, , buffer
    End If
End With

End Function

Public Function WriteSSCR(ByVal FileHandle As Integer, ByRef Record As ES_SSCR)

Dim buffer As Byte
Dim i As Long

With Record
    Put FileHandle, , "SSCR"
    Put FileHandle, , .Size
    Put FileHandle, , .UnknownHeader1
    Put FileHandle, , .Flag
    If .Flag.Flag_01 >= 20 Then
        Put FileHandle, , "DELE"
        Put FileHandle, , CLng(4)
        Put FileHandle, , CLng(0)
    End If
    Put FileHandle, , "NAME"
    Put FileHandle, , .NAMESize
    Put FileHandle, , .NAMEValue
    Put FileHandle, , "DATA"
    Put FileHandle, , .DATASize
    Put FileHandle, , .DATAValue
End With

End Function

Public Function WritePGRD(ByVal FileHandle As Integer, ByRef Record As ES_PGRD)

Dim buffer As Byte
Dim i As Long

With Record
    Put FileHandle, , "PGRD"
    Put FileHandle, , .Size
    Put FileHandle, , .UnknownHeader1
    Put FileHandle, , .Flag
    Put FileHandle, , "DATA"
    Put FileHandle, , .DATASize
    Put FileHandle, , .DATAGridX
    Put FileHandle, , .DATAGridY
    Put FileHandle, , .DATAGranularity
    Put FileHandle, , .DATAPointsCount
    Put FileHandle, , "NAME"
    Put FileHandle, , .NAMESize
    Put FileHandle, , .NAMEValue
    Put FileHandle, , buffer
    If .PGRPSize <> 0 Then
        Put FileHandle, , "PGRP"
        Put FileHandle, , .PGRPSize
        For i = 0 To (.PGRPSize / 16) - 1
            With .PGRPPoints(i)
                Put FileHandle, , .PGRPCoordX
                Put FileHandle, , .PGRPCoordY
                Put FileHandle, , .PGRPCoordZ
                Put FileHandle, , .PGRPUnknown1
                Put FileHandle, , .PGRPConnectCount
                Put FileHandle, , .PGRPUnknown2
                Put FileHandle, , .PGRPUnknown3
            End With
        Next
    End If
    If .PGRCSize <> 0 Then
        Put FileHandle, , "PGRC"
        Put FileHandle, , .PGRCSize
        For i = 0 To (.PGRCSize / 4) - 1
            Put FileHandle, , .PGRCData(i)
        Next
    End If
End With

End Function

Public Function WriteNPC_(ByVal FileHandle As Integer, ByRef Record As ES_NPC_)

Dim buffer As Byte
Dim i As Long
Dim l As Long

With Record
    Put FileHandle, , "NPC_"
    Put FileHandle, , .Size
    Put FileHandle, , .UnknownHeader1
    Put FileHandle, , .Flag
    Put FileHandle, , "NAME"
    Put FileHandle, , .NAMESize
    Put FileHandle, , .NAMEValue
    Put FileHandle, , buffer
    If .Flag.Flag_01 >= 20 Then
        Put FileHandle, , "DELE"
        Put FileHandle, , CLng(4)
        Put FileHandle, , CLng(0)
        Exit Function
    End If
    If .MODLSize <> 0 Then
        Put FileHandle, , "MODL"
        Put FileHandle, , .MODLSize
        Put FileHandle, , .MODLValue
        Put FileHandle, , buffer
    End If
    If .FNAMSize <> 0 Then
        Put FileHandle, , "FNAM"
        Put FileHandle, , .FNAMSize
        Put FileHandle, , .FNAMValue
        Put FileHandle, , buffer
    End If
    If .RNAMSize <> 0 Then
        Put FileHandle, , "RNAM"
        Put FileHandle, , .RNAMSize
        Put FileHandle, , .RNAMValue
        Put FileHandle, , buffer
    End If
    If .CNAMSize <> 0 Then
        Put FileHandle, , "CNAM"
        Put FileHandle, , .CNAMSize
        Put FileHandle, , .CNAMValue
        Put FileHandle, , buffer
    End If
    If .ANAMSize <> 0 Then
        Put FileHandle, , "ANAM"
        Put FileHandle, , .ANAMSize
        Put FileHandle, , .ANAMValue
        Put FileHandle, , buffer
    End If
    If .BNAMSize <> 0 Then
        Put FileHandle, , "BNAM"
        Put FileHandle, , .BNAMSize
        Put FileHandle, , .BNAMValue
        Put FileHandle, , buffer
    End If
    If .KNAMSize <> 0 Then
        Put FileHandle, , "KNAM"
        Put FileHandle, , .KNAMSize
        Put FileHandle, , .KNAMValue
        Put FileHandle, , buffer
    End If
    If .SCRISize <> 0 Then
        Put FileHandle, , "SCRI"
        Put FileHandle, , .SCRISize
        Put FileHandle, , .SCRIValue
        Put FileHandle, , buffer
    End If
    Put FileHandle, , "NPDT"
    Put FileHandle, , .NPDTSize
    If .NPDTSize = 12 Then
        Put FileHandle, , .NPDTDataS
    Else
        Put FileHandle, , .NPDTDataL
    End If
    Put FileHandle, , "FLAG"
    Put FileHandle, , .FLAGSize
    Put FileHandle, , .FLAGGeneral
    Put FileHandle, , .FLAGBlood
    Put FileHandle, , buffer
    Put FileHandle, , buffer
    If .INDXSize <> 0 Then
        Put FileHandle, , "INDX"
        Put FileHandle, , .INDXSize
        Put FileHandle, , .INDXValue
    End If
    On Error Resume Next
    If .NPCO(LBound(.NPCO)).NPCOSize = 0 Then
    Else
        For i = LBound(.NPCO) To UBound(.NPCO)
            Put FileHandle, , "NPCO"
            Put FileHandle, , .NPCO(i).NPCOSize
            Put FileHandle, , .NPCO(i).NPCOCount
            Put FileHandle, , .NPCO(i).NPCOItem
        Next
    End If
    If .NPCS(LBound(.NPCS)).NPCSSize = 0 Then
    Else
        For i = LBound(.NPCS) To UBound(.NPCS)
            Put FileHandle, , "NPCS"
            Put FileHandle, , .NPCS(i).NPCSSize
            Put FileHandle, , .NPCS(i).NPCSItem
        Next
    End If
    If .AIDTSize <> 0 Then
        Put FileHandle, , "AIDT"
        Put FileHandle, , .AIDTSize
        Put FileHandle, , .AIDTHello
        Put FileHandle, , .AIDTUnknown1
        Put FileHandle, , .AIDTFight
        Put FileHandle, , .AIDTFlee
        Put FileHandle, , .AIDTAlarm
        Put FileHandle, , .AIDTUnknown2
        Put FileHandle, , .AIDTUnknown3
        Put FileHandle, , .AIDTUnknown4
        Put FileHandle, , .AIDTFlag
    End If
    For i = 0 To 3
        If .DODT(i).DODTSize <> 0 Then
            With .DODT(i)
                Put FileHandle, , "DODT"
                Put FileHandle, , .DODTSize
                Put FileHandle, , .DODTPosX
                Put FileHandle, , .DODTPosY
                Put FileHandle, , .DODTPosZ
                Put FileHandle, , .DODTRotX
                Put FileHandle, , .DODTRotY
                Put FileHandle, , .DODTRotZ
                If .DNAMSize <> 0 Then
                    Put FileHandle, , "DNAM"
                    Put FileHandle, , .DNAMSize
                    Put FileHandle, , .DNAMValue
                    Put FileHandle, , buffer
                End If
            End With
        End If
    Next
    If .AI_W(LBound(.AI_W)).AI_WSize = 0 Then
    Else
        For i = LBound(.AI_W) To UBound(.AI_W)
            With .AI_W(i)
                Put FileHandle, , "AI_W"
                Put FileHandle, , .AI_WSize
                Put FileHandle, , .AI_WDistance
                Put FileHandle, , .AI_WDuration
                Put FileHandle, , .AI_WTime
                For l = 0 To 7
                    Put FileHandle, , .AI_WIdles(l)
                Next
                Put FileHandle, , .AI_WUnknown
            End With
        Next
    End If
    If .AI_T(LBound(.AI_T)).AI_TSize = 0 Then
    Else
        For i = LBound(.AI_T) To UBound(.AI_T)
            With .AI_T(i)
                Put FileHandle, , "AI_T"
                Put FileHandle, , .AI_TSize
                Put FileHandle, , .AI_TCoordX
                Put FileHandle, , .AI_TCoordY
                Put FileHandle, , .AI_TCoordZ
                Put FileHandle, , .AI_TUnknown
            End With
        Next
    End If
    If .AI_E(LBound(.AI_E)).AI_ESize = 0 Then
    Else
        For i = LBound(.AI_E) To UBound(.AI_E)
            With .AI_E(i)
                Put FileHandle, , "AI_E"
                Put FileHandle, , .AI_ESize
                Put FileHandle, , .AI_ECoordX
                Put FileHandle, , .AI_ECoordY
                Put FileHandle, , .AI_ECoordZ
                Put FileHandle, , .AI_EDuration
                Put FileHandle, , .AI_ECharacter
                Put FileHandle, , .AI_EUnknown
                If .CNDTSizeE <> 0 Then
                    Put FileHandle, , "CNDT"
                    Put FileHandle, , .CNDTSizeE
                    Put FileHandle, , .CNDTValueE
                    Put FileHandle, , buffer
                End If
            End With
        Next
    End If
    If .AI_F(LBound(.AI_F)).AI_FSize = 0 Then
    Else
        For i = LBound(.AI_F) To UBound(.AI_F)
            With .AI_F(i)
                Put FileHandle, , "AI_F"
                Put FileHandle, , .AI_FSize
                Put FileHandle, , .AI_FCoordX
                Put FileHandle, , .AI_FCoordY
                Put FileHandle, , .AI_FCoordZ
                Put FileHandle, , .AI_FDuration
                Put FileHandle, , .AI_FCharacter
                Put FileHandle, , .AI_FUnknown
                If .CNDTSizeF <> 0 Then
                    Put FileHandle, , "CNDT"
                    Put FileHandle, , .CNDTSizeF
                    Put FileHandle, , .CNDTValueF
                    Put FileHandle, , buffer
                End If
            End With
        Next
    End If
    If .AI_A(LBound(.AI_A)).AI_ASize = 0 Then
    Else
        For i = LBound(.AI_A) To UBound(.AI_A)
            With .AI_A(i)
                Put FileHandle, , "AI_A"
                Put FileHandle, , .AI_ASize
                Put FileHandle, , .AI_ATarget
                Put FileHandle, , .AI_AUnknown
            End With
        Next
    End If
End With

End Function

Public Function WriteCREA(ByVal FileHandle As Integer, ByRef Record As ES_CREA)

Dim buffer As Byte
Dim i As Long
Dim l As Long

With Record
    Put FileHandle, , "CREA"
    Put FileHandle, , .Size
    Put FileHandle, , .UnknownHeader1
    Put FileHandle, , .Flag
    Put FileHandle, , "NAME"
    Put FileHandle, , .NAMESize
    Put FileHandle, , .NAMEValue
    Put FileHandle, , buffer
    If .Flag.Flag_01 >= 20 Then
        Put FileHandle, , "DELE"
        Put FileHandle, , CLng(4)
        Put FileHandle, , CLng(0)
        Exit Function
    End If
    If .MODLSize <> 0 Then
        Put FileHandle, , "MODL"
        Put FileHandle, , .MODLSize
        Put FileHandle, , .MODLValue
        Put FileHandle, , buffer
    End If
    If .CNAMSize <> 0 Then
        Put FileHandle, , "CNAM"
        Put FileHandle, , .CNAMSize
        Put FileHandle, , .CNAMValue
        Put FileHandle, , buffer
    End If
    If .FNAMSize <> 0 Then
        Put FileHandle, , "FNAM"
        Put FileHandle, , .FNAMSize
        Put FileHandle, , .FNAMValue
        Put FileHandle, , buffer
    End If
    If .SCRISize <> 0 Then
        Put FileHandle, , "SCRI"
        Put FileHandle, , .SCRISize
        Put FileHandle, , .SCRIValue
        Put FileHandle, , buffer
    End If
    Put FileHandle, , "NPDT"
    Put FileHandle, , .NPDTData
    Put FileHandle, , "FLAG"
    Put FileHandle, , .FLAGSize
    Put FileHandle, , .FLAGGeneral
    Put FileHandle, , .FLAGBlood
    Put FileHandle, , buffer
    Put FileHandle, , buffer
    If .INDXSize <> 0 Then
        Put FileHandle, , "INDX"
        Put FileHandle, , .INDXSize
        Put FileHandle, , .INDXValue
    End If
    If .XSCLSize <> 0 Then
        Put FileHandle, , "XSCL"
        Put FileHandle, , .XSCLSize
        Put FileHandle, , .XSCLValue
    End If
    On Error Resume Next
    If .NPCO(LBound(.NPCO)).NPCOSize = 0 Then
    Else
        For i = LBound(.NPCO) To UBound(.NPCO)
            Put FileHandle, , "NPCO"
            Put FileHandle, , .NPCO(i).NPCOSize
            Put FileHandle, , .NPCO(i).NPCOCount
            Put FileHandle, , .NPCO(i).NPCOItem
        Next
    End If
    On Error Resume Next
    If .NPCS(LBound(.NPCS)).NPCSSize = 0 Then
    Else
        For i = LBound(.NPCS) To UBound(.NPCS)
            Put FileHandle, , "NPCS"
            Put FileHandle, , .NPCS(i).NPCSSize
            Put FileHandle, , .NPCS(i).NPCSItem
        Next
    End If
    Put FileHandle, , "AIDT"
    Put FileHandle, , .AIDTSize
    Put FileHandle, , .AIDTHello
    Put FileHandle, , .AIDTUnknown1
    Put FileHandle, , .AIDTFight
    Put FileHandle, , .AIDTFlee
    Put FileHandle, , .AIDTAlarm
    Put FileHandle, , .AIDTUnknown2
    Put FileHandle, , .AIDTUnknown3
    Put FileHandle, , .AIDTUnknown4
    Put FileHandle, , .AIDTFlag
    For i = 0 To 3
        If .DODT(i).DODTSize <> 0 Then
            With .DODT(i)
                Put FileHandle, , "DODT"
                Put FileHandle, , .DODTSize
                Put FileHandle, , .DODTPosX
                Put FileHandle, , .DODTPosY
                Put FileHandle, , .DODTPosZ
                Put FileHandle, , .DODTRotX
                Put FileHandle, , .DODTRotY
                Put FileHandle, , .DODTRotZ
                If .DNAMSize <> 0 Then
                    Put FileHandle, , "DNAM"
                    Put FileHandle, , .DNAMSize
                    Put FileHandle, , .DNAMValue
                    Put FileHandle, , buffer
                End If
            End With
        End If
    Next
    If .AI_W(LBound(.AI_W)).AI_WSize = 0 Then
    Else
        For i = LBound(.AI_W) To UBound(.AI_W)
            With .AI_W(i)
                Put FileHandle, , "AI_W"
                Put FileHandle, , .AI_WSize
                Put FileHandle, , .AI_WDistance
                Put FileHandle, , .AI_WDuration
                Put FileHandle, , .AI_WTime
                For l = 0 To 7
                    Put FileHandle, , .AI_WIdles(l)
                Next
                Put FileHandle, , .AI_WUnknown
            End With
        Next
    End If
    If .AI_T(LBound(.AI_T)).AI_TSize = 0 Then
    Else
        For i = LBound(.AI_T) To UBound(.AI_T)
            With .AI_T(i)
                Put FileHandle, , "AI_T"
                Put FileHandle, , .AI_TSize
                Put FileHandle, , .AI_TCoordX
                Put FileHandle, , .AI_TCoordY
                Put FileHandle, , .AI_TCoordZ
                Put FileHandle, , .AI_TUnknown
            End With
        Next
    End If
    If .AI_E(LBound(.AI_E)).AI_ESize = 0 Then
    Else
        For i = LBound(.AI_E) To UBound(.AI_E)
            With .AI_E(i)
                Put FileHandle, , "AI_E"
                Put FileHandle, , .AI_ESize
                Put FileHandle, , .AI_ECoordX
                Put FileHandle, , .AI_ECoordY
                Put FileHandle, , .AI_ECoordZ
                Put FileHandle, , .AI_EDuration
                Put FileHandle, , .AI_ECharacter
                Put FileHandle, , .AI_EUnknown
                If .CNDTSizeE <> 0 Then
                    Put FileHandle, , "CNDT"
                    Put FileHandle, , .CNDTSizeE
                    Put FileHandle, , .CNDTValueE
                    Put FileHandle, , buffer
                End If
            End With
        Next
    End If
    If .AI_F(LBound(.AI_F)).AI_FSize = 0 Then
    Else
        For i = LBound(.AI_F) To UBound(.AI_F)
            With .AI_F(i)
                Put FileHandle, , "AI_F"
                Put FileHandle, , .AI_FSize
                Put FileHandle, , .AI_FCoordX
                Put FileHandle, , .AI_FCoordY
                Put FileHandle, , .AI_FCoordZ
                Put FileHandle, , .AI_FDuration
                Put FileHandle, , .AI_FCharacter
                Put FileHandle, , .AI_FUnknown
                If .CNDTSizeF <> 0 Then
                    Put FileHandle, , "CNDT"
                    Put FileHandle, , .CNDTSizeF
                    Put FileHandle, , .CNDTValueF
                    Put FileHandle, , buffer
                End If
            End With
        Next
    End If
    If .AI_A(LBound(.AI_A)).AI_ASize = 0 Then
    Else
        For i = LBound(.AI_A) To UBound(.AI_A)
            With .AI_A(i)
                Put FileHandle, , "AI_A"
                Put FileHandle, , .AI_ASize
                Put FileHandle, , .AI_ATarget
                Put FileHandle, , .AI_AUnknown
            End With
        Next
    End If
End With

End Function

Public Function WriteCELL(ByVal FileHandle As Integer, ByRef Record As ES_CELL)

Dim buffer As Byte
Dim i As Long, l As Long, j As Long

With Record
    Put FileHandle, , "CELL"
    Put FileHandle, , .Size
    Put FileHandle, , .UnknownHeader1
    Put FileHandle, , .Flag
    Put FileHandle, , "NAME"
    Put FileHandle, , .NAMESize
    Put FileHandle, , .NAMEValue
    Put FileHandle, , buffer
    If .Deleted = 1 Then
        Put FileHandle, , "DELE"
        Put FileHandle, , CLng(4)
        Put FileHandle, , CLng(0)
    End If
    Put FileHandle, , "DATA"
    Put FileHandle, , .DATASize
    Put FileHandle, , .DATAFlag
    Put FileHandle, , .DATAGridX
    Put FileHandle, , .DATAGridY
    If .RGNNSize <> 0 Then
        Put FileHandle, , "RGNN"
        Put FileHandle, , .RGNNSize
        Put FileHandle, , .RGNNValue
        Put FileHandle, , buffer
    End If
    If .NAM5Size <> 0 Then
        Put FileHandle, , "NAM5"
        Put FileHandle, , .NAM5Size
        Put FileHandle, , .NAM5Red
        Put FileHandle, , .NAM5Green
        Put FileHandle, , .NAM5Blue
        Put FileHandle, , buffer
    End If
    If .NAM8Size <> 0 Then
        Put FileHandle, , "NAM8"
        Put FileHandle, , .NAM8Size
        Put FileHandle, , .NAM8Value
    End If
    If .MPCDSize <> 0 Then
        Put FileHandle, , "MPCD"
        Put FileHandle, , .MPCDSize
        Put FileHandle, , .MPCDValueX
        Put FileHandle, , .MPCDValueY
        Put FileHandle, , .MPCDValueZ
    End If
    If .WHGTSize <> 0 Then
        Put FileHandle, , "WHGT"
        Put FileHandle, , .WHGTSize
        Put FileHandle, , .WHGTValue
    End If
    If .AMBISize <> 0 Then
        Put FileHandle, , "AMBI"
        Put FileHandle, , .AMBISize
        Put FileHandle, , .AMBIRed
        Put FileHandle, , .AMBIGreen
        Put FileHandle, , .AMBIBlue
        Put FileHandle, , buffer
        Put FileHandle, , .AMBISunRed
        Put FileHandle, , .AMBISunGreen
        Put FileHandle, , .AMBISunBlue
        Put FileHandle, , buffer
        Put FileHandle, , .AMBIFogRed
        Put FileHandle, , .AMBIFogGreen
        Put FileHandle, , .AMBIFogBlue
        Put FileHandle, , buffer
        Put FileHandle, , .AMBIFogDensity
    End If
    If .INTVSize <> 0 Then
        Put FileHandle, , "INTV"
        Put FileHandle, , .INTVSize
        Put FileHandle, , .INTVValue
    End If
    On Error Resume Next
    If .References(LBound(.References)).FRMRSize = 0 Then
    Else
        For i = LBound(.References) To UBound(.References)
            With .References(i)
                If .Persistant = 1 Then
                    If .MVRFSize = 0 Then
                        Put FileHandle, , "FRMR"
                        Put FileHandle, , .FRMRSize
                        Put FileHandle, , .FRMRObjIndex
                        Put FileHandle, , .FRMRModIndex
                    Else
                        Put FileHandle, , "MVRF"
                        Put FileHandle, , .MVRFSize
                        Put FileHandle, , .MVRFObjectIndex
                        Put FileHandle, , .MVRFModIndex
                        If .CNDTSize > 0 Then
                            Put FileHandle, , "CNDT"
                            Put FileHandle, , .CNDTSize
                            Put FileHandle, , .CNDTGridX
                            Put FileHandle, , .CNDTGridY
                        ElseIf .MVRFCNAMSize > 0 Then
                            Put FileHandle, , "CNAM"
                            Put FileHandle, , .MVRFCNAMSize
                            Put FileHandle, , .MVRFCNAMValue
                        Else
                            MsgBox "Error while writing moved reference."
                            Exit Function
                        End If
                        Put FileHandle, , "FRMR"
                        Put FileHandle, , .FRMRSize
                        Put FileHandle, , .FRMRObjIndex
                        Put FileHandle, , .FRMRModIndex
                    End If
                    Put FileHandle, , "NAME"
                    Put FileHandle, , .NAMESize
                    Put FileHandle, , .NAMEValue
                    Put FileHandle, , buffer
                    If .XSCLSize <> 0 Then
                        Put FileHandle, , "XSCL"
                        Put FileHandle, , .XSCLSize
                        Put FileHandle, , .XSCLValue
                    End If
                    If .DODTSize <> 0 Then
                        Put FileHandle, , "DODT"
                        Put FileHandle, , .DODTSize
                        Put FileHandle, , .DODTPosX
                        Put FileHandle, , .DODTPosY
                        Put FileHandle, , .DODTPosZ
                        Put FileHandle, , .DODTRotX
                        Put FileHandle, , .DODTRotY
                        Put FileHandle, , .DODTRotZ
                    End If
                    If .DNAMSize <> 0 Then
                        Put FileHandle, , "DNAM"
                        Put FileHandle, , .DNAMSize
                        Put FileHandle, , .DNAMValue
                        Put FileHandle, , buffer
                    End If
                    If .FLTVSize <> 0 Then
                        Put FileHandle, , "FLTV"
                        Put FileHandle, , .FLTVSize
                        Put FileHandle, , .FLTVValue
                    End If
                    If .KNAMSize <> 0 Then
                        Put FileHandle, , "KNAM"
                        Put FileHandle, , .KNAMSize
                        Put FileHandle, , .KNAMValue
                        Put FileHandle, , buffer
                    End If
                    If .TNAMSize <> 0 Then
                        Put FileHandle, , "TNAM"
                        Put FileHandle, , .TNAMSize
                        Put FileHandle, , .TNAMValue
                        Put FileHandle, , buffer
                    End If
                    If .ANAMSize <> 0 Then
                        Put FileHandle, , "ANAM"
                        Put FileHandle, , .ANAMSize
                        Put FileHandle, , .ANAMValue
                        Put FileHandle, , buffer
                    End If
                    If .CNAMSize <> 0 Then
                        Put FileHandle, , "CNAM"
                        Put FileHandle, , .CNAMSize
                        Put FileHandle, , .CNAMValue
                        Put FileHandle, , buffer
                    End If
                    If .UNAMSize <> 0 Then
                        Put FileHandle, , "UNAM"
                        Put FileHandle, , .UNAMSize
                        Put FileHandle, , .UNAMValue
                    End If
                    If .BNAMSize <> 0 Then
                        Put FileHandle, , "BNAM"
                        Put FileHandle, , .BNAMSize
                        Put FileHandle, , .BNAMValue
                        Put FileHandle, , buffer
                    End If
                    If .XCHGSize <> 0 Then
                        Put FileHandle, , "XCHG"
                        Put FileHandle, , .XCHGSize
                        Put FileHandle, , .XCHGValue
                    End If
                    If .INTVSize <> 0 Then
                        Put FileHandle, , "INTV"
                        Put FileHandle, , .INTVSize
                        Put FileHandle, , .INTVValue
                    End If
                    If .NAM9Size <> 0 Then
                        Put FileHandle, , "NAM9"
                        Put FileHandle, , .NAM9Size
                        Put FileHandle, , .NAM9Value
                    End If
                    If .INDXSize <> 0 Then
                        Put FileHandle, , "INDX"
                        Put FileHandle, , .INDXSize
                        Put FileHandle, , .INDXValue
                    End If
                    If .XSOLSize <> 0 Then
                        Put FileHandle, , "XSOL"
                        Put FileHandle, , .XSOLSize
                        Put FileHandle, , .XSOLValue
                        Put FileHandle, , buffer
                    End If
                    If .Disabled Then
                        Put FileHandle, , "ZNAM"
                        Put FileHandle, , CLng(1)
                        Put FileHandle, , buffer
                    End If
                    For l = LBound(.RefUnknown) To UBound(.RefUnknown) - 1
                        If .RefUnknown(l) <> "" Then
                            Put FileHandle, , Left(.RefUnknown(l), 4)
                            Put FileHandle, , (Len(.RefUnknown(l)) - 8)
                            Put FileHandle, , Right(.RefUnknown(l), Len(.RefUnknown(l)) - 4)
                        End If
                    Next
                    If .DATASize <> 0 Then
                        Put FileHandle, , "DATA"
                        Put FileHandle, , .DATASize
                        Put FileHandle, , .DATAPosX
                        Put FileHandle, , .DATAPosY
                        Put FileHandle, , .DATAPosZ
                        Put FileHandle, , .DATARotX
                        Put FileHandle, , .DATARotY
                        Put FileHandle, , .DATARotZ
                    End If
                    If .DATA2Size <> 0 Then
                        Put FileHandle, , "DATA"
                        Put FileHandle, , .DATA2Size
                        Put FileHandle, , .DATA2PosX
                        Put FileHandle, , .DATA2PosY
                        Put FileHandle, , .DATA2PosZ
                        Put FileHandle, , .DATA2RotX
                        Put FileHandle, , .DATA2RotY
                        Put FileHandle, , .DATA2RotZ
                    End If
                    If .Deleted = 1 Then
                        Put FileHandle, , "DELE"
                        Put FileHandle, , CLng(4)
                        Put FileHandle, , CByte(100)
                        Put FileHandle, , CByte(44)
                        Put FileHandle, , CByte(72)
                        Put FileHandle, , CByte(0)
                        GoTo FinishedRef1
                    End If
                End If
            End With
FinishedRef1:
        Next
    End If
    If .NAM0Size <> 0 Then
        Put FileHandle, , "NAM0"
        Put FileHandle, , .NAM0Size
        Put FileHandle, , .NAM0Value
    End If
    If .References(LBound(.References)).FRMRSize = 0 Then
    Else
        For i = LBound(.References) To UBound(.References)
            With .References(i)
                If .Persistant = 0 Then
                    If .MVRFSize = 0 Then
                        Put FileHandle, , "FRMR"
                        Put FileHandle, , .FRMRSize
                        Put FileHandle, , .FRMRObjIndex
                        Put FileHandle, , .FRMRModIndex
                    Else
                        Put FileHandle, , "MVRF"
                        Put FileHandle, , .MVRFSize
                        Put FileHandle, , .MVRFObjectIndex
                        Put FileHandle, , .MVRFModIndex
                        If .CNDTSize > 0 Then
                            Put FileHandle, , "CNDT"
                            Put FileHandle, , .CNDTSize
                            Put FileHandle, , .CNDTGridX
                            Put FileHandle, , .CNDTGridY
                        ElseIf .MVRFCNAMSize > 0 Then
                            Put FileHandle, , "CNAM"
                            Put FileHandle, , .MVRFCNAMSize
                            Put FileHandle, , .MVRFCNAMValue
                        Else
                            MsgBox "Error while writing moved reference."
                            Exit Function
                        End If
                        Put FileHandle, , "FRMR"
                        Put FileHandle, , .FRMRSize
                        Put FileHandle, , .FRMRObjIndex
                        Put FileHandle, , .FRMRModIndex
                    End If
                    Put FileHandle, , "NAME"
                    Put FileHandle, , .NAMESize
                    Put FileHandle, , .NAMEValue
                    Put FileHandle, , buffer
                    If .XSCLSize <> 0 Then
                        Put FileHandle, , "XSCL"
                        Put FileHandle, , .XSCLSize
                        Put FileHandle, , .XSCLValue
                    End If
                    If .DODTSize <> 0 Then
                        Put FileHandle, , "DODT"
                        Put FileHandle, , .DODTSize
                        Put FileHandle, , .DODTPosX
                        Put FileHandle, , .DODTPosY
                        Put FileHandle, , .DODTPosZ
                        Put FileHandle, , .DODTRotX
                        Put FileHandle, , .DODTRotY
                        Put FileHandle, , .DODTRotZ
                    End If
                    If .DNAMSize <> 0 Then
                        Put FileHandle, , "DNAM"
                        Put FileHandle, , .DNAMSize
                        Put FileHandle, , .DNAMValue
                        Put FileHandle, , buffer
                    End If
                    If .FLTVSize <> 0 Then
                        Put FileHandle, , "FLTV"
                        Put FileHandle, , .FLTVSize
                        Put FileHandle, , .FLTVValue
                    End If
                    If .KNAMSize <> 0 Then
                        Put FileHandle, , "KNAM"
                        Put FileHandle, , .KNAMSize
                        Put FileHandle, , .KNAMValue
                        Put FileHandle, , buffer
                    End If
                    If .TNAMSize <> 0 Then
                        Put FileHandle, , "TNAM"
                        Put FileHandle, , .TNAMSize
                        Put FileHandle, , .TNAMValue
                        Put FileHandle, , buffer
                    End If
                    If .ANAMSize <> 0 Then
                        Put FileHandle, , "ANAM"
                        Put FileHandle, , .ANAMSize
                        Put FileHandle, , .ANAMValue
                        Put FileHandle, , buffer
                    End If
                    If .CNAMSize <> 0 Then
                        Put FileHandle, , "CNAM"
                        Put FileHandle, , .CNAMSize
                        Put FileHandle, , .CNAMValue
                        Put FileHandle, , buffer
                    End If
                    If .UNAMSize <> 0 Then
                        Put FileHandle, , "UNAM"
                        Put FileHandle, , .UNAMSize
                        Put FileHandle, , .UNAMValue
                    End If
                    If .BNAMSize <> 0 Then
                        Put FileHandle, , "BNAM"
                        Put FileHandle, , .BNAMSize
                        Put FileHandle, , .BNAMValue
                        Put FileHandle, , buffer
                    End If
                    If .XCHGSize <> 0 Then
                        Put FileHandle, , "XCHG"
                        Put FileHandle, , .XCHGSize
                        Put FileHandle, , .XCHGValue
                    End If
                    If .INTVSize <> 0 Then
                        Put FileHandle, , "INTV"
                        Put FileHandle, , .INTVSize
                        Put FileHandle, , .INTVValue
                    End If
                    If .NAM9Size <> 0 Then
                        Put FileHandle, , "NAM9"
                        Put FileHandle, , .NAM9Size
                        Put FileHandle, , .NAM9Value
                    End If
                    If .INDXSize <> 0 Then
                        Put FileHandle, , "INDX"
                        Put FileHandle, , .INDXSize
                        Put FileHandle, , .INDXValue
                    End If
                    If .XSOLSize <> 0 Then
                        Put FileHandle, , "XSOL"
                        Put FileHandle, , .XSOLSize
                        Put FileHandle, , .XSOLValue
                        Put FileHandle, , buffer
                    End If
                    If .Disabled Then
                        Put FileHandle, , "ZNAM"
                        Put FileHandle, , CLng(1)
                        Put FileHandle, , buffer
                    End If
                    For l = LBound(.RefUnknown) To UBound(.RefUnknown) - 1
                        If .RefUnknown(l) <> "" Then
                            Put FileHandle, , Left(.RefUnknown(l), 4)
                            Put FileHandle, , (Len(.RefUnknown(l)) - 8)
                            Put FileHandle, , Right(.RefUnknown(l), Len(.RefUnknown(l)) - 4)
                        End If
                    Next
                    If .DATASize <> 0 Then
                        Put FileHandle, , "DATA"
                        Put FileHandle, , .DATASize
                        Put FileHandle, , .DATAPosX
                        Put FileHandle, , .DATAPosY
                        Put FileHandle, , .DATAPosZ
                        Put FileHandle, , .DATARotX
                        Put FileHandle, , .DATARotY
                        Put FileHandle, , .DATARotZ
                    End If
                    If .DATA2Size <> 0 Then
                        Put FileHandle, , "DATA"
                        Put FileHandle, , .DATA2Size
                        Put FileHandle, , .DATA2PosX
                        Put FileHandle, , .DATA2PosY
                        Put FileHandle, , .DATA2PosZ
                        Put FileHandle, , .DATA2RotX
                        Put FileHandle, , .DATA2RotY
                        Put FileHandle, , .DATA2RotZ
                    End If
                    If .Deleted = 1 Then
                        Put FileHandle, , "DELE"
                        Put FileHandle, , CLng(4)
                        Put FileHandle, , CByte(100)
                        Put FileHandle, , CByte(44)
                        Put FileHandle, , CByte(72)
                        Put FileHandle, , CByte(0)
                        GoTo FinishedRef2
                    End If
                End If
            End With
FinishedRef2:
        Next
    End If
End With

End Function

Public Function WriteDIAL(ByVal FileHandle As Integer, ByRef Record As ES_DIAL, ByRef ResponsesWritten As Long)

Dim buffer As Byte
Dim i As Long

With Record
    CurrentDIAL = .NAMEValue
    Put FileHandle, , "DIAL"
    Put FileHandle, , .Size
    Put FileHandle, , .UnknownHeader1
    Put FileHandle, , .Flag
    Put FileHandle, , "NAME"
    Put FileHandle, , .NAMESize
    Put FileHandle, , .NAMEValue
    Put FileHandle, , buffer
    Put FileHandle, , "DATA"
    Put FileHandle, , .DATASize
    If .DATASize = 4 Then
        Put FileHandle, , CLng(0)
    Else
        Put FileHandle, , .DATAType
    End If
    If .XIDXSize <> 0 Then
        Put FileHandle, , "XIDX"
        Put FileHandle, , .XIDXSize
        Put FileHandle, , .XIDXValue
    End If
    If .Flag.Flag_01 >= 20 Then
        Put FileHandle, , "DELE"
        Put FileHandle, , CLng(4)
        Put FileHandle, , CLng(0)
    End If
End With

On Error Resume Next
If LBound(INFO) <> 0 Then
Else
    For i = LBound(INFO) To UBound(INFO)
        If INFO(i).ParentDIAL = Record.NAMEValue Then
            Call WriteINFO(FileHandle, INFO(i))
            ResponsesWritten = ResponsesWritten + 1
        End If
    Next
End If

End Function

Public Function WriteINFO(ByVal FileHandle As Integer, ByRef Record As ES_INFO, Optional ByVal SaveGame As Boolean)

Dim buffer As Byte
Dim i As Long

With Record
    Put FileHandle, , "INFO"
    Put FileHandle, , .Size
    Put FileHandle, , .UnknownHeader1
    Put FileHandle, , .Flag
    If .Flag.Flag_01 >= 20 Then
        Put FileHandle, , "INAM"
        Put FileHandle, , .INAMSize
        Put FileHandle, , .INAMValue
        Put FileHandle, , buffer
        If .PNAMSize > 0 Then
            Put FileHandle, , "PNAM"
            Put FileHandle, , .PNAMSize
            Put FileHandle, , .PNAMValue
            Put FileHandle, , buffer
        End If
        If .NNAMSize > 0 Then
            Put FileHandle, , "NNAM"
            Put FileHandle, , .NNAMSize
            Put FileHandle, , .NNAMValue
            Put FileHandle, , buffer
        End If
        If .NAMESize <> 0 Then
            Put FileHandle, , "NAME"
            Put FileHandle, , .NAMESize
            Put FileHandle, , .NAMEValue
        End If
        Put FileHandle, , "DELE"
        Put FileHandle, , CLng(4)
        Put FileHandle, , CLng(0)
        Exit Function
    End If
    Put FileHandle, , "INAM"
    Put FileHandle, , .INAMSize
    Put FileHandle, , .INAMValue
    Put FileHandle, , buffer
    If SaveGame = True Then
        Put FileHandle, , "ACDT"
        Put FileHandle, , .ACDTSize
        Put FileHandle, , .ACDTValue
        Put FileHandle, , buffer
        Exit Function
    End If
    If .XIDXSize > 0 Then
        Put FileHandle, , "XIDX"
        Put FileHandle, , .XIDXSize
        Put FileHandle, , .XIDXValue
    End If
    If .PNAMSize > 0 Then
        Put FileHandle, , "PNAM"
        Put FileHandle, , .PNAMSize
        Put FileHandle, , .PNAMValue
        Put FileHandle, , buffer
    End If
    If .NNAMSize > 0 Then
        Put FileHandle, , "NNAM"
        Put FileHandle, , .NNAMSize
        Put FileHandle, , .NNAMValue
        Put FileHandle, , buffer
    End If
    Put FileHandle, , "DATA"
    Put FileHandle, , .DATASize
    Put FileHandle, , .DATAType
    Put FileHandle, , .DATADisposition
    Put FileHandle, , .DATARank
    Put FileHandle, , .DATAGender
    Put FileHandle, , .DATAPCRank
    Put FileHandle, , .DATAUnknown
    If .ONAMSize <> 0 Then
        Put FileHandle, , "ONAM"
        Put FileHandle, , .ONAMSize
        Put FileHandle, , .ONAMValue
        Put FileHandle, , buffer
    End If
    If .RNAMSize <> 0 Then
        Put FileHandle, , "RNAM"
        Put FileHandle, , .RNAMSize
        Put FileHandle, , .RNAMValue
        Put FileHandle, , buffer
    End If
    If .CNAMSize <> 0 Then
        Put FileHandle, , "CNAM"
        Put FileHandle, , .CNAMSize
        Put FileHandle, , .CNAMValue
        Put FileHandle, , buffer
    End If
    If .FNAMSize <> 0 Then
        Put FileHandle, , "FNAM"
        Put FileHandle, , .FNAMSize
        Put FileHandle, , .FNAMValue
        Put FileHandle, , buffer
    End If
    If .ANAMSize <> 0 Then
        Put FileHandle, , "ANAM"
        Put FileHandle, , .ANAMSize
        Put FileHandle, , .ANAMValue
        Put FileHandle, , buffer
    End If
    If .DNAMSize <> 0 Then
        Put FileHandle, , "DNAM"
        Put FileHandle, , .DNAMSize
        Put FileHandle, , .DNAMValue
        Put FileHandle, , buffer
    End If
    If .SNAMSize <> 0 Then
        Put FileHandle, , "SNAM"
        Put FileHandle, , .SNAMSize
        Put FileHandle, , .SNAMValue
        Put FileHandle, , buffer
    End If
    If .NAMESize <> 0 Then
        Put FileHandle, , "NAME"
        Put FileHandle, , .NAMESize
        Put FileHandle, , .NAMEValue
    End If
    If .QSTNSize <> 0 Then
        Put FileHandle, , "QSTN"
        Put FileHandle, , .QSTNSize
        Put FileHandle, , .QSTNValue
    End If
    If .QSTFSize <> 0 Then
        Put FileHandle, , "QSTF"
        Put FileHandle, , .QSTFSize
        Put FileHandle, , .QSTFValue
    End If
    If .QSTRSize <> 0 Then
        Put FileHandle, , "QSTR"
        Put FileHandle, , .QSTRSize
        Put FileHandle, , .QSTRValue
    End If
    For i = LBound(.SCVR) To UBound(.SCVR)
        With .SCVR(i)
            If .SCVRSize <> 0 Then
                Put FileHandle, , "SCVR"
                Put FileHandle, , .SCVRSize
                Put FileHandle, , .SCVRIndex
                Put FileHandle, , .SCVRType
                Put FileHandle, , .SCVRFunction
                Put FileHandle, , .SCVROperator
                Put FileHandle, , .SCVRValue
                If .INTVSize <> 0 Then
                    Put FileHandle, , "INTV"
                    Put FileHandle, , .INTVSize
                    Put FileHandle, , .INTVValue
                ElseIf .FLTVSize <> 0 Then
                    Put FileHandle, , "FLTV"
                    Put FileHandle, , .FLTVSize
                    Put FileHandle, , .FLTVValue
                End If
            End If
        End With
    Next
    If .BNAMSize <> 0 Then
        Put FileHandle, , "BNAM"
        Put FileHandle, , .BNAMSize
        Put FileHandle, , .BNAMValue
    End If
End With

End Function

'***************************************************************************
'*                                                                         *
'*                          Main Write Function                            *
'*                                                                         *
'***************************************************************************

Public Function WriteFile(ByVal FileName As String, PBar As ProgressBar, ByVal RecordsCount As Long, Optional ByVal SkipUnknownData As Boolean) As Double

Dim i As Long, RecordsWritten As Long, xTime As Long
Dim FileHandle As Integer

If UCase(Right$(FileName, 3)) = "ESS" Then
    If MsgBox("Writing ESS files is not fully supported right now. Doing so is very likely to produce an unusable file. Are you sure you want to continue?", vbYesNo) = vbNo Then
        Exit Function
        WriteFile = -1
    End If
End If

xTime = GetTickCount

FileHandle = FreeFile

If Dir$(FileName) <> "" Then
    Kill FileName
End If

PBar.Min = 0
PBar.Max = 1

Open FileName For Binary As FileHandle

On Error Resume Next
If LBound(TES3) <> 0 Then
Else
    For i = LBound(TES3) To UBound(TES3)
        If UCase(Right$(FileName, 3)) = "ESM" Then
                Call WriteTES3(FileHandle, TES3(i), RecordsCount, 1)
        ElseIf UCase(Right$(FileName, 3)) = "ESS" Then
                xTime = GetTickCount
                Call WriteTES3(FileHandle, TES3(i), RecordsCount, 32)
        Else
                Call WriteTES3(FileHandle, TES3(i), RecordsCount, 0)
        End If
        RecordsWritten = RecordsWritten + 1
    Next
End If
PBar.Value = Seek(FileHandle) / LOF(FileHandle)
If LBound(GMST) <> 0 Then
Else
    For i = LBound(GMST) To UBound(GMST)
        Call WriteGMST(FileHandle, GMST(i))
        RecordsWritten = RecordsWritten + 1
    Next
End If
PBar.Value = Seek(FileHandle) / LOF(FileHandle)
If LBound(GLOB) <> 0 Then
Else
    For i = LBound(GLOB) To UBound(GLOB)
        Call WriteGLOB(FileHandle, GLOB(i))
        RecordsWritten = RecordsWritten + 1
    Next
End If
PBar.Value = Seek(FileHandle) / LOF(FileHandle)
If LBound(CLAS) <> 0 Then
Else
    For i = LBound(CLAS) To UBound(CLAS)
        Call WriteCLAS(FileHandle, CLAS(i))
        RecordsWritten = RecordsWritten + 1
    Next
End If
PBar.Value = Seek(FileHandle) / LOF(FileHandle)
If LBound(FACT) <> 0 Then
Else
    For i = LBound(FACT) To UBound(FACT)
        Call WriteFACT(FileHandle, FACT(i))
        RecordsWritten = RecordsWritten + 1
    Next
End If
PBar.Value = Seek(FileHandle) / LOF(FileHandle)
If LBound(RACE) <> 0 Then
Else
    For i = LBound(RACE) To UBound(RACE)
        Call WriteRACE(FileHandle, RACE(i))
        RecordsWritten = RecordsWritten + 1
    Next
End If
PBar.Value = Seek(FileHandle) / LOF(FileHandle)
If LBound(SOUN) <> 0 Then
Else
    For i = LBound(SOUN) To UBound(SOUN)
        Call WriteSOUN(FileHandle, SOUN(i))
        RecordsWritten = RecordsWritten + 1
    Next
End If
PBar.Value = Seek(FileHandle) / LOF(FileHandle)
If LBound(SKIL) <> 0 Then
Else
    For i = LBound(SKIL) To UBound(SKIL)
        Call WriteSKIL(FileHandle, SKIL(i))
        RecordsWritten = RecordsWritten + 1
    Next
End If
PBar.Value = Seek(FileHandle) / LOF(FileHandle)
If LBound(MGEF) <> 0 Then
Else
    For i = LBound(MGEF) To UBound(MGEF)
        Call WriteMGEF(FileHandle, MGEF(i))
        RecordsWritten = RecordsWritten + 1
    Next
End If
PBar.Value = Seek(FileHandle) / LOF(FileHandle)
If LBound(SCPT) <> 0 Then
Else
    For i = LBound(SCPT) To UBound(SCPT)
        If UCase(Right$(FileName, 3)) = "ESS" Then
            Call WriteSCPT(FileHandle, SCPT(i), False)
        Else
            Call WriteSCPT(FileHandle, SCPT(i), True)
        End If
        RecordsWritten = RecordsWritten + 1
    Next
End If
PBar.Value = Seek(FileHandle) / LOF(FileHandle)
If LBound(REGN) <> 0 Then
Else
    For i = LBound(REGN) To UBound(REGN)
        Call WriteREGN(FileHandle, REGN(i))
        RecordsWritten = RecordsWritten + 1
    Next
End If
PBar.Value = Seek(FileHandle) / LOF(FileHandle)
If LBound(BSGN) <> 0 Then
Else
    For i = LBound(BSGN) To UBound(BSGN)
        Call WriteBSGN(FileHandle, BSGN(i))
        RecordsWritten = RecordsWritten + 1
    Next
End If
PBar.Value = Seek(FileHandle) / LOF(FileHandle)
If LBound(LTEX) <> 0 Then
Else
    For i = LBound(LTEX) To UBound(LTEX)
        Call WriteLTEX(FileHandle, LTEX(i))
        RecordsWritten = RecordsWritten + 1
    Next
End If
PBar.Value = Seek(FileHandle) / LOF(FileHandle)
If LBound(STAT) <> 0 Then
Else
    For i = LBound(STAT) To UBound(STAT)
        Call WriteSTAT(FileHandle, STAT(i))
        RecordsWritten = RecordsWritten + 1
    Next
End If
PBar.Value = Seek(FileHandle) / LOF(FileHandle)
If LBound(DOOR) <> 0 Then
Else
    For i = LBound(DOOR) To UBound(DOOR)
        Call WriteDOOR(FileHandle, DOOR(i))
        RecordsWritten = RecordsWritten + 1
    Next
End If
PBar.Value = Seek(FileHandle) / LOF(FileHandle)
If LBound(MISC) <> 0 Then
Else
    For i = LBound(MISC) To UBound(MISC)
        Call WriteMISC(FileHandle, MISC(i))
        RecordsWritten = RecordsWritten + 1
    Next
End If
PBar.Value = Seek(FileHandle) / LOF(FileHandle)
If LBound(WEAP) <> 0 Then
Else
    For i = LBound(WEAP) To UBound(WEAP)
        Call WriteWEAP(FileHandle, WEAP(i))
        RecordsWritten = RecordsWritten + 1
    Next
End If
PBar.Value = Seek(FileHandle) / LOF(FileHandle)
If LBound(CONT) <> 0 Then
Else
    For i = LBound(CONT) To UBound(CONT)
        Call WriteCONT(FileHandle, CONT(i))
        RecordsWritten = RecordsWritten + 1
    Next
End If
PBar.Value = Seek(FileHandle) / LOF(FileHandle)
If LBound(SPEL) <> 0 Then
Else
    For i = LBound(SPEL) To UBound(SPEL)
        Call WriteSPEL(FileHandle, SPEL(i))
        RecordsWritten = RecordsWritten + 1
    Next
End If
PBar.Value = Seek(FileHandle) / LOF(FileHandle)
If LBound(ENCH) <> 0 Then
Else
    For i = LBound(ENCH) To UBound(ENCH)
        Call WriteENCH(FileHandle, ENCH(i))
        RecordsWritten = RecordsWritten + 1
    Next
End If
PBar.Value = Seek(FileHandle) / LOF(FileHandle)
If LBound(BODY) <> 0 Then
Else
    For i = LBound(BODY) To UBound(BODY)
        Call WriteBODY(FileHandle, BODY(i))
        RecordsWritten = RecordsWritten + 1
    Next
End If
PBar.Value = Seek(FileHandle) / LOF(FileHandle)
If LBound(LIGH) <> 0 Then
Else
    For i = LBound(LIGH) To UBound(LIGH)
        Call WriteLIGH(FileHandle, LIGH(i))
        RecordsWritten = RecordsWritten + 1
    Next
End If
PBar.Value = Seek(FileHandle) / LOF(FileHandle)
If LBound(ARMO) <> 0 Then
Else
    For i = LBound(ARMO) To UBound(ARMO)
        Call WriteARMO(FileHandle, ARMO(i))
        RecordsWritten = RecordsWritten + 1
    Next
End If
PBar.Value = Seek(FileHandle) / LOF(FileHandle)
If LBound(CLOT) <> 0 Then
Else
    For i = LBound(CLOT) To UBound(CLOT)
        Call WriteCLOT(FileHandle, CLOT(i))
        RecordsWritten = RecordsWritten + 1
    Next
End If
PBar.Value = Seek(FileHandle) / LOF(FileHandle)
If LBound(REPA) <> 0 Then
Else
    For i = LBound(REPA) To UBound(REPA)
        Call WriteREPA(FileHandle, REPA(i))
        RecordsWritten = RecordsWritten + 1
    Next
End If
PBar.Value = Seek(FileHandle) / LOF(FileHandle)
If LBound(ACTI) <> 0 Then
Else
    For i = LBound(ACTI) To UBound(ACTI)
        Call WriteACTI(FileHandle, ACTI(i))
        RecordsWritten = RecordsWritten + 1
    Next
End If
PBar.Value = Seek(FileHandle) / LOF(FileHandle)
If LBound(APPA) <> 0 Then
Else
    For i = LBound(APPA) To UBound(APPA)
        Call WriteAPPA(FileHandle, APPA(i))
        RecordsWritten = RecordsWritten + 1
    Next
End If
PBar.Value = Seek(FileHandle) / LOF(FileHandle)
If LBound(L_CK) <> 0 Then
Else
    For i = LBound(L_CK) To UBound(L_CK)
        Call WriteLOCK(FileHandle, L_CK(i))
        RecordsWritten = RecordsWritten + 1
    Next
End If
PBar.Value = Seek(FileHandle) / LOF(FileHandle)
If LBound(PROB) <> 0 Then
Else
    For i = LBound(PROB) To UBound(PROB)
        Call WritePROB(FileHandle, PROB(i))
        RecordsWritten = RecordsWritten + 1
    Next
End If
PBar.Value = Seek(FileHandle) / LOF(FileHandle)
If LBound(INGR) <> 0 Then
Else
    For i = LBound(INGR) To UBound(INGR)
        Call WriteINGR(FileHandle, INGR(i))
        RecordsWritten = RecordsWritten + 1
    Next
End If
PBar.Value = Seek(FileHandle) / LOF(FileHandle)
If LBound(BOOK) <> 0 Then
Else
    For i = LBound(BOOK) To UBound(BOOK)
        Call WriteBOOK(FileHandle, BOOK(i))
        RecordsWritten = RecordsWritten + 1
    Next
End If
PBar.Value = Seek(FileHandle) / LOF(FileHandle)
If LBound(ALCH) <> 0 Then
Else
    For i = LBound(ALCH) To UBound(ALCH)
        Call WriteALCH(FileHandle, ALCH(i))
        RecordsWritten = RecordsWritten + 1
    Next
End If
PBar.Value = Seek(FileHandle) / LOF(FileHandle)
If LBound(LEVI) <> 0 Then
Else
    For i = LBound(LEVI) To UBound(LEVI)
        Call WriteLEVI(FileHandle, LEVI(i))
        RecordsWritten = RecordsWritten + 1
    Next
End If
PBar.Value = Seek(FileHandle) / LOF(FileHandle)
If LBound(LEVC) <> 0 Then
Else
    For i = LBound(LEVC) To UBound(LEVC)
        Call WriteLEVC(FileHandle, LEVC(i))
        RecordsWritten = RecordsWritten + 1
    Next
End If
PBar.Value = Seek(FileHandle) / LOF(FileHandle)
If LBound(SNDG) <> 0 Then
Else
    For i = LBound(SNDG) To UBound(SNDG)
        Call WriteSNDG(FileHandle, SNDG(i))
        RecordsWritten = RecordsWritten + 1
    Next
End If
PBar.Value = Seek(FileHandle) / LOF(FileHandle)
If LBound(SSCR) <> 0 Then
Else
    For i = LBound(SSCR) To UBound(SSCR)
        Call WriteSSCR(FileHandle, SSCR(i))
        RecordsWritten = RecordsWritten + 1
    Next
End If
PBar.Value = Seek(FileHandle) / LOF(FileHandle)
If LBound(NPC_) <> 0 Then
Else
    For i = LBound(NPC_) To UBound(NPC_)
        Call WriteNPC_(FileHandle, NPC_(i))
        RecordsWritten = RecordsWritten + 1
    Next
End If
PBar.Value = Seek(FileHandle) / LOF(FileHandle)
If LBound(CREA) <> 0 Then
Else
    For i = LBound(CREA) To UBound(CREA)
        Call WriteCREA(FileHandle, CREA(i))
        RecordsWritten = RecordsWritten + 1
    Next
End If
PBar.Value = Seek(FileHandle) / LOF(FileHandle)
If LBound(CELL) <> 0 Then
Else
    For i = LBound(CELL) To UBound(CELL)
        PBar.Value = Seek(FileHandle) / LOF(FileHandle)
        Call WriteCELL(FileHandle, CELL(i))
        RecordsWritten = RecordsWritten + 1
    Next
End If
PBar.Value = Seek(FileHandle) / LOF(FileHandle)
If LBound(LAND) <> 0 Then
Else
    For i = LBound(LAND) To UBound(LAND)
        PBar.Value = Seek(FileHandle) / LOF(FileHandle)
        Call WriteUnknown(FileHandle, LAND(i))
        RecordsWritten = RecordsWritten + 1
    Next
End If
PBar.Value = Seek(FileHandle) / LOF(FileHandle)
If LBound(PGRD) <> 0 Then
Else
    For i = LBound(PGRD) To UBound(PGRD)
        Call WritePGRD(FileHandle, PGRD(i))
        RecordsWritten = RecordsWritten + 1
    Next
End If
PBar.Value = Seek(FileHandle) / LOF(FileHandle)
If LBound(DIAL) <> 0 Then
Else
    For i = LBound(DIAL) To UBound(DIAL)
        PBar.Value = Seek(FileHandle) / LOF(FileHandle)
        Call WriteDIAL(FileHandle, DIAL(i), RecordsWritten)
        RecordsWritten = RecordsWritten + 1
    Next
End If
PBar.Value = Seek(FileHandle) / LOF(FileHandle)
If LBound(CNTC) <> 0 Then
Else
    For i = LBound(CNTC) To UBound(CNTC)
        Call WriteUnknown(FileHandle, CNTC(i))
        RecordsWritten = RecordsWritten + 1
    Next
End If
PBar.Value = Seek(FileHandle) / LOF(FileHandle)
If LBound(CREC) <> 0 Then
Else
    For i = LBound(CREC) To UBound(CREC)
        Call WriteUnknown(FileHandle, CREC(i))
        RecordsWritten = RecordsWritten + 1
    Next
End If
PBar.Value = Seek(FileHandle) / LOF(FileHandle)
If LBound(FMAP) <> 0 Then
Else
    For i = LBound(FMAP) To UBound(FMAP)
        Call WriteUnknown(FileHandle, FMAP(i))
        RecordsWritten = RecordsWritten + 1
    Next
End If
PBar.Value = Seek(FileHandle) / LOF(FileHandle)
If LBound(GAME) <> 0 Then
Else
    For i = LBound(GAME) To UBound(GAME)
        Call WriteUnknown(FileHandle, GAME(i))
        RecordsWritten = RecordsWritten + 1
    Next
End If
PBar.Value = Seek(FileHandle) / LOF(FileHandle)
If LBound(JOUR) <> 0 Then
Else
    For i = LBound(JOUR) To UBound(JOUR)
        Call WriteUnknown(FileHandle, JOUR(i))
        RecordsWritten = RecordsWritten + 1
    Next
End If
PBar.Value = Seek(FileHandle) / LOF(FileHandle)
If LBound(KLST) <> 0 Then
Else
    For i = LBound(KLST) To UBound(KLST)
        Call WriteUnknown(FileHandle, KLST(i))
        RecordsWritten = RecordsWritten + 1
    Next
End If
PBar.Value = Seek(FileHandle) / LOF(FileHandle)
If LBound(NPCC) <> 0 Then
Else
    For i = LBound(NPCC) To UBound(NPCC)
        Call WriteUnknown(FileHandle, NPCC(i))
        RecordsWritten = RecordsWritten + 1
    Next
End If
PBar.Value = Seek(FileHandle) / LOF(FileHandle)
If LBound(PCDT) <> 0 Then
Else
    For i = LBound(PCDT) To UBound(PCDT)
        Call WriteUnknown(FileHandle, PCDT(i))
        RecordsWritten = RecordsWritten + 1
    Next
End If
PBar.Value = Seek(FileHandle) / LOF(FileHandle)
If LBound(QUES) <> 0 Then
Else
    For i = LBound(QUES) To UBound(QUES)
        Call WriteUnknown(FileHandle, QUES(i))
        RecordsWritten = RecordsWritten + 1
    Next
End If
PBar.Value = Seek(FileHandle) / LOF(FileHandle)
If LBound(REFR) <> 0 Then
Else
    For i = LBound(REFR) To UBound(REFR)
        Call WriteUnknown(FileHandle, REFR(i))
        RecordsWritten = RecordsWritten + 1
    Next
End If
PBar.Value = Seek(FileHandle) / LOF(FileHandle)
If LBound(SPLM) <> 0 Then
Else
    For i = LBound(SPLM) To UBound(SPLM)
        Call WriteUnknown(FileHandle, SPLM(i))
        RecordsWritten = RecordsWritten + 1
    Next
End If
PBar.Value = Seek(FileHandle) / LOF(FileHandle)
If LBound(STLN) <> 0 Then
Else
    For i = LBound(STLN) To UBound(STLN)
        Call WriteUnknown(FileHandle, STLN(i))
        RecordsWritten = RecordsWritten + 1
    Next
End If
PBar.Value = Seek(FileHandle) / LOF(FileHandle)
If LBound(Unknown) <> 0 Then
Else
    For i = LBound(Unknown) To UBound(Unknown)
        PBar.Value = Seek(FileHandle) / LOF(FileHandle)
        Call WriteUnknown(FileHandle, Unknown(i))
        RecordsWritten = RecordsWritten + 1
    Next
End If
Close FileHandle

WriteFile = GetTickCount - xTime

End Function
